""" Cisco_IOS_XR_invmgr_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR invmgr package operational data.

This module contains definitions
for the following management objects\:
  inventory\: Inventory information

Copyright (c) 2013\-2018 by Cisco Systems, Inc.
All rights reserved.

"""
import sys
from collections import OrderedDict

from ydk.types import Entity as _Entity_
from ydk.types import EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class CardResetReason(Enum):
    """
    CardResetReason (Enum Class)

    Card reset reason

    .. data:: reset_unknown = 1

    	reset unknown

    .. data:: power_up = 2

    	power up

    .. data:: parity_error = 3

    	parity error

    .. data:: clear_config_reset = 4

    	clear config reset

    .. data:: manual_reset = 5

    	manual reset

    .. data:: watch_dog_timeout_reset = 6

    	watch dog timeout reset

    .. data:: resource_overflow_reset = 7

    	resource overflow reset

    .. data:: missing_task_reset = 8

    	missing task reset

    .. data:: low_voltage_reset = 9

    	low voltage reset

    .. data:: controller_reset = 10

    	controller reset

    .. data:: system_reset = 11

    	system reset

    .. data:: switchover_reset = 12

    	switchover reset

    .. data:: upgrade_reset = 13

    	upgrade reset

    .. data:: downgrade_reset = 14

    	downgrade reset

    .. data:: cache_error_reset = 15

    	cache error reset

    .. data:: device_driver_reset = 16

    	device driver reset

    .. data:: software_exception_reset = 17

    	software exception reset

    .. data:: restore_config_reset = 18

    	restore config reset

    .. data:: abort_rev_reset = 19

    	abort rev reset

    .. data:: burn_boot_reset = 20

    	burn boot reset

    .. data:: standby_cd_healthier_reset = 21

    	standby cd healthier reset

    .. data:: non_native_config_clear_reset = 22

    	non native config clear reset

    .. data:: memory_protection_error_reset = 23

    	memory protection error reset

    .. data:: card_reset_reason_max = 24

    	card reset reason max

    """

    reset_unknown = Enum.YLeaf(1, "reset-unknown")

    power_up = Enum.YLeaf(2, "power-up")

    parity_error = Enum.YLeaf(3, "parity-error")

    clear_config_reset = Enum.YLeaf(4, "clear-config-reset")

    manual_reset = Enum.YLeaf(5, "manual-reset")

    watch_dog_timeout_reset = Enum.YLeaf(6, "watch-dog-timeout-reset")

    resource_overflow_reset = Enum.YLeaf(7, "resource-overflow-reset")

    missing_task_reset = Enum.YLeaf(8, "missing-task-reset")

    low_voltage_reset = Enum.YLeaf(9, "low-voltage-reset")

    controller_reset = Enum.YLeaf(10, "controller-reset")

    system_reset = Enum.YLeaf(11, "system-reset")

    switchover_reset = Enum.YLeaf(12, "switchover-reset")

    upgrade_reset = Enum.YLeaf(13, "upgrade-reset")

    downgrade_reset = Enum.YLeaf(14, "downgrade-reset")

    cache_error_reset = Enum.YLeaf(15, "cache-error-reset")

    device_driver_reset = Enum.YLeaf(16, "device-driver-reset")

    software_exception_reset = Enum.YLeaf(17, "software-exception-reset")

    restore_config_reset = Enum.YLeaf(18, "restore-config-reset")

    abort_rev_reset = Enum.YLeaf(19, "abort-rev-reset")

    burn_boot_reset = Enum.YLeaf(20, "burn-boot-reset")

    standby_cd_healthier_reset = Enum.YLeaf(21, "standby-cd-healthier-reset")

    non_native_config_clear_reset = Enum.YLeaf(22, "non-native-config-clear-reset")

    memory_protection_error_reset = Enum.YLeaf(23, "memory-protection-error-reset")

    card_reset_reason_max = Enum.YLeaf(24, "card-reset-reason-max")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['CardResetReason']


class SensorData(Enum):
    """
    SensorData (Enum Class)

    Sensor measurement data types

    .. data:: unknown = 2

    	Datatype unknown

    .. data:: ac_volts = 3

    	AC volts

    .. data:: dc_volts = 4

    	DC volts

    .. data:: amperes = 5

    	Amperes

    .. data:: watts = 6

    	Power in watts

    .. data:: hertz = 7

    	Frequency in hertz

    .. data:: celsius = 8

    	Celsius

    .. data:: rpm = 10

    	Rotations per minute

    .. data:: dbm = 14

    	Power in dBm

    .. data:: db = 15

    	Power in dB

    """

    unknown = Enum.YLeaf(2, "unknown")

    ac_volts = Enum.YLeaf(3, "ac-volts")

    dc_volts = Enum.YLeaf(4, "dc-volts")

    amperes = Enum.YLeaf(5, "amperes")

    watts = Enum.YLeaf(6, "watts")

    hertz = Enum.YLeaf(7, "hertz")

    celsius = Enum.YLeaf(8, "celsius")

    rpm = Enum.YLeaf(10, "rpm")

    dbm = Enum.YLeaf(14, "dbm")

    db = Enum.YLeaf(15, "db")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['SensorData']


class SensorStatus(Enum):
    """
    SensorStatus (Enum Class)

    Sensor status

    .. data:: ok = 1

    	State ok

    .. data:: unavailable = 2

    	State Unavailable

    .. data:: non_operational = 3

    	State no operational

    """

    ok = Enum.YLeaf(1, "ok")

    unavailable = Enum.YLeaf(2, "unavailable")

    non_operational = Enum.YLeaf(3, "non-operational")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['SensorStatus']


class ThresholdRelation(Enum):
    """
    ThresholdRelation (Enum Class)

    Threshold relation

    .. data:: less_than = 1

    	Sensor value is less than threshold

    .. data:: less_or_equal = 2

    	Sensor value is lesser than  or equal to

    	threshold

    .. data:: greater_than = 3

    	Sensor value is greater than threshold

    .. data:: greater_or_equal = 4

    	Sensor value is greater than or equal to

    	threshold

    .. data:: equal = 5

    	Sensor value is equal to threshold

    .. data:: not_equal = 6

    	Sensor value is not equal to threshold

    """

    less_than = Enum.YLeaf(1, "less-than")

    less_or_equal = Enum.YLeaf(2, "less-or-equal")

    greater_than = Enum.YLeaf(3, "greater-than")

    greater_or_equal = Enum.YLeaf(4, "greater-or-equal")

    equal = Enum.YLeaf(5, "equal")

    not_equal = Enum.YLeaf(6, "not-equal")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['ThresholdRelation']


class ThresholdSeverity(Enum):
    """
    ThresholdSeverity (Enum Class)

    Threshold severity

    .. data:: other = 1

    	Other

    .. data:: minor = 10

    	Minor

    .. data:: major = 20

    	Major

    .. data:: critical = 30

    	Critical

    """

    other = Enum.YLeaf(1, "other")

    minor = Enum.YLeaf(10, "minor")

    major = Enum.YLeaf(20, "major")

    critical = Enum.YLeaf(30, "critical")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['ThresholdSeverity']


class Unit(Enum):
    """
    Unit (Enum Class)

    Unit information

    .. data:: celsius = 0

    	Degree in celsius

    .. data:: milli_volts = 1

    	Milli volts

    .. data:: milli_amperes = 2

    	Milli amperes

    .. data:: rpm = 3

    	Rotations per minute

    .. data:: watts = 4

    	Watts

    .. data:: dbm = 5

    	dBm

    .. data:: db = 6

    	dB

    """

    celsius = Enum.YLeaf(0, "celsius")

    milli_volts = Enum.YLeaf(1, "milli-volts")

    milli_amperes = Enum.YLeaf(2, "milli-amperes")

    rpm = Enum.YLeaf(3, "rpm")

    watts = Enum.YLeaf(4, "watts")

    dbm = Enum.YLeaf(5, "dbm")

    db = Enum.YLeaf(6, "db")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['Unit']



class Inventory(_Entity_):
    """
    Inventory information
    
    .. attribute:: entities
    
    	Entities Table
    	**type**\:  :py:class:`Entities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities>`
    
    	**config**\: False
    
    .. attribute:: racks
    
    	RackTable
    	**type**\:  :py:class:`Racks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks>`
    
    	**config**\: False
    
    

    """

    _prefix = 'invmgr-oper'
    _revision = '2018-04-19'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(Inventory, self).__init__()
        self._top_entity = None

        self.yang_name = "inventory"
        self.yang_parent_name = "Cisco-IOS-XR-invmgr-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("entities", ("entities", Inventory.Entities)), ("racks", ("racks", Inventory.Racks))])
        self._leafs = OrderedDict()

        self.entities = Inventory.Entities()
        self.entities.parent = self
        self._children_name_map["entities"] = "entities"

        self.racks = Inventory.Racks()
        self.racks.parent = self
        self._children_name_map["racks"] = "racks"
        self._segment_path = lambda: "Cisco-IOS-XR-invmgr-oper:inventory"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(Inventory, [], name, value)


    class Entities(_Entity_):
        """
        Entities Table
        
        .. attribute:: entity_
        
        	Entity name
        	**type**\: list of  		 :py:class:`Entity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity>`
        
        	**config**\: False
        
        

        """

        _prefix = 'invmgr-oper'
        _revision = '2018-04-19'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Inventory.Entities, self).__init__()

            self.yang_name = "entities"
            self.yang_parent_name = "inventory"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("entity", ("entity_", Inventory.Entities.Entity))])
            self._leafs = OrderedDict()

            self.entity_ = YList(self)
            self._segment_path = lambda: "entities"
            self._absolute_path = lambda: "Cisco-IOS-XR-invmgr-oper:inventory/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Inventory.Entities, [], name, value)


        class Entity(_Entity_):
            """
            Entity name
            
            .. attribute:: name  (key)
            
            	Entity name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: subentities
            
            	SubEntities Table
            	**type**\:  :py:class:`Subentities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Subentities>`
            
            	**config**\: False
            
            .. attribute:: attributes
            
            	Attributes
            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes>`
            
            	**config**\: False
            
            

            """

            _prefix = 'invmgr-oper'
            _revision = '2018-04-19'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Inventory.Entities.Entity, self).__init__()

                self.yang_name = "entity"
                self.yang_parent_name = "entities"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['name']
                self._child_classes = OrderedDict([("subentities", ("subentities", Inventory.Entities.Entity.Subentities)), ("attributes", ("attributes", Inventory.Entities.Entity.Attributes))])
                self._leafs = OrderedDict([
                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                ])
                self.name = None

                self.subentities = Inventory.Entities.Entity.Subentities()
                self.subentities.parent = self
                self._children_name_map["subentities"] = "subentities"

                self.attributes = Inventory.Entities.Entity.Attributes()
                self.attributes.parent = self
                self._children_name_map["attributes"] = "attributes"
                self._segment_path = lambda: "entity" + "[name='" + str(self.name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-invmgr-oper:inventory/entities/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Inventory.Entities.Entity, ['name'], name, value)


            class Subentities(_Entity_):
                """
                SubEntities Table
                
                .. attribute:: subentity
                
                	Subentity Bag
                	**type**\: list of  		 :py:class:`Subentity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Subentities.Subentity>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Entities.Entity.Subentities, self).__init__()

                    self.yang_name = "subentities"
                    self.yang_parent_name = "entity"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("subentity", ("subentity", Inventory.Entities.Entity.Subentities.Subentity))])
                    self._leafs = OrderedDict()

                    self.subentity = YList(self)
                    self._segment_path = lambda: "subentities"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Entities.Entity.Subentities, [], name, value)


                class Subentity(_Entity_):
                    """
                    Subentity Bag
                    
                    .. attribute:: name  (key)
                    
                    	Subentity name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: subentity_name
                    
                    	Subentity Name
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Subentities.Subentity, self).__init__()

                        self.yang_name = "subentity"
                        self.yang_parent_name = "subentities"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['name']
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('subentity_name', (YLeaf(YType.str, 'subentity-name'), ['str'])),
                        ])
                        self.name = None
                        self.subentity_name = None
                        self._segment_path = lambda: "subentity" + "[name='" + str(self.name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Subentities.Subentity, ['name', 'subentity_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Subentities.Subentity']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Entities.Entity.Subentities']['meta_info']


            class Attributes(_Entity_):
                """
                Attributes
                
                .. attribute:: inv_basic_bag
                
                	Inventory Basic Bag
                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.InvBasicBag>`
                
                	**config**\: False
                
                .. attribute:: vm_node_id
                
                	VM Node ID Tuple
                	**type**\:  :py:class:`VmNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.VmNodeId>`
                
                	**config**\: False
                
                .. attribute:: threshold
                
                	Threshold
                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold>`
                
                	**config**\: False
                
                .. attribute:: vm_done
                
                	VM Done Tuple
                	**type**\:  :py:class:`VmDone <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.VmDone>`
                
                	**config**\: False
                
                .. attribute:: fru_info
                
                	Inventory EDM FRU info
                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.FruInfo>`
                
                	**config**\: False
                
                .. attribute:: env_sensor_info_xml
                
                	Environment sensor info XML
                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.EnvSensorInfoXml>`
                
                	**config**\: False
                
                .. attribute:: inv_asset_bag
                
                	Inventory Asset Bag
                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.InvAssetBag>`
                
                	**config**\: False
                
                .. attribute:: env_sensor_info
                
                	Environment sensor info
                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.EnvSensorInfo>`
                
                	**config**\: False
                
                .. attribute:: node_id
                
                	Node ID Tuple
                	**type**\:  :py:class:`NodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.NodeId>`
                
                	**config**\: False
                
                .. attribute:: inv_eeprom_info
                
                	Inventory EDM EEPROM Information Bag
                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.InvEepromInfo>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Entities.Entity.Attributes, self).__init__()

                    self.yang_name = "attributes"
                    self.yang_parent_name = "entity"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Entities.Entity.Attributes.InvBasicBag)), ("vm-node-id", ("vm_node_id", Inventory.Entities.Entity.Attributes.VmNodeId)), ("threshold", ("threshold", Inventory.Entities.Entity.Attributes.Threshold)), ("vm-done", ("vm_done", Inventory.Entities.Entity.Attributes.VmDone)), ("fru-info", ("fru_info", Inventory.Entities.Entity.Attributes.FruInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Entities.Entity.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Entities.Entity.Attributes.InvAssetBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Entities.Entity.Attributes.EnvSensorInfo)), ("node-id", ("node_id", Inventory.Entities.Entity.Attributes.NodeId)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Entities.Entity.Attributes.InvEepromInfo))])
                    self._leafs = OrderedDict()

                    self.inv_basic_bag = Inventory.Entities.Entity.Attributes.InvBasicBag()
                    self.inv_basic_bag.parent = self
                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                    self.vm_node_id = Inventory.Entities.Entity.Attributes.VmNodeId()
                    self.vm_node_id.parent = self
                    self._children_name_map["vm_node_id"] = "vm-node-id"

                    self.threshold = Inventory.Entities.Entity.Attributes.Threshold()
                    self.threshold.parent = self
                    self._children_name_map["threshold"] = "threshold"

                    self.vm_done = Inventory.Entities.Entity.Attributes.VmDone()
                    self.vm_done.parent = self
                    self._children_name_map["vm_done"] = "vm-done"

                    self.fru_info = Inventory.Entities.Entity.Attributes.FruInfo()
                    self.fru_info.parent = self
                    self._children_name_map["fru_info"] = "fru-info"

                    self.env_sensor_info_xml = Inventory.Entities.Entity.Attributes.EnvSensorInfoXml()
                    self.env_sensor_info_xml.parent = self
                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                    self.inv_asset_bag = Inventory.Entities.Entity.Attributes.InvAssetBag()
                    self.inv_asset_bag.parent = self
                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                    self.env_sensor_info = Inventory.Entities.Entity.Attributes.EnvSensorInfo()
                    self.env_sensor_info.parent = self
                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                    self.node_id = Inventory.Entities.Entity.Attributes.NodeId()
                    self.node_id.parent = self
                    self._children_name_map["node_id"] = "node-id"

                    self.inv_eeprom_info = Inventory.Entities.Entity.Attributes.InvEepromInfo()
                    self.inv_eeprom_info.parent = self
                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                    self._segment_path = lambda: "attributes"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Entities.Entity.Attributes, [], name, value)


                class InvBasicBag(_Entity_):
                    """
                    Inventory Basic Bag
                    
                    .. attribute:: description
                    
                    	describes in user\-readable terms       what the entity in question does
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: vendor_type
                    
                    	maps to the vendor OID string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: name
                    
                    	name string for the entity
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hardware_revision
                    
                    	hw revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: firmware_revision
                    
                    	firmware revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: software_revision
                    
                    	software revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: chip_hardware_revision
                    
                    	chip module hw revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: serial_number
                    
                    	serial number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_name
                    
                    	manufacturer's name
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: model_name
                    
                    	model name
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: asset_id_str
                    
                    	asset Identification string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: asset_identification
                    
                    	asset Identification
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: is_field_replaceable_unit
                    
                    	1 if Field Replaceable Unit 0, if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_asset_tags
                    
                    	Manufacture Asset Tags
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: composite_class_code
                    
                    	Major&minor class of the entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: memory_size
                    
                    	Size of memory associated with       the entity where applicable
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: environmental_monitor_path
                    
                    	sysdb name of sensor in the envmon EDM
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: alias
                    
                    	useful for storing an entity alias 
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: group_flag
                    
                    	indicates if this entity is group       or not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: new_deviation_number
                    
                    	integer value for New Deviation Number 0x88
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: physical_layer_interface_module_type
                    
                    	integer value for plim type if     applicable to this entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: unrecognized_fru
                    
                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: redundancystate
                    
                    	integer value for Redundancy State if applicable to this entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: ceport
                    
                    	1 if ce port found, 0 if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: xr_scoped
                    
                    	1 if xr scoped, 0 if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unique_id
                    
                    	Unique id for an entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: allocated_power
                    
                    	Allocated power for an entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_capacity
                    
                    	Power Capacity of a Power Module
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.InvBasicBag, self).__init__()

                        self.yang_name = "inv-basic-bag"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                        ])
                        self.description = None
                        self.vendor_type = None
                        self.name = None
                        self.hardware_revision = None
                        self.firmware_revision = None
                        self.software_revision = None
                        self.chip_hardware_revision = None
                        self.serial_number = None
                        self.manufacturer_name = None
                        self.model_name = None
                        self.asset_id_str = None
                        self.asset_identification = None
                        self.is_field_replaceable_unit = None
                        self.manufacturer_asset_tags = None
                        self.composite_class_code = None
                        self.memory_size = None
                        self.environmental_monitor_path = None
                        self.alias = None
                        self.group_flag = None
                        self.new_deviation_number = None
                        self.physical_layer_interface_module_type = None
                        self.unrecognized_fru = None
                        self.redundancystate = None
                        self.ceport = None
                        self.xr_scoped = None
                        self.unique_id = None
                        self.allocated_power = None
                        self.power_capacity = None
                        self._segment_path = lambda: "inv-basic-bag"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.InvBasicBag']['meta_info']


                class VmNodeId(_Entity_):
                    """
                    VM Node ID Tuple
                    
                    .. attribute:: vm_node_id
                    
                    	VM Node Id Tuple
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.VmNodeId, self).__init__()

                        self.yang_name = "vm-node-id"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('vm_node_id', (YLeaf(YType.uint32, 'vm-node-id'), ['int'])),
                        ])
                        self.vm_node_id = None
                        self._segment_path = lambda: "vm-node-id"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.VmNodeId, ['vm_node_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.VmNodeId']['meta_info']


                class Threshold(_Entity_):
                    """
                    Threshold
                    
                    .. attribute:: minor_hi
                    
                    	Minor High
                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MinorHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: major_hi
                    
                    	Major High
                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MajorHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: minor_lo
                    
                    	Minor Low
                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MinorLo>`
                    
                    	**config**\: False
                    
                    .. attribute:: major_lo
                    
                    	Major Low
                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MajorLo>`
                    
                    	**config**\: False
                    
                    .. attribute:: critical_hi
                    
                    	Critical High
                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.CriticalHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: critical_lo
                    
                    	Critical Low
                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.CriticalLo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.Threshold, self).__init__()

                        self.yang_name = "threshold"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("minor-hi", ("minor_hi", Inventory.Entities.Entity.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Entities.Entity.Attributes.Threshold.MajorHi)), ("minor-lo", ("minor_lo", Inventory.Entities.Entity.Attributes.Threshold.MinorLo)), ("major-lo", ("major_lo", Inventory.Entities.Entity.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Entities.Entity.Attributes.Threshold.CriticalHi)), ("critical-lo", ("critical_lo", Inventory.Entities.Entity.Attributes.Threshold.CriticalLo))])
                        self._leafs = OrderedDict()

                        self.minor_hi = Inventory.Entities.Entity.Attributes.Threshold.MinorHi()
                        self.minor_hi.parent = self
                        self._children_name_map["minor_hi"] = "minor-hi"

                        self.major_hi = Inventory.Entities.Entity.Attributes.Threshold.MajorHi()
                        self.major_hi.parent = self
                        self._children_name_map["major_hi"] = "major-hi"

                        self.minor_lo = Inventory.Entities.Entity.Attributes.Threshold.MinorLo()
                        self.minor_lo.parent = self
                        self._children_name_map["minor_lo"] = "minor-lo"

                        self.major_lo = Inventory.Entities.Entity.Attributes.Threshold.MajorLo()
                        self.major_lo.parent = self
                        self._children_name_map["major_lo"] = "major-lo"

                        self.critical_hi = Inventory.Entities.Entity.Attributes.Threshold.CriticalHi()
                        self.critical_hi.parent = self
                        self._children_name_map["critical_hi"] = "critical-hi"

                        self.critical_lo = Inventory.Entities.Entity.Attributes.Threshold.CriticalLo()
                        self.critical_lo.parent = self
                        self._children_name_map["critical_lo"] = "critical-lo"
                        self._segment_path = lambda: "threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold, [], name, value)


                    class MinorHi(_Entity_):
                        """
                        Minor High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.MinorHi, self).__init__()

                            self.yang_name = "minor-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "minor-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MinorHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MinorHi']['meta_info']


                    class MajorHi(_Entity_):
                        """
                        Major High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.MajorHi, self).__init__()

                            self.yang_name = "major-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "major-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MajorHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MajorHi']['meta_info']


                    class MinorLo(_Entity_):
                        """
                        Minor Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.MinorLo, self).__init__()

                            self.yang_name = "minor-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "minor-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MinorLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MinorLo']['meta_info']


                    class MajorLo(_Entity_):
                        """
                        Major Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.MajorLo, self).__init__()

                            self.yang_name = "major-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "major-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MajorLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.MajorLo']['meta_info']


                    class CriticalHi(_Entity_):
                        """
                        Critical High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.CriticalHi, self).__init__()

                            self.yang_name = "critical-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "critical-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.CriticalHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.CriticalHi']['meta_info']


                    class CriticalLo(_Entity_):
                        """
                        Critical Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.Threshold.CriticalLo, self).__init__()

                            self.yang_name = "critical-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "critical-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.CriticalLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold.CriticalLo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.Threshold']['meta_info']


                class VmDone(_Entity_):
                    """
                    VM Done Tuple
                    
                    .. attribute:: vm_node_done
                    
                    	VM Node Done Tuple
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.VmDone, self).__init__()

                        self.yang_name = "vm-done"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('vm_node_done', (YLeaf(YType.uint8, 'vm-node-done'), ['int'])),
                        ])
                        self.vm_node_done = None
                        self._segment_path = lambda: "vm-done"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.VmDone, ['vm_node_done'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.VmDone']['meta_info']


                class FruInfo(_Entity_):
                    """
                    Inventory EDM FRU info
                    
                    .. attribute:: last_operational_state_change
                    
                    	last card oper change state
                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange>`
                    
                    	**config**\: False
                    
                    .. attribute:: card_up_time
                    
                    	card up time
                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime>`
                    
                    	**config**\: False
                    
                    .. attribute:: card_administrative_state
                    
                    	card admin state\: shutdown or not
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_administrative_state
                    
                    	power admin state\: up or down
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_operational_state
                    
                    	card operation state
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_monitor_state
                    
                    	card is monitored by a manager or left unmonitored
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_reset_reason
                    
                    	card reset reason enum
                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: power_current_measurement
                    
                    	power current\: not implemented
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_operational_state
                    
                    	Power operation state
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.FruInfo, self).__init__()

                        self.yang_name = "fru-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime))])
                        self._leafs = OrderedDict([
                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                        ])
                        self.card_administrative_state = None
                        self.power_administrative_state = None
                        self.card_operational_state = None
                        self.card_monitor_state = None
                        self.card_reset_reason = None
                        self.power_current_measurement = None
                        self.power_operational_state = None

                        self.last_operational_state_change = Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange()
                        self.last_operational_state_change.parent = self
                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                        self.card_up_time = Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime()
                        self.card_up_time.parent = self
                        self._children_name_map["card_up_time"] = "card-up-time"
                        self._segment_path = lambda: "fru-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                    class LastOperationalStateChange(_Entity_):
                        """
                        last card oper change state
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                            self.yang_name = "last-operational-state-change"
                            self.yang_parent_name = "fru-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                            ])
                            self.time_in_seconds = None
                            self.time_in_nano_seconds = None
                            self._segment_path = lambda: "last-operational-state-change"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                    class CardUpTime(_Entity_):
                        """
                        card up time
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime, self).__init__()

                            self.yang_name = "card-up-time"
                            self.yang_parent_name = "fru-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                            ])
                            self.time_in_seconds = None
                            self.time_in_nano_seconds = None
                            self._segment_path = lambda: "card-up-time"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.FruInfo.CardUpTime']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.FruInfo']['meta_info']


                class EnvSensorInfoXml(_Entity_):
                    """
                    Environment sensor info XML
                    
                    .. attribute:: threshold
                    
                    	Threshold information
                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold>`
                    
                    	**config**\: False
                    
                    .. attribute:: description
                    
                    	Device Name
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                    
                    	**config**\: False
                    
                    .. attribute:: value
                    
                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: data_type
                    
                    	Sensor data type
                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	Sensor operation state
                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml, self).__init__()

                        self.yang_name = "env-sensor-info-xml"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold))])
                        self._leafs = OrderedDict([
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                        ])
                        self.description = None
                        self.units = None
                        self.value = None
                        self.data_type = None
                        self.status = None
                        self.update_rate = None

                        self.threshold = Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold()
                        self.threshold.parent = self
                        self._children_name_map["threshold"] = "threshold"
                        self._segment_path = lambda: "env-sensor-info-xml"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                    class Threshold(_Entity_):
                        """
                        Threshold information
                        
                        .. attribute:: threshold_array
                        
                        	Array of threshold
                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                            self.yang_name = "threshold"
                            self.yang_parent_name = "env-sensor-info-xml"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                            self._leafs = OrderedDict()

                            self.threshold_array = YList(self)
                            self._segment_path = lambda: "threshold"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                        class ThresholdArray(_Entity_):
                            """
                            Array of threshold
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_name
                            
                            	Threshold name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                self.yang_name = "threshold-array"
                                self.yang_parent_name = "threshold"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_name = None
                                self._segment_path = lambda: "threshold-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.EnvSensorInfoXml']['meta_info']


                class InvAssetBag(_Entity_):
                    """
                    Inventory Asset Bag
                    
                    .. attribute:: part_number
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_assembly_number
                    
                    	Manufacture Assembly number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_assembly_revision
                    
                    	Manufacture assembly revision
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_firmware_identifier
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_software_identifier
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_common_language_equipment_identifier
                    
                    	Common Language Equipment           Identifier number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: original_equipment_manufacturer_string
                    
                    	String containing OEM information           if applicable
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.InvAssetBag, self).__init__()

                        self.yang_name = "inv-asset-bag"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                        ])
                        self.part_number = None
                        self.manufacturer_assembly_number = None
                        self.manufacturer_assembly_revision = None
                        self.manufacturer_firmware_identifier = None
                        self.manufacturer_software_identifier = None
                        self.manufacturer_common_language_equipment_identifier = None
                        self.original_equipment_manufacturer_string = None
                        self._segment_path = lambda: "inv-asset-bag"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.InvAssetBag']['meta_info']


                class EnvSensorInfo(_Entity_):
                    """
                    Environment sensor info
                    
                    .. attribute:: field_validity_bitmap
                    
                    	Sensor valid bitmap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: device_description
                    
                    	Device Name
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: device_id
                    
                    	Identifier for this device
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: value
                    
                    	Current reading of sensor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: alarm_type
                    
                    	Indicates threshold violation
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: data_type
                    
                    	Sensor data type enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: scale
                    
                    	Sensor scale enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: precision
                    
                    	Sensor precision range
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	Sensor operation state enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: age_time_stamp
                    
                    	Age of the sensor value; set to the current time if directly access the value from sensor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: average
                    
                    	Average sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: minimum
                    
                    	Minimum Sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: maximum
                    
                    	Maximum Sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: interval
                    
                    	Time Interval over which sensor value is monitored
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.EnvSensorInfo, self).__init__()

                        self.yang_name = "env-sensor-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                        ])
                        self.field_validity_bitmap = None
                        self.device_description = None
                        self.units = None
                        self.device_id = None
                        self.value = None
                        self.alarm_type = None
                        self.data_type = None
                        self.scale = None
                        self.precision = None
                        self.status = None
                        self.age_time_stamp = None
                        self.update_rate = None
                        self.average = None
                        self.minimum = None
                        self.maximum = None
                        self.interval = None
                        self._segment_path = lambda: "env-sensor-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.EnvSensorInfo']['meta_info']


                class NodeId(_Entity_):
                    """
                    Node ID Tuple
                    
                    .. attribute:: node_id
                    
                    	Node Id Tuple
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.NodeId, self).__init__()

                        self.yang_name = "node-id"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('node_id', (YLeaf(YType.uint32, 'node-id'), ['int'])),
                        ])
                        self.node_id = None
                        self._segment_path = lambda: "node-id"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.NodeId, ['node_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.NodeId']['meta_info']


                class InvEepromInfo(_Entity_):
                    """
                    Inventory EDM EEPROM Information Bag
                    
                    .. attribute:: eeprom
                    
                    	EEPROM data not from hex data
                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom>`
                    
                    	**config**\: False
                    
                    .. attribute:: inv_card_type
                    
                    	Inventory card type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: opaque_data
                    
                    	EEPROM hex data
                    	**type**\: str
                    
                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                    
                    	**config**\: False
                    
                    .. attribute:: opaque_data_size
                    
                    	size of the EEPROM hex data
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_eeprom
                    
                    	use eeprom instead of opaque data
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: description
                    
                    	A textual description of physical entity
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: form_factor
                    
                    	Optics form factor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: connector_type
                    
                    	Connector type
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: otn_application_code
                    
                    	Otn Application Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sonet_application_code
                    
                    	Sonet Application Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ethernet_compliance_code
                    
                    	Ethernet Compliance Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: date_string
                    
                    	Date string in IDPROM
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Entities.Entity.Attributes.InvEepromInfo, self).__init__()

                        self.yang_name = "inv-eeprom-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom))])
                        self._leafs = OrderedDict([
                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                        ])
                        self.inv_card_type = None
                        self.opaque_data = None
                        self.opaque_data_size = None
                        self.has_eeprom = None
                        self.description = None
                        self.form_factor = None
                        self.connector_type = None
                        self.otn_application_code = None
                        self.sonet_application_code = None
                        self.ethernet_compliance_code = None
                        self.date_string = None

                        self.eeprom = Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom()
                        self.eeprom.parent = self
                        self._children_name_map["eeprom"] = "eeprom"
                        self._segment_path = lambda: "inv-eeprom-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Entities.Entity.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                    class Eeprom(_Entity_):
                        """
                        EEPROM data not from hex data
                        
                        .. attribute:: rma
                        
                        	RMA Data
                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma>`
                        
                        	**config**\: False
                        
                        .. attribute:: description
                        
                        	A textual description of physical entity
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: idprom_format_rev
                        
                        	IDPROM Format Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: controller_family
                        
                        	Controller family
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: controller_type
                        
                        	Controller type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: vid
                        
                        	Version ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: hwid
                        
                        	Hardware Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pid
                        
                        	Product ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: udi_description
                        
                        	UDI description
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: udi_name
                        
                        	UDI name
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: clei
                        
                        	Common Language Equipment Identifier (CLEI) code
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eci
                        
                        	Equipment Catalog Item (ECI) number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: top_assem_part_num
                        
                        	Top assembly part number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: top_assem_vid
                        
                        	Top assembly revision number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pca_num
                        
                        	PCA number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pcavid
                        
                        	PCA revision ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: chassis_sid
                        
                        	Chassis serial number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num1
                        
                        	Deviation Number # 1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num2
                        
                        	Deviation Number # 2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num3
                        
                        	Deviation Number # 3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num4
                        
                        	Deviation Number # 4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num5
                        
                        	Deviation Number # 5
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num6
                        
                        	Deviation Number # 6
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num7
                        
                        	Deviation Number # 7
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: manu_test_data
                        
                        	Manufacturing Test Data
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: asset_id
                        
                        	Asset ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: asset_alias
                        
                        	Asset Alias
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address1
                        
                        	Base Mac Address #1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size1
                        
                        	Mac Address Block Size #1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address2
                        
                        	Base Mac Address #2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size2
                        
                        	Mac Address Block Size #2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address3
                        
                        	Base Mac Address #3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size3
                        
                        	Mac Address Block Size #3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address4
                        
                        	Base Mac Address #4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size4
                        
                        	Mac Address Block Size #4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pcb_serial_num
                        
                        	PCB Serial Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: power_supply_type
                        
                        	Power Supply Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: power_consumption
                        
                        	Power Consumption
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_signature
                        
                        	Block Signature
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_version
                        
                        	Block Version
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_length
                        
                        	Block Length
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_checksum
                        
                        	Block Checksum
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eeprom_size
                        
                        	EEPROM Size
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_count
                        
                        	Block Count
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: fru_major_type
                        
                        	FRU Major Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: fru_minor_type
                        
                        	FRU Minor Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: oem_string
                        
                        	OEM String
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: product_id
                        
                        	Product ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: serial_number
                        
                        	Serial Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: part_number
                        
                        	Part Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: part_revision
                        
                        	Part Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mfg_deviation
                        
                        	MFG Deviation
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: hw_version
                        
                        	Hardware Version
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mfg_bits
                        
                        	MFG Bits
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: engineer_use
                        
                        	Engineer Use
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: snmpoid
                        
                        	SNMP OID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: rma_code
                        
                        	RMA Code
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eci_alpha_number
                        
                        	AlphaNumeric Equipment Catalog Item (ECI) number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom, self).__init__()

                            self.yang_name = "eeprom"
                            self.yang_parent_name = "inv-eeprom-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma))])
                            self._leafs = OrderedDict([
                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                            ])
                            self.description = None
                            self.idprom_format_rev = None
                            self.controller_family = None
                            self.controller_type = None
                            self.vid = None
                            self.hwid = None
                            self.pid = None
                            self.udi_description = None
                            self.udi_name = None
                            self.clei = None
                            self.eci = None
                            self.top_assem_part_num = None
                            self.top_assem_vid = None
                            self.pca_num = None
                            self.pcavid = None
                            self.chassis_sid = None
                            self.dev_num1 = None
                            self.dev_num2 = None
                            self.dev_num3 = None
                            self.dev_num4 = None
                            self.dev_num5 = None
                            self.dev_num6 = None
                            self.dev_num7 = None
                            self.manu_test_data = None
                            self.asset_id = None
                            self.asset_alias = None
                            self.base_mac_address1 = None
                            self.mac_add_blk_size1 = None
                            self.base_mac_address2 = None
                            self.mac_add_blk_size2 = None
                            self.base_mac_address3 = None
                            self.mac_add_blk_size3 = None
                            self.base_mac_address4 = None
                            self.mac_add_blk_size4 = None
                            self.pcb_serial_num = None
                            self.power_supply_type = None
                            self.power_consumption = None
                            self.block_signature = None
                            self.block_version = None
                            self.block_length = None
                            self.block_checksum = None
                            self.eeprom_size = None
                            self.block_count = None
                            self.fru_major_type = None
                            self.fru_minor_type = None
                            self.oem_string = None
                            self.product_id = None
                            self.serial_number = None
                            self.part_number = None
                            self.part_revision = None
                            self.mfg_deviation = None
                            self.hw_version = None
                            self.mfg_bits = None
                            self.engineer_use = None
                            self.snmpoid = None
                            self.rma_code = None
                            self.eci_alpha_number = None

                            self.rma = Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma()
                            self.rma.parent = self
                            self._children_name_map["rma"] = "rma"
                            self._segment_path = lambda: "eeprom"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                        class Rma(_Entity_):
                            """
                            RMA Data
                            
                            .. attribute:: test_history
                            
                            	Test history
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: rma_number
                            
                            	RMA tracking number format is N\-N\-N
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: rma_history
                            
                            	RMA history
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                self.yang_name = "rma"
                                self.yang_parent_name = "eeprom"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                ])
                                self.test_history = None
                                self.rma_number = None
                                self.rma_history = None
                                self._segment_path = lambda: "rma"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Entities.Entity.Attributes.InvEepromInfo.Eeprom']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Entities.Entity.Attributes.InvEepromInfo']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Entities.Entity.Attributes']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                return meta._meta_table['Inventory.Entities.Entity']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
            return meta._meta_table['Inventory.Entities']['meta_info']


    class Racks(_Entity_):
        """
        RackTable
        
        .. attribute:: rack
        
        	Rack name
        	**type**\: list of  		 :py:class:`Rack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack>`
        
        	**config**\: False
        
        

        """

        _prefix = 'invmgr-oper'
        _revision = '2018-04-19'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Inventory.Racks, self).__init__()

            self.yang_name = "racks"
            self.yang_parent_name = "inventory"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("rack", ("rack", Inventory.Racks.Rack))])
            self._leafs = OrderedDict()

            self.rack = YList(self)
            self._segment_path = lambda: "racks"
            self._absolute_path = lambda: "Cisco-IOS-XR-invmgr-oper:inventory/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Inventory.Racks, [], name, value)


        class Rack(_Entity_):
            """
            Rack name
            
            .. attribute:: name  (key)
            
            	Rack name
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: entity_
            
            	Entity information
            	**type**\:  :py:class:`Entity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity>`
            
            	**config**\: False
            
            .. attribute:: powershelf
            
            	Powershelf information
            	**type**\:  :py:class:`Powershelf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf>`
            
            	**config**\: False
            
            .. attribute:: fantray
            
            	Fantray information
            	**type**\:  :py:class:`Fantray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray>`
            
            	**config**\: False
            
            .. attribute:: attributes
            
            	Attributes
            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes>`
            
            	**config**\: False
            
            

            """

            _prefix = 'invmgr-oper'
            _revision = '2018-04-19'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Inventory.Racks.Rack, self).__init__()

                self.yang_name = "rack"
                self.yang_parent_name = "racks"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['name']
                self._child_classes = OrderedDict([("entity", ("entity_", Inventory.Racks.Rack.Entity)), ("powershelf", ("powershelf", Inventory.Racks.Rack.Powershelf)), ("fantray", ("fantray", Inventory.Racks.Rack.Fantray)), ("attributes", ("attributes", Inventory.Racks.Rack.Attributes))])
                self._leafs = OrderedDict([
                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                ])
                self.name = None

                self.entity_ = Inventory.Racks.Rack.Entity()
                self.entity_.parent = self
                self._children_name_map["entity_"] = "entity"

                self.powershelf = Inventory.Racks.Rack.Powershelf()
                self.powershelf.parent = self
                self._children_name_map["powershelf"] = "powershelf"

                self.fantray = Inventory.Racks.Rack.Fantray()
                self.fantray.parent = self
                self._children_name_map["fantray"] = "fantray"

                self.attributes = Inventory.Racks.Rack.Attributes()
                self.attributes.parent = self
                self._children_name_map["attributes"] = "attributes"
                self._segment_path = lambda: "rack" + "[name='" + str(self.name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-invmgr-oper:inventory/racks/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Inventory.Racks.Rack, ['name'], name, value)


            class Entity(_Entity_):
                """
                Entity information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of  		 :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Racks.Rack.Entity, self).__init__()

                    self.yang_name = "entity"
                    self.yang_parent_name = "rack"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slot", ("slot", Inventory.Racks.Rack.Entity.Slot))])
                    self._leafs = OrderedDict()

                    self.slot = YList(self)
                    self._segment_path = lambda: "entity"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Racks.Rack.Entity, [], name, value)


                class Slot(_Entity_):
                    """
                    Slot number
                    
                    .. attribute:: name  (key)
                    
                    	Slot name
                    	**type**\: str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    	**config**\: False
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:  :py:class:`Tsi1s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s>`
                    
                    	**config**\: False
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Entity.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "entity"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['name']
                        self._child_classes = OrderedDict([("tsi1s", ("tsi1s", Inventory.Racks.Rack.Entity.Slot.Tsi1s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Attributes))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                        ])
                        self.name = None

                        self.tsi1s = Inventory.Racks.Rack.Entity.Slot.Tsi1s()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"

                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._segment_path = lambda: "slot" + "[name='" + str(self.name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot, ['name'], name, value)


                    class Tsi1s(_Entity_):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of  		 :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("tsi1", ("tsi1", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1))])
                            self._leafs = OrderedDict()

                            self.tsi1 = YList(self)
                            self._segment_path = lambda: "tsi1s"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s, [], name, value)


                        class Tsi1(_Entity_):
                            """
                            TSI1
                            
                            .. attribute:: name  (key)
                            
                            	TSI1
                            	**type**\: str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            	**config**\: False
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:  :py:class:`Tsi2s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s>`
                            
                            	**config**\: False
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['name']
                                self._child_classes = OrderedDict([("tsi2s", ("tsi2s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes))])
                                self._leafs = OrderedDict([
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ])
                                self.name = None

                                self.tsi2s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"

                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._segment_path = lambda: "tsi1" + "[name='" + str(self.name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1, ['name'], name, value)


                            class Tsi2s(_Entity_):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of  		 :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("tsi2", ("tsi2", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2))])
                                    self._leafs = OrderedDict()

                                    self.tsi2 = YList(self)
                                    self._segment_path = lambda: "tsi2s"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s, [], name, value)


                                class Tsi2(_Entity_):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  (key)
                                    
                                    	TSI2
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:  :py:class:`Tsi3s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['name']
                                        self._child_classes = OrderedDict([("tsi3s", ("tsi3s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ])
                                        self.name = None

                                        self.tsi3s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"

                                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._segment_path = lambda: "tsi2" + "[name='" + str(self.name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, ['name'], name, value)


                                    class Tsi3s(_Entity_):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of  		 :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("tsi3", ("tsi3", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3))])
                                            self._leafs = OrderedDict()

                                            self.tsi3 = YList(self)
                                            self._segment_path = lambda: "tsi3s"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, [], name, value)


                                        class Tsi3(_Entity_):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  (key)
                                            
                                            	TSI3
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:  :py:class:`Tsi4s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['name']
                                                self._child_classes = OrderedDict([("tsi4s", ("tsi4s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ])
                                                self.name = None

                                                self.tsi4s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"

                                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._segment_path = lambda: "tsi3" + "[name='" + str(self.name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, ['name'], name, value)


                                            class Tsi4s(_Entity_):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of  		 :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("tsi4", ("tsi4", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4))])
                                                    self._leafs = OrderedDict()

                                                    self.tsi4 = YList(self)
                                                    self._segment_path = lambda: "tsi4s"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, [], name, value)


                                                class Tsi4(_Entity_):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  (key)
                                                    
                                                    	TSI4
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:  :py:class:`Tsi5s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['name']
                                                        self._child_classes = OrderedDict([("tsi5s", ("tsi5s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes))])
                                                        self._leafs = OrderedDict([
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ])
                                                        self.name = None

                                                        self.tsi5s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"

                                                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._segment_path = lambda: "tsi4" + "[name='" + str(self.name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, ['name'], name, value)


                                                    class Tsi5s(_Entity_):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of  		 :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("tsi5", ("tsi5", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5))])
                                                            self._leafs = OrderedDict()

                                                            self.tsi5 = YList(self)
                                                            self._segment_path = lambda: "tsi5s"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, [], name, value)


                                                        class Tsi5(_Entity_):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  (key)
                                                            
                                                            	TSI5
                                                            	**type**\: str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:  :py:class:`Tsi6s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = ['name']
                                                                self._child_classes = OrderedDict([("tsi6s", ("tsi6s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes))])
                                                                self._leafs = OrderedDict([
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                ])
                                                                self.name = None

                                                                self.tsi6s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"

                                                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._segment_path = lambda: "tsi5" + "[name='" + str(self.name) + "']"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, ['name'], name, value)


                                                            class Tsi6s(_Entity_):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of  		 :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("tsi6", ("tsi6", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6))])
                                                                    self._leafs = OrderedDict()

                                                                    self.tsi6 = YList(self)
                                                                    self._segment_path = lambda: "tsi6s"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, [], name, value)


                                                                class Tsi6(_Entity_):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  (key)
                                                                    
                                                                    	TSI6
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:  :py:class:`Tsi7s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = ['name']
                                                                        self._child_classes = OrderedDict([("tsi7s", ("tsi7s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes))])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ])
                                                                        self.name = None

                                                                        self.tsi7s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"

                                                                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._segment_path = lambda: "tsi6" + "[name='" + str(self.name) + "']"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, ['name'], name, value)


                                                                    class Tsi7s(_Entity_):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of  		 :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("tsi7", ("tsi7", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7))])
                                                                            self._leafs = OrderedDict()

                                                                            self.tsi7 = YList(self)
                                                                            self._segment_path = lambda: "tsi7s"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, [], name, value)


                                                                        class Tsi7(_Entity_):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  (key)
                                                                            
                                                                            	TSI7
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:  :py:class:`Tsi8s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = ['name']
                                                                                self._child_classes = OrderedDict([("tsi8s", ("tsi8s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ])
                                                                                self.name = None

                                                                                self.tsi8s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"

                                                                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._segment_path = lambda: "tsi7" + "[name='" + str(self.name) + "']"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, ['name'], name, value)


                                                                            class Tsi8s(_Entity_):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of  		 :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("tsi8", ("tsi8", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.tsi8 = YList(self)
                                                                                    self._segment_path = lambda: "tsi8s"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, [], name, value)


                                                                                class Tsi8(_Entity_):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  (key)
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:  :py:class:`Tsi9s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = ['name']
                                                                                        self._child_classes = OrderedDict([("tsi9s", ("tsi9s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ])
                                                                                        self.name = None

                                                                                        self.tsi9s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"

                                                                                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._segment_path = lambda: "tsi8" + "[name='" + str(self.name) + "']"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, ['name'], name, value)


                                                                                    class Tsi9s(_Entity_):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of  		 :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("tsi9", ("tsi9", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.tsi9 = YList(self)
                                                                                            self._segment_path = lambda: "tsi9s"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, [], name, value)


                                                                                        class Tsi9(_Entity_):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  (key)
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:  :py:class:`Tsi10s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = ['name']
                                                                                                self._child_classes = OrderedDict([("tsi10s", ("tsi10s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                ])
                                                                                                self.name = None

                                                                                                self.tsi10s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"

                                                                                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._segment_path = lambda: "tsi9" + "[name='" + str(self.name) + "']"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, ['name'], name, value)


                                                                                            class Tsi10s(_Entity_):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of  		 :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("tsi10", ("tsi10", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.tsi10 = YList(self)
                                                                                                    self._segment_path = lambda: "tsi10s"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, [], name, value)


                                                                                                class Tsi10(_Entity_):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  (key)
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:  :py:class:`Tsi11s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = ['name']
                                                                                                        self._child_classes = OrderedDict([("tsi11s", ("tsi11s", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s)), ("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                        ])
                                                                                                        self.name = None

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"

                                                                                                        self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._segment_path = lambda: "tsi10" + "[name='" + str(self.name) + "']"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, ['name'], name, value)


                                                                                                    class Tsi11s(_Entity_):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of  		 :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("tsi11", ("tsi11", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.tsi11 = YList(self)
                                                                                                            self._segment_path = lambda: "tsi11s"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, [], name, value)


                                                                                                        class Tsi11(_Entity_):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  (key)
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = ['name']
                                                                                                                self._child_classes = OrderedDict([("attributes", ("attributes", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                ])
                                                                                                                self.name = None

                                                                                                                self.attributes = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._segment_path = lambda: "tsi11" + "[name='" + str(self.name) + "']"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, ['name'], name, value)


                                                                                                            class Attributes(_Entity_):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, [], name, value)


                                                                                                                class InvBasicBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: allocated_power
                                                                                                                    
                                                                                                                    	Allocated power for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_capacity
                                                                                                                    
                                                                                                                    	Power Capacity of a Power Module
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.vendor_type = None
                                                                                                                        self.name = None
                                                                                                                        self.hardware_revision = None
                                                                                                                        self.firmware_revision = None
                                                                                                                        self.software_revision = None
                                                                                                                        self.chip_hardware_revision = None
                                                                                                                        self.serial_number = None
                                                                                                                        self.manufacturer_name = None
                                                                                                                        self.model_name = None
                                                                                                                        self.asset_id_str = None
                                                                                                                        self.asset_identification = None
                                                                                                                        self.is_field_replaceable_unit = None
                                                                                                                        self.manufacturer_asset_tags = None
                                                                                                                        self.composite_class_code = None
                                                                                                                        self.memory_size = None
                                                                                                                        self.environmental_monitor_path = None
                                                                                                                        self.alias = None
                                                                                                                        self.group_flag = None
                                                                                                                        self.new_deviation_number = None
                                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                                        self.unrecognized_fru = None
                                                                                                                        self.redundancystate = None
                                                                                                                        self.ceport = None
                                                                                                                        self.xr_scoped = None
                                                                                                                        self.unique_id = None
                                                                                                                        self.allocated_power = None
                                                                                                                        self.power_capacity = None
                                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag']['meta_info']


                                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: average
                                                                                                                    
                                                                                                                    	Average sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minimum
                                                                                                                    
                                                                                                                    	Minimum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: maximum
                                                                                                                    
                                                                                                                    	Maximum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: interval
                                                                                                                    
                                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.field_validity_bitmap = None
                                                                                                                        self.device_description = None
                                                                                                                        self.units = None
                                                                                                                        self.device_id = None
                                                                                                                        self.value = None
                                                                                                                        self.alarm_type = None
                                                                                                                        self.data_type = None
                                                                                                                        self.scale = None
                                                                                                                        self.precision = None
                                                                                                                        self.status = None
                                                                                                                        self.age_time_stamp = None
                                                                                                                        self.update_rate = None
                                                                                                                        self.average = None
                                                                                                                        self.minimum = None
                                                                                                                        self.maximum = None
                                                                                                                        self.interval = None
                                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo']['meta_info']


                                                                                                                class PwgInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.power_group_redundancy_mode = None
                                                                                                                        self.power_group_power_units = None
                                                                                                                        self.power_group_available_current = None
                                                                                                                        self.power_group_drawn_current = None
                                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo']['meta_info']


                                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.units = None
                                                                                                                        self.value = None
                                                                                                                        self.data_type = None
                                                                                                                        self.status = None
                                                                                                                        self.update_rate = None

                                                                                                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                                    class Threshold(_Entity_):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.threshold_array = YList(self)
                                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                        class ThresholdArray(_Entity_):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_name = None
                                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                                class InvAssetBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.part_number = None
                                                                                                                        self.manufacturer_assembly_number = None
                                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                                        self.manufacturer_software_identifier = None
                                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag']['meta_info']


                                                                                                                class Threshold(_Entity_):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo))])
                                                                                                                        self._leafs = OrderedDict()

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, [], name, value)


                                                                                                                    class MajorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                                    class CriticalHi(_Entity_):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                                    class MinorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                                    class MajorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                                    class CriticalLo(_Entity_):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                                    class MinorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold']['meta_info']


                                                                                                                class FruInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.card_administrative_state = None
                                                                                                                        self.power_administrative_state = None
                                                                                                                        self.card_operational_state = None
                                                                                                                        self.card_monitor_state = None
                                                                                                                        self.card_reset_reason = None
                                                                                                                        self.power_current_measurement = None
                                                                                                                        self.power_operational_state = None

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                                    class CardUpTime(_Entity_):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo']['meta_info']


                                                                                                                class InvEepromInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: form_factor
                                                                                                                    
                                                                                                                    	Optics form factor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: connector_type
                                                                                                                    
                                                                                                                    	Connector type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: otn_application_code
                                                                                                                    
                                                                                                                    	Otn Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: sonet_application_code
                                                                                                                    
                                                                                                                    	Sonet Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                                    
                                                                                                                    	Ethernet Compliance Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: date_string
                                                                                                                    
                                                                                                                    	Date string in IDPROM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.inv_card_type = None
                                                                                                                        self.opaque_data = None
                                                                                                                        self.opaque_data_size = None
                                                                                                                        self.has_eeprom = None
                                                                                                                        self.description = None
                                                                                                                        self.form_factor = None
                                                                                                                        self.connector_type = None
                                                                                                                        self.otn_application_code = None
                                                                                                                        self.sonet_application_code = None
                                                                                                                        self.ethernet_compliance_code = None
                                                                                                                        self.date_string = None

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                                    class Eeprom(_Entity_):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci_alpha_number
                                                                                                                        
                                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                            ])
                                                                                                                            self.description = None
                                                                                                                            self.idprom_format_rev = None
                                                                                                                            self.controller_family = None
                                                                                                                            self.controller_type = None
                                                                                                                            self.vid = None
                                                                                                                            self.hwid = None
                                                                                                                            self.pid = None
                                                                                                                            self.udi_description = None
                                                                                                                            self.udi_name = None
                                                                                                                            self.clei = None
                                                                                                                            self.eci = None
                                                                                                                            self.top_assem_part_num = None
                                                                                                                            self.top_assem_vid = None
                                                                                                                            self.pca_num = None
                                                                                                                            self.pcavid = None
                                                                                                                            self.chassis_sid = None
                                                                                                                            self.dev_num1 = None
                                                                                                                            self.dev_num2 = None
                                                                                                                            self.dev_num3 = None
                                                                                                                            self.dev_num4 = None
                                                                                                                            self.dev_num5 = None
                                                                                                                            self.dev_num6 = None
                                                                                                                            self.dev_num7 = None
                                                                                                                            self.manu_test_data = None
                                                                                                                            self.asset_id = None
                                                                                                                            self.asset_alias = None
                                                                                                                            self.base_mac_address1 = None
                                                                                                                            self.mac_add_blk_size1 = None
                                                                                                                            self.base_mac_address2 = None
                                                                                                                            self.mac_add_blk_size2 = None
                                                                                                                            self.base_mac_address3 = None
                                                                                                                            self.mac_add_blk_size3 = None
                                                                                                                            self.base_mac_address4 = None
                                                                                                                            self.mac_add_blk_size4 = None
                                                                                                                            self.pcb_serial_num = None
                                                                                                                            self.power_supply_type = None
                                                                                                                            self.power_consumption = None
                                                                                                                            self.block_signature = None
                                                                                                                            self.block_version = None
                                                                                                                            self.block_length = None
                                                                                                                            self.block_checksum = None
                                                                                                                            self.eeprom_size = None
                                                                                                                            self.block_count = None
                                                                                                                            self.fru_major_type = None
                                                                                                                            self.fru_minor_type = None
                                                                                                                            self.oem_string = None
                                                                                                                            self.product_id = None
                                                                                                                            self.serial_number = None
                                                                                                                            self.part_number = None
                                                                                                                            self.part_revision = None
                                                                                                                            self.mfg_deviation = None
                                                                                                                            self.hw_version = None
                                                                                                                            self.mfg_bits = None
                                                                                                                            self.engineer_use = None
                                                                                                                            self.snmpoid = None
                                                                                                                            self.rma_code = None
                                                                                                                            self.eci_alpha_number = None

                                                                                                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                        class Rma(_Entity_):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.test_history = None
                                                                                                                                self.rma_number = None
                                                                                                                                self.rma_history = None
                                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s']['meta_info']


                                                                                                    class Attributes(_Entity_):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._segment_path = lambda: "attributes"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, [], name, value)


                                                                                                        class InvBasicBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: allocated_power
                                                                                                            
                                                                                                            	Allocated power for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_capacity
                                                                                                            
                                                                                                            	Power Capacity of a Power Module
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.vendor_type = None
                                                                                                                self.name = None
                                                                                                                self.hardware_revision = None
                                                                                                                self.firmware_revision = None
                                                                                                                self.software_revision = None
                                                                                                                self.chip_hardware_revision = None
                                                                                                                self.serial_number = None
                                                                                                                self.manufacturer_name = None
                                                                                                                self.model_name = None
                                                                                                                self.asset_id_str = None
                                                                                                                self.asset_identification = None
                                                                                                                self.is_field_replaceable_unit = None
                                                                                                                self.manufacturer_asset_tags = None
                                                                                                                self.composite_class_code = None
                                                                                                                self.memory_size = None
                                                                                                                self.environmental_monitor_path = None
                                                                                                                self.alias = None
                                                                                                                self.group_flag = None
                                                                                                                self.new_deviation_number = None
                                                                                                                self.physical_layer_interface_module_type = None
                                                                                                                self.unrecognized_fru = None
                                                                                                                self.redundancystate = None
                                                                                                                self.ceport = None
                                                                                                                self.xr_scoped = None
                                                                                                                self.unique_id = None
                                                                                                                self.allocated_power = None
                                                                                                                self.power_capacity = None
                                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag']['meta_info']


                                                                                                        class EnvSensorInfo(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: average
                                                                                                            
                                                                                                            	Average sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minimum
                                                                                                            
                                                                                                            	Minimum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: maximum
                                                                                                            
                                                                                                            	Maximum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: interval
                                                                                                            
                                                                                                            	Time Interval over which sensor value is monitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                ])
                                                                                                                self.field_validity_bitmap = None
                                                                                                                self.device_description = None
                                                                                                                self.units = None
                                                                                                                self.device_id = None
                                                                                                                self.value = None
                                                                                                                self.alarm_type = None
                                                                                                                self.data_type = None
                                                                                                                self.scale = None
                                                                                                                self.precision = None
                                                                                                                self.status = None
                                                                                                                self.age_time_stamp = None
                                                                                                                self.update_rate = None
                                                                                                                self.average = None
                                                                                                                self.minimum = None
                                                                                                                self.maximum = None
                                                                                                                self.interval = None
                                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo']['meta_info']


                                                                                                        class PwgInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                ])
                                                                                                                self.power_group_redundancy_mode = None
                                                                                                                self.power_group_power_units = None
                                                                                                                self.power_group_available_current = None
                                                                                                                self.power_group_drawn_current = None
                                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo']['meta_info']


                                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.units = None
                                                                                                                self.value = None
                                                                                                                self.data_type = None
                                                                                                                self.status = None
                                                                                                                self.update_rate = None

                                                                                                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                            class Threshold(_Entity_):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.threshold_array = YList(self)
                                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                class ThresholdArray(_Entity_):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_name = None
                                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                        class InvAssetBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.part_number = None
                                                                                                                self.manufacturer_assembly_number = None
                                                                                                                self.manufacturer_assembly_revision = None
                                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                                self.manufacturer_software_identifier = None
                                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag']['meta_info']


                                                                                                        class Threshold(_Entity_):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo))])
                                                                                                                self._leafs = OrderedDict()

                                                                                                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._segment_path = lambda: "threshold"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, [], name, value)


                                                                                                            class MajorLo(_Entity_):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                            class CriticalHi(_Entity_):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                            class MinorHi(_Entity_):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                            class MajorHi(_Entity_):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                            class CriticalLo(_Entity_):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                            class MinorLo(_Entity_):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold']['meta_info']


                                                                                                        class FruInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                ])
                                                                                                                self.card_administrative_state = None
                                                                                                                self.power_administrative_state = None
                                                                                                                self.card_operational_state = None
                                                                                                                self.card_monitor_state = None
                                                                                                                self.card_reset_reason = None
                                                                                                                self.power_current_measurement = None
                                                                                                                self.power_operational_state = None

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                            class CardUpTime(_Entity_):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo']['meta_info']


                                                                                                        class InvEepromInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: form_factor
                                                                                                            
                                                                                                            	Optics form factor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: connector_type
                                                                                                            
                                                                                                            	Connector type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: otn_application_code
                                                                                                            
                                                                                                            	Otn Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: sonet_application_code
                                                                                                            
                                                                                                            	Sonet Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ethernet_compliance_code
                                                                                                            
                                                                                                            	Ethernet Compliance Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: date_string
                                                                                                            
                                                                                                            	Date string in IDPROM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.inv_card_type = None
                                                                                                                self.opaque_data = None
                                                                                                                self.opaque_data_size = None
                                                                                                                self.has_eeprom = None
                                                                                                                self.description = None
                                                                                                                self.form_factor = None
                                                                                                                self.connector_type = None
                                                                                                                self.otn_application_code = None
                                                                                                                self.sonet_application_code = None
                                                                                                                self.ethernet_compliance_code = None
                                                                                                                self.date_string = None

                                                                                                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                            class Eeprom(_Entity_):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci_alpha_number
                                                                                                                
                                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                    ])
                                                                                                                    self.description = None
                                                                                                                    self.idprom_format_rev = None
                                                                                                                    self.controller_family = None
                                                                                                                    self.controller_type = None
                                                                                                                    self.vid = None
                                                                                                                    self.hwid = None
                                                                                                                    self.pid = None
                                                                                                                    self.udi_description = None
                                                                                                                    self.udi_name = None
                                                                                                                    self.clei = None
                                                                                                                    self.eci = None
                                                                                                                    self.top_assem_part_num = None
                                                                                                                    self.top_assem_vid = None
                                                                                                                    self.pca_num = None
                                                                                                                    self.pcavid = None
                                                                                                                    self.chassis_sid = None
                                                                                                                    self.dev_num1 = None
                                                                                                                    self.dev_num2 = None
                                                                                                                    self.dev_num3 = None
                                                                                                                    self.dev_num4 = None
                                                                                                                    self.dev_num5 = None
                                                                                                                    self.dev_num6 = None
                                                                                                                    self.dev_num7 = None
                                                                                                                    self.manu_test_data = None
                                                                                                                    self.asset_id = None
                                                                                                                    self.asset_alias = None
                                                                                                                    self.base_mac_address1 = None
                                                                                                                    self.mac_add_blk_size1 = None
                                                                                                                    self.base_mac_address2 = None
                                                                                                                    self.mac_add_blk_size2 = None
                                                                                                                    self.base_mac_address3 = None
                                                                                                                    self.mac_add_blk_size3 = None
                                                                                                                    self.base_mac_address4 = None
                                                                                                                    self.mac_add_blk_size4 = None
                                                                                                                    self.pcb_serial_num = None
                                                                                                                    self.power_supply_type = None
                                                                                                                    self.power_consumption = None
                                                                                                                    self.block_signature = None
                                                                                                                    self.block_version = None
                                                                                                                    self.block_length = None
                                                                                                                    self.block_checksum = None
                                                                                                                    self.eeprom_size = None
                                                                                                                    self.block_count = None
                                                                                                                    self.fru_major_type = None
                                                                                                                    self.fru_minor_type = None
                                                                                                                    self.oem_string = None
                                                                                                                    self.product_id = None
                                                                                                                    self.serial_number = None
                                                                                                                    self.part_number = None
                                                                                                                    self.part_revision = None
                                                                                                                    self.mfg_deviation = None
                                                                                                                    self.hw_version = None
                                                                                                                    self.mfg_bits = None
                                                                                                                    self.engineer_use = None
                                                                                                                    self.snmpoid = None
                                                                                                                    self.rma_code = None
                                                                                                                    self.eci_alpha_number = None

                                                                                                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                class Rma(_Entity_):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.test_history = None
                                                                                                                        self.rma_number = None
                                                                                                                        self.rma_history = None
                                                                                                                        self._segment_path = lambda: "rma"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s']['meta_info']


                                                                                            class Attributes(_Entity_):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, [], name, value)


                                                                                                class InvBasicBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: allocated_power
                                                                                                    
                                                                                                    	Allocated power for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_capacity
                                                                                                    
                                                                                                    	Power Capacity of a Power Module
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.vendor_type = None
                                                                                                        self.name = None
                                                                                                        self.hardware_revision = None
                                                                                                        self.firmware_revision = None
                                                                                                        self.software_revision = None
                                                                                                        self.chip_hardware_revision = None
                                                                                                        self.serial_number = None
                                                                                                        self.manufacturer_name = None
                                                                                                        self.model_name = None
                                                                                                        self.asset_id_str = None
                                                                                                        self.asset_identification = None
                                                                                                        self.is_field_replaceable_unit = None
                                                                                                        self.manufacturer_asset_tags = None
                                                                                                        self.composite_class_code = None
                                                                                                        self.memory_size = None
                                                                                                        self.environmental_monitor_path = None
                                                                                                        self.alias = None
                                                                                                        self.group_flag = None
                                                                                                        self.new_deviation_number = None
                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                        self.unrecognized_fru = None
                                                                                                        self.redundancystate = None
                                                                                                        self.ceport = None
                                                                                                        self.xr_scoped = None
                                                                                                        self.unique_id = None
                                                                                                        self.allocated_power = None
                                                                                                        self.power_capacity = None
                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag']['meta_info']


                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: average
                                                                                                    
                                                                                                    	Average sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minimum
                                                                                                    
                                                                                                    	Minimum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: maximum
                                                                                                    
                                                                                                    	Maximum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: interval
                                                                                                    
                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                        ])
                                                                                                        self.field_validity_bitmap = None
                                                                                                        self.device_description = None
                                                                                                        self.units = None
                                                                                                        self.device_id = None
                                                                                                        self.value = None
                                                                                                        self.alarm_type = None
                                                                                                        self.data_type = None
                                                                                                        self.scale = None
                                                                                                        self.precision = None
                                                                                                        self.status = None
                                                                                                        self.age_time_stamp = None
                                                                                                        self.update_rate = None
                                                                                                        self.average = None
                                                                                                        self.minimum = None
                                                                                                        self.maximum = None
                                                                                                        self.interval = None
                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo']['meta_info']


                                                                                                class PwgInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                        ])
                                                                                                        self.power_group_redundancy_mode = None
                                                                                                        self.power_group_power_units = None
                                                                                                        self.power_group_available_current = None
                                                                                                        self.power_group_drawn_current = None
                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo']['meta_info']


                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.units = None
                                                                                                        self.value = None
                                                                                                        self.data_type = None
                                                                                                        self.status = None
                                                                                                        self.update_rate = None

                                                                                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                    class Threshold(_Entity_):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.threshold_array = YList(self)
                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                        class ThresholdArray(_Entity_):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_name = None
                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                class InvAssetBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.part_number = None
                                                                                                        self.manufacturer_assembly_number = None
                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                        self.manufacturer_software_identifier = None
                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag']['meta_info']


                                                                                                class Threshold(_Entity_):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, [], name, value)


                                                                                                    class MajorLo(_Entity_):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                    class CriticalHi(_Entity_):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                    class MinorHi(_Entity_):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                    class MajorHi(_Entity_):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                    class CriticalLo(_Entity_):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                    class MinorLo(_Entity_):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold']['meta_info']


                                                                                                class FruInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                        ])
                                                                                                        self.card_administrative_state = None
                                                                                                        self.power_administrative_state = None
                                                                                                        self.card_operational_state = None
                                                                                                        self.card_monitor_state = None
                                                                                                        self.card_reset_reason = None
                                                                                                        self.power_current_measurement = None
                                                                                                        self.power_operational_state = None

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                    class CardUpTime(_Entity_):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo']['meta_info']


                                                                                                class InvEepromInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: form_factor
                                                                                                    
                                                                                                    	Optics form factor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: connector_type
                                                                                                    
                                                                                                    	Connector type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: otn_application_code
                                                                                                    
                                                                                                    	Otn Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: sonet_application_code
                                                                                                    
                                                                                                    	Sonet Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                    
                                                                                                    	Ethernet Compliance Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: date_string
                                                                                                    
                                                                                                    	Date string in IDPROM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.inv_card_type = None
                                                                                                        self.opaque_data = None
                                                                                                        self.opaque_data_size = None
                                                                                                        self.has_eeprom = None
                                                                                                        self.description = None
                                                                                                        self.form_factor = None
                                                                                                        self.connector_type = None
                                                                                                        self.otn_application_code = None
                                                                                                        self.sonet_application_code = None
                                                                                                        self.ethernet_compliance_code = None
                                                                                                        self.date_string = None

                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                    class Eeprom(_Entity_):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci_alpha_number
                                                                                                        
                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                            ])
                                                                                                            self.description = None
                                                                                                            self.idprom_format_rev = None
                                                                                                            self.controller_family = None
                                                                                                            self.controller_type = None
                                                                                                            self.vid = None
                                                                                                            self.hwid = None
                                                                                                            self.pid = None
                                                                                                            self.udi_description = None
                                                                                                            self.udi_name = None
                                                                                                            self.clei = None
                                                                                                            self.eci = None
                                                                                                            self.top_assem_part_num = None
                                                                                                            self.top_assem_vid = None
                                                                                                            self.pca_num = None
                                                                                                            self.pcavid = None
                                                                                                            self.chassis_sid = None
                                                                                                            self.dev_num1 = None
                                                                                                            self.dev_num2 = None
                                                                                                            self.dev_num3 = None
                                                                                                            self.dev_num4 = None
                                                                                                            self.dev_num5 = None
                                                                                                            self.dev_num6 = None
                                                                                                            self.dev_num7 = None
                                                                                                            self.manu_test_data = None
                                                                                                            self.asset_id = None
                                                                                                            self.asset_alias = None
                                                                                                            self.base_mac_address1 = None
                                                                                                            self.mac_add_blk_size1 = None
                                                                                                            self.base_mac_address2 = None
                                                                                                            self.mac_add_blk_size2 = None
                                                                                                            self.base_mac_address3 = None
                                                                                                            self.mac_add_blk_size3 = None
                                                                                                            self.base_mac_address4 = None
                                                                                                            self.mac_add_blk_size4 = None
                                                                                                            self.pcb_serial_num = None
                                                                                                            self.power_supply_type = None
                                                                                                            self.power_consumption = None
                                                                                                            self.block_signature = None
                                                                                                            self.block_version = None
                                                                                                            self.block_length = None
                                                                                                            self.block_checksum = None
                                                                                                            self.eeprom_size = None
                                                                                                            self.block_count = None
                                                                                                            self.fru_major_type = None
                                                                                                            self.fru_minor_type = None
                                                                                                            self.oem_string = None
                                                                                                            self.product_id = None
                                                                                                            self.serial_number = None
                                                                                                            self.part_number = None
                                                                                                            self.part_revision = None
                                                                                                            self.mfg_deviation = None
                                                                                                            self.hw_version = None
                                                                                                            self.mfg_bits = None
                                                                                                            self.engineer_use = None
                                                                                                            self.snmpoid = None
                                                                                                            self.rma_code = None
                                                                                                            self.eci_alpha_number = None

                                                                                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                        class Rma(_Entity_):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                ])
                                                                                                                self.test_history = None
                                                                                                                self.rma_number = None
                                                                                                                self.rma_history = None
                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s']['meta_info']


                                                                                    class Attributes(_Entity_):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._segment_path = lambda: "attributes"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, [], name, value)


                                                                                        class InvBasicBag(_Entity_):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: allocated_power
                                                                                            
                                                                                            	Allocated power for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_capacity
                                                                                            
                                                                                            	Power Capacity of a Power Module
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.vendor_type = None
                                                                                                self.name = None
                                                                                                self.hardware_revision = None
                                                                                                self.firmware_revision = None
                                                                                                self.software_revision = None
                                                                                                self.chip_hardware_revision = None
                                                                                                self.serial_number = None
                                                                                                self.manufacturer_name = None
                                                                                                self.model_name = None
                                                                                                self.asset_id_str = None
                                                                                                self.asset_identification = None
                                                                                                self.is_field_replaceable_unit = None
                                                                                                self.manufacturer_asset_tags = None
                                                                                                self.composite_class_code = None
                                                                                                self.memory_size = None
                                                                                                self.environmental_monitor_path = None
                                                                                                self.alias = None
                                                                                                self.group_flag = None
                                                                                                self.new_deviation_number = None
                                                                                                self.physical_layer_interface_module_type = None
                                                                                                self.unrecognized_fru = None
                                                                                                self.redundancystate = None
                                                                                                self.ceport = None
                                                                                                self.xr_scoped = None
                                                                                                self.unique_id = None
                                                                                                self.allocated_power = None
                                                                                                self.power_capacity = None
                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag']['meta_info']


                                                                                        class EnvSensorInfo(_Entity_):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: average
                                                                                            
                                                                                            	Average sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minimum
                                                                                            
                                                                                            	Minimum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: maximum
                                                                                            
                                                                                            	Maximum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: interval
                                                                                            
                                                                                            	Time Interval over which sensor value is monitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                ])
                                                                                                self.field_validity_bitmap = None
                                                                                                self.device_description = None
                                                                                                self.units = None
                                                                                                self.device_id = None
                                                                                                self.value = None
                                                                                                self.alarm_type = None
                                                                                                self.data_type = None
                                                                                                self.scale = None
                                                                                                self.precision = None
                                                                                                self.status = None
                                                                                                self.age_time_stamp = None
                                                                                                self.update_rate = None
                                                                                                self.average = None
                                                                                                self.minimum = None
                                                                                                self.maximum = None
                                                                                                self.interval = None
                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo']['meta_info']


                                                                                        class PwgInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                ])
                                                                                                self.power_group_redundancy_mode = None
                                                                                                self.power_group_power_units = None
                                                                                                self.power_group_available_current = None
                                                                                                self.power_group_drawn_current = None
                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo']['meta_info']


                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.units = None
                                                                                                self.value = None
                                                                                                self.data_type = None
                                                                                                self.status = None
                                                                                                self.update_rate = None

                                                                                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                            class Threshold(_Entity_):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.threshold_array = YList(self)
                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                class ThresholdArray(_Entity_):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_name = None
                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                        class InvAssetBag(_Entity_):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                ])
                                                                                                self.part_number = None
                                                                                                self.manufacturer_assembly_number = None
                                                                                                self.manufacturer_assembly_revision = None
                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                self.manufacturer_software_identifier = None
                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag']['meta_info']


                                                                                        class Threshold(_Entity_):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._segment_path = lambda: "threshold"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, [], name, value)


                                                                                            class MajorLo(_Entity_):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo']['meta_info']


                                                                                            class CriticalHi(_Entity_):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                            class MinorHi(_Entity_):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi']['meta_info']


                                                                                            class MajorHi(_Entity_):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi']['meta_info']


                                                                                            class CriticalLo(_Entity_):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                            class MinorLo(_Entity_):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold']['meta_info']


                                                                                        class FruInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                ])
                                                                                                self.card_administrative_state = None
                                                                                                self.power_administrative_state = None
                                                                                                self.card_operational_state = None
                                                                                                self.card_monitor_state = None
                                                                                                self.card_reset_reason = None
                                                                                                self.power_current_measurement = None
                                                                                                self.power_operational_state = None

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                            class CardUpTime(_Entity_):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo']['meta_info']


                                                                                        class InvEepromInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: form_factor
                                                                                            
                                                                                            	Optics form factor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: connector_type
                                                                                            
                                                                                            	Connector type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: otn_application_code
                                                                                            
                                                                                            	Otn Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: sonet_application_code
                                                                                            
                                                                                            	Sonet Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ethernet_compliance_code
                                                                                            
                                                                                            	Ethernet Compliance Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: date_string
                                                                                            
                                                                                            	Date string in IDPROM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                ])
                                                                                                self.inv_card_type = None
                                                                                                self.opaque_data = None
                                                                                                self.opaque_data_size = None
                                                                                                self.has_eeprom = None
                                                                                                self.description = None
                                                                                                self.form_factor = None
                                                                                                self.connector_type = None
                                                                                                self.otn_application_code = None
                                                                                                self.sonet_application_code = None
                                                                                                self.ethernet_compliance_code = None
                                                                                                self.date_string = None

                                                                                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                            class Eeprom(_Entity_):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci_alpha_number
                                                                                                
                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                    ])
                                                                                                    self.description = None
                                                                                                    self.idprom_format_rev = None
                                                                                                    self.controller_family = None
                                                                                                    self.controller_type = None
                                                                                                    self.vid = None
                                                                                                    self.hwid = None
                                                                                                    self.pid = None
                                                                                                    self.udi_description = None
                                                                                                    self.udi_name = None
                                                                                                    self.clei = None
                                                                                                    self.eci = None
                                                                                                    self.top_assem_part_num = None
                                                                                                    self.top_assem_vid = None
                                                                                                    self.pca_num = None
                                                                                                    self.pcavid = None
                                                                                                    self.chassis_sid = None
                                                                                                    self.dev_num1 = None
                                                                                                    self.dev_num2 = None
                                                                                                    self.dev_num3 = None
                                                                                                    self.dev_num4 = None
                                                                                                    self.dev_num5 = None
                                                                                                    self.dev_num6 = None
                                                                                                    self.dev_num7 = None
                                                                                                    self.manu_test_data = None
                                                                                                    self.asset_id = None
                                                                                                    self.asset_alias = None
                                                                                                    self.base_mac_address1 = None
                                                                                                    self.mac_add_blk_size1 = None
                                                                                                    self.base_mac_address2 = None
                                                                                                    self.mac_add_blk_size2 = None
                                                                                                    self.base_mac_address3 = None
                                                                                                    self.mac_add_blk_size3 = None
                                                                                                    self.base_mac_address4 = None
                                                                                                    self.mac_add_blk_size4 = None
                                                                                                    self.pcb_serial_num = None
                                                                                                    self.power_supply_type = None
                                                                                                    self.power_consumption = None
                                                                                                    self.block_signature = None
                                                                                                    self.block_version = None
                                                                                                    self.block_length = None
                                                                                                    self.block_checksum = None
                                                                                                    self.eeprom_size = None
                                                                                                    self.block_count = None
                                                                                                    self.fru_major_type = None
                                                                                                    self.fru_minor_type = None
                                                                                                    self.oem_string = None
                                                                                                    self.product_id = None
                                                                                                    self.serial_number = None
                                                                                                    self.part_number = None
                                                                                                    self.part_revision = None
                                                                                                    self.mfg_deviation = None
                                                                                                    self.hw_version = None
                                                                                                    self.mfg_bits = None
                                                                                                    self.engineer_use = None
                                                                                                    self.snmpoid = None
                                                                                                    self.rma_code = None
                                                                                                    self.eci_alpha_number = None

                                                                                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                class Rma(_Entity_):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                        ])
                                                                                                        self.test_history = None
                                                                                                        self.rma_number = None
                                                                                                        self.rma_history = None
                                                                                                        self._segment_path = lambda: "rma"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s']['meta_info']


                                                                            class Attributes(_Entity_):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._segment_path = lambda: "attributes"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, [], name, value)


                                                                                class InvBasicBag(_Entity_):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: allocated_power
                                                                                    
                                                                                    	Allocated power for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_capacity
                                                                                    
                                                                                    	Power Capacity of a Power Module
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.vendor_type = None
                                                                                        self.name = None
                                                                                        self.hardware_revision = None
                                                                                        self.firmware_revision = None
                                                                                        self.software_revision = None
                                                                                        self.chip_hardware_revision = None
                                                                                        self.serial_number = None
                                                                                        self.manufacturer_name = None
                                                                                        self.model_name = None
                                                                                        self.asset_id_str = None
                                                                                        self.asset_identification = None
                                                                                        self.is_field_replaceable_unit = None
                                                                                        self.manufacturer_asset_tags = None
                                                                                        self.composite_class_code = None
                                                                                        self.memory_size = None
                                                                                        self.environmental_monitor_path = None
                                                                                        self.alias = None
                                                                                        self.group_flag = None
                                                                                        self.new_deviation_number = None
                                                                                        self.physical_layer_interface_module_type = None
                                                                                        self.unrecognized_fru = None
                                                                                        self.redundancystate = None
                                                                                        self.ceport = None
                                                                                        self.xr_scoped = None
                                                                                        self.unique_id = None
                                                                                        self.allocated_power = None
                                                                                        self.power_capacity = None
                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag']['meta_info']


                                                                                class EnvSensorInfo(_Entity_):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: average
                                                                                    
                                                                                    	Average sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minimum
                                                                                    
                                                                                    	Minimum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: maximum
                                                                                    
                                                                                    	Maximum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: interval
                                                                                    
                                                                                    	Time Interval over which sensor value is monitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                        ])
                                                                                        self.field_validity_bitmap = None
                                                                                        self.device_description = None
                                                                                        self.units = None
                                                                                        self.device_id = None
                                                                                        self.value = None
                                                                                        self.alarm_type = None
                                                                                        self.data_type = None
                                                                                        self.scale = None
                                                                                        self.precision = None
                                                                                        self.status = None
                                                                                        self.age_time_stamp = None
                                                                                        self.update_rate = None
                                                                                        self.average = None
                                                                                        self.minimum = None
                                                                                        self.maximum = None
                                                                                        self.interval = None
                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo']['meta_info']


                                                                                class PwgInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                        ])
                                                                                        self.power_group_redundancy_mode = None
                                                                                        self.power_group_power_units = None
                                                                                        self.power_group_available_current = None
                                                                                        self.power_group_drawn_current = None
                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo']['meta_info']


                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.units = None
                                                                                        self.value = None
                                                                                        self.data_type = None
                                                                                        self.status = None
                                                                                        self.update_rate = None

                                                                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                    class Threshold(_Entity_):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.threshold_array = YList(self)
                                                                                            self._segment_path = lambda: "threshold"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                        class ThresholdArray(_Entity_):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_name = None
                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                class InvAssetBag(_Entity_):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                        ])
                                                                                        self.part_number = None
                                                                                        self.manufacturer_assembly_number = None
                                                                                        self.manufacturer_assembly_revision = None
                                                                                        self.manufacturer_firmware_identifier = None
                                                                                        self.manufacturer_software_identifier = None
                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                        self.original_equipment_manufacturer_string = None
                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag']['meta_info']


                                                                                class Threshold(_Entity_):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._segment_path = lambda: "threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, [], name, value)


                                                                                    class MajorLo(_Entity_):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo']['meta_info']


                                                                                    class CriticalHi(_Entity_):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                    class MinorHi(_Entity_):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi']['meta_info']


                                                                                    class MajorHi(_Entity_):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi']['meta_info']


                                                                                    class CriticalLo(_Entity_):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                    class MinorLo(_Entity_):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold']['meta_info']


                                                                                class FruInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                        ])
                                                                                        self.card_administrative_state = None
                                                                                        self.power_administrative_state = None
                                                                                        self.card_operational_state = None
                                                                                        self.card_monitor_state = None
                                                                                        self.card_reset_reason = None
                                                                                        self.power_current_measurement = None
                                                                                        self.power_operational_state = None

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._segment_path = lambda: "fru-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                    class CardUpTime(_Entity_):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo']['meta_info']


                                                                                class InvEepromInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: form_factor
                                                                                    
                                                                                    	Optics form factor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: connector_type
                                                                                    
                                                                                    	Connector type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: otn_application_code
                                                                                    
                                                                                    	Otn Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: sonet_application_code
                                                                                    
                                                                                    	Sonet Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ethernet_compliance_code
                                                                                    
                                                                                    	Ethernet Compliance Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: date_string
                                                                                    
                                                                                    	Date string in IDPROM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                        ])
                                                                                        self.inv_card_type = None
                                                                                        self.opaque_data = None
                                                                                        self.opaque_data_size = None
                                                                                        self.has_eeprom = None
                                                                                        self.description = None
                                                                                        self.form_factor = None
                                                                                        self.connector_type = None
                                                                                        self.otn_application_code = None
                                                                                        self.sonet_application_code = None
                                                                                        self.ethernet_compliance_code = None
                                                                                        self.date_string = None

                                                                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                    class Eeprom(_Entity_):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci_alpha_number
                                                                                        
                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                            ])
                                                                                            self.description = None
                                                                                            self.idprom_format_rev = None
                                                                                            self.controller_family = None
                                                                                            self.controller_type = None
                                                                                            self.vid = None
                                                                                            self.hwid = None
                                                                                            self.pid = None
                                                                                            self.udi_description = None
                                                                                            self.udi_name = None
                                                                                            self.clei = None
                                                                                            self.eci = None
                                                                                            self.top_assem_part_num = None
                                                                                            self.top_assem_vid = None
                                                                                            self.pca_num = None
                                                                                            self.pcavid = None
                                                                                            self.chassis_sid = None
                                                                                            self.dev_num1 = None
                                                                                            self.dev_num2 = None
                                                                                            self.dev_num3 = None
                                                                                            self.dev_num4 = None
                                                                                            self.dev_num5 = None
                                                                                            self.dev_num6 = None
                                                                                            self.dev_num7 = None
                                                                                            self.manu_test_data = None
                                                                                            self.asset_id = None
                                                                                            self.asset_alias = None
                                                                                            self.base_mac_address1 = None
                                                                                            self.mac_add_blk_size1 = None
                                                                                            self.base_mac_address2 = None
                                                                                            self.mac_add_blk_size2 = None
                                                                                            self.base_mac_address3 = None
                                                                                            self.mac_add_blk_size3 = None
                                                                                            self.base_mac_address4 = None
                                                                                            self.mac_add_blk_size4 = None
                                                                                            self.pcb_serial_num = None
                                                                                            self.power_supply_type = None
                                                                                            self.power_consumption = None
                                                                                            self.block_signature = None
                                                                                            self.block_version = None
                                                                                            self.block_length = None
                                                                                            self.block_checksum = None
                                                                                            self.eeprom_size = None
                                                                                            self.block_count = None
                                                                                            self.fru_major_type = None
                                                                                            self.fru_minor_type = None
                                                                                            self.oem_string = None
                                                                                            self.product_id = None
                                                                                            self.serial_number = None
                                                                                            self.part_number = None
                                                                                            self.part_revision = None
                                                                                            self.mfg_deviation = None
                                                                                            self.hw_version = None
                                                                                            self.mfg_bits = None
                                                                                            self.engineer_use = None
                                                                                            self.snmpoid = None
                                                                                            self.rma_code = None
                                                                                            self.eci_alpha_number = None

                                                                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._segment_path = lambda: "eeprom"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                        class Rma(_Entity_):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                ])
                                                                                                self.test_history = None
                                                                                                self.rma_number = None
                                                                                                self.rma_history = None
                                                                                                self._segment_path = lambda: "rma"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s']['meta_info']


                                                                    class Attributes(_Entity_):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"

                                                                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._segment_path = lambda: "attributes"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, [], name, value)


                                                                        class InvBasicBag(_Entity_):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: allocated_power
                                                                            
                                                                            	Allocated power for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_capacity
                                                                            
                                                                            	Power Capacity of a Power Module
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.vendor_type = None
                                                                                self.name = None
                                                                                self.hardware_revision = None
                                                                                self.firmware_revision = None
                                                                                self.software_revision = None
                                                                                self.chip_hardware_revision = None
                                                                                self.serial_number = None
                                                                                self.manufacturer_name = None
                                                                                self.model_name = None
                                                                                self.asset_id_str = None
                                                                                self.asset_identification = None
                                                                                self.is_field_replaceable_unit = None
                                                                                self.manufacturer_asset_tags = None
                                                                                self.composite_class_code = None
                                                                                self.memory_size = None
                                                                                self.environmental_monitor_path = None
                                                                                self.alias = None
                                                                                self.group_flag = None
                                                                                self.new_deviation_number = None
                                                                                self.physical_layer_interface_module_type = None
                                                                                self.unrecognized_fru = None
                                                                                self.redundancystate = None
                                                                                self.ceport = None
                                                                                self.xr_scoped = None
                                                                                self.unique_id = None
                                                                                self.allocated_power = None
                                                                                self.power_capacity = None
                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag']['meta_info']


                                                                        class EnvSensorInfo(_Entity_):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: average
                                                                            
                                                                            	Average sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minimum
                                                                            
                                                                            	Minimum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: maximum
                                                                            
                                                                            	Maximum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: interval
                                                                            
                                                                            	Time Interval over which sensor value is monitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                ])
                                                                                self.field_validity_bitmap = None
                                                                                self.device_description = None
                                                                                self.units = None
                                                                                self.device_id = None
                                                                                self.value = None
                                                                                self.alarm_type = None
                                                                                self.data_type = None
                                                                                self.scale = None
                                                                                self.precision = None
                                                                                self.status = None
                                                                                self.age_time_stamp = None
                                                                                self.update_rate = None
                                                                                self.average = None
                                                                                self.minimum = None
                                                                                self.maximum = None
                                                                                self.interval = None
                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo']['meta_info']


                                                                        class PwgInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\: str
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                ])
                                                                                self.power_group_redundancy_mode = None
                                                                                self.power_group_power_units = None
                                                                                self.power_group_available_current = None
                                                                                self.power_group_drawn_current = None
                                                                                self._segment_path = lambda: "pwg-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo']['meta_info']


                                                                        class EnvSensorInfoXml(_Entity_):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.units = None
                                                                                self.value = None
                                                                                self.data_type = None
                                                                                self.status = None
                                                                                self.update_rate = None

                                                                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                            class Threshold(_Entity_):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.threshold_array = YList(self)
                                                                                    self._segment_path = lambda: "threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                class ThresholdArray(_Entity_):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_name = None
                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml']['meta_info']


                                                                        class InvAssetBag(_Entity_):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                ])
                                                                                self.part_number = None
                                                                                self.manufacturer_assembly_number = None
                                                                                self.manufacturer_assembly_revision = None
                                                                                self.manufacturer_firmware_identifier = None
                                                                                self.manufacturer_software_identifier = None
                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                self.original_equipment_manufacturer_string = None
                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag']['meta_info']


                                                                        class Threshold(_Entity_):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._segment_path = lambda: "threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, [], name, value)


                                                                            class MajorLo(_Entity_):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo']['meta_info']


                                                                            class CriticalHi(_Entity_):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi']['meta_info']


                                                                            class MinorHi(_Entity_):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi']['meta_info']


                                                                            class MajorHi(_Entity_):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi']['meta_info']


                                                                            class CriticalLo(_Entity_):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo']['meta_info']


                                                                            class MinorLo(_Entity_):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold']['meta_info']


                                                                        class FruInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                ])
                                                                                self.card_administrative_state = None
                                                                                self.power_administrative_state = None
                                                                                self.card_operational_state = None
                                                                                self.card_monitor_state = None
                                                                                self.card_reset_reason = None
                                                                                self.power_current_measurement = None
                                                                                self.power_operational_state = None

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._segment_path = lambda: "fru-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                            class LastOperationalStateChange(_Entity_):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                            class CardUpTime(_Entity_):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo']['meta_info']


                                                                        class InvEepromInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: form_factor
                                                                            
                                                                            	Optics form factor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: connector_type
                                                                            
                                                                            	Connector type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: otn_application_code
                                                                            
                                                                            	Otn Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: sonet_application_code
                                                                            
                                                                            	Sonet Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ethernet_compliance_code
                                                                            
                                                                            	Ethernet Compliance Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: date_string
                                                                            
                                                                            	Date string in IDPROM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                ])
                                                                                self.inv_card_type = None
                                                                                self.opaque_data = None
                                                                                self.opaque_data_size = None
                                                                                self.has_eeprom = None
                                                                                self.description = None
                                                                                self.form_factor = None
                                                                                self.connector_type = None
                                                                                self.otn_application_code = None
                                                                                self.sonet_application_code = None
                                                                                self.ethernet_compliance_code = None
                                                                                self.date_string = None

                                                                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                            class Eeprom(_Entity_):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci_alpha_number
                                                                                
                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                    ])
                                                                                    self.description = None
                                                                                    self.idprom_format_rev = None
                                                                                    self.controller_family = None
                                                                                    self.controller_type = None
                                                                                    self.vid = None
                                                                                    self.hwid = None
                                                                                    self.pid = None
                                                                                    self.udi_description = None
                                                                                    self.udi_name = None
                                                                                    self.clei = None
                                                                                    self.eci = None
                                                                                    self.top_assem_part_num = None
                                                                                    self.top_assem_vid = None
                                                                                    self.pca_num = None
                                                                                    self.pcavid = None
                                                                                    self.chassis_sid = None
                                                                                    self.dev_num1 = None
                                                                                    self.dev_num2 = None
                                                                                    self.dev_num3 = None
                                                                                    self.dev_num4 = None
                                                                                    self.dev_num5 = None
                                                                                    self.dev_num6 = None
                                                                                    self.dev_num7 = None
                                                                                    self.manu_test_data = None
                                                                                    self.asset_id = None
                                                                                    self.asset_alias = None
                                                                                    self.base_mac_address1 = None
                                                                                    self.mac_add_blk_size1 = None
                                                                                    self.base_mac_address2 = None
                                                                                    self.mac_add_blk_size2 = None
                                                                                    self.base_mac_address3 = None
                                                                                    self.mac_add_blk_size3 = None
                                                                                    self.base_mac_address4 = None
                                                                                    self.mac_add_blk_size4 = None
                                                                                    self.pcb_serial_num = None
                                                                                    self.power_supply_type = None
                                                                                    self.power_consumption = None
                                                                                    self.block_signature = None
                                                                                    self.block_version = None
                                                                                    self.block_length = None
                                                                                    self.block_checksum = None
                                                                                    self.eeprom_size = None
                                                                                    self.block_count = None
                                                                                    self.fru_major_type = None
                                                                                    self.fru_minor_type = None
                                                                                    self.oem_string = None
                                                                                    self.product_id = None
                                                                                    self.serial_number = None
                                                                                    self.part_number = None
                                                                                    self.part_revision = None
                                                                                    self.mfg_deviation = None
                                                                                    self.hw_version = None
                                                                                    self.mfg_bits = None
                                                                                    self.engineer_use = None
                                                                                    self.snmpoid = None
                                                                                    self.rma_code = None
                                                                                    self.eci_alpha_number = None

                                                                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._segment_path = lambda: "eeprom"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                class Rma(_Entity_):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                        ])
                                                                                        self.test_history = None
                                                                                        self.rma_number = None
                                                                                        self.rma_history = None
                                                                                        self._segment_path = lambda: "rma"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s']['meta_info']


                                                            class Attributes(_Entity_):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"

                                                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._segment_path = lambda: "attributes"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, [], name, value)


                                                                class InvBasicBag(_Entity_):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: allocated_power
                                                                    
                                                                    	Allocated power for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_capacity
                                                                    
                                                                    	Power Capacity of a Power Module
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.vendor_type = None
                                                                        self.name = None
                                                                        self.hardware_revision = None
                                                                        self.firmware_revision = None
                                                                        self.software_revision = None
                                                                        self.chip_hardware_revision = None
                                                                        self.serial_number = None
                                                                        self.manufacturer_name = None
                                                                        self.model_name = None
                                                                        self.asset_id_str = None
                                                                        self.asset_identification = None
                                                                        self.is_field_replaceable_unit = None
                                                                        self.manufacturer_asset_tags = None
                                                                        self.composite_class_code = None
                                                                        self.memory_size = None
                                                                        self.environmental_monitor_path = None
                                                                        self.alias = None
                                                                        self.group_flag = None
                                                                        self.new_deviation_number = None
                                                                        self.physical_layer_interface_module_type = None
                                                                        self.unrecognized_fru = None
                                                                        self.redundancystate = None
                                                                        self.ceport = None
                                                                        self.xr_scoped = None
                                                                        self.unique_id = None
                                                                        self.allocated_power = None
                                                                        self.power_capacity = None
                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag']['meta_info']


                                                                class EnvSensorInfo(_Entity_):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: average
                                                                    
                                                                    	Average sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minimum
                                                                    
                                                                    	Minimum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: maximum
                                                                    
                                                                    	Maximum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: interval
                                                                    
                                                                    	Time Interval over which sensor value is monitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                        ])
                                                                        self.field_validity_bitmap = None
                                                                        self.device_description = None
                                                                        self.units = None
                                                                        self.device_id = None
                                                                        self.value = None
                                                                        self.alarm_type = None
                                                                        self.data_type = None
                                                                        self.scale = None
                                                                        self.precision = None
                                                                        self.status = None
                                                                        self.age_time_stamp = None
                                                                        self.update_rate = None
                                                                        self.average = None
                                                                        self.minimum = None
                                                                        self.maximum = None
                                                                        self.interval = None
                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo']['meta_info']


                                                                class PwgInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\: str
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                        ])
                                                                        self.power_group_redundancy_mode = None
                                                                        self.power_group_power_units = None
                                                                        self.power_group_available_current = None
                                                                        self.power_group_drawn_current = None
                                                                        self._segment_path = lambda: "pwg-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo']['meta_info']


                                                                class EnvSensorInfoXml(_Entity_):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.units = None
                                                                        self.value = None
                                                                        self.data_type = None
                                                                        self.status = None
                                                                        self.update_rate = None

                                                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                    class Threshold(_Entity_):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.threshold_array = YList(self)
                                                                            self._segment_path = lambda: "threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                        class ThresholdArray(_Entity_):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_name = None
                                                                                self._segment_path = lambda: "threshold-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml']['meta_info']


                                                                class InvAssetBag(_Entity_):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                        ])
                                                                        self.part_number = None
                                                                        self.manufacturer_assembly_number = None
                                                                        self.manufacturer_assembly_revision = None
                                                                        self.manufacturer_firmware_identifier = None
                                                                        self.manufacturer_software_identifier = None
                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                        self.original_equipment_manufacturer_string = None
                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag']['meta_info']


                                                                class Threshold(_Entity_):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._segment_path = lambda: "threshold"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, [], name, value)


                                                                    class MajorLo(_Entity_):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo']['meta_info']


                                                                    class CriticalHi(_Entity_):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi']['meta_info']


                                                                    class MinorHi(_Entity_):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi']['meta_info']


                                                                    class MajorHi(_Entity_):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi']['meta_info']


                                                                    class CriticalLo(_Entity_):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo']['meta_info']


                                                                    class MinorLo(_Entity_):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold']['meta_info']


                                                                class FruInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime))])
                                                                        self._leafs = OrderedDict([
                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                        ])
                                                                        self.card_administrative_state = None
                                                                        self.power_administrative_state = None
                                                                        self.card_operational_state = None
                                                                        self.card_monitor_state = None
                                                                        self.card_reset_reason = None
                                                                        self.power_current_measurement = None
                                                                        self.power_operational_state = None

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._segment_path = lambda: "fru-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                    class LastOperationalStateChange(_Entity_):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                    class CardUpTime(_Entity_):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "card-up-time"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo']['meta_info']


                                                                class InvEepromInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: form_factor
                                                                    
                                                                    	Optics form factor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: connector_type
                                                                    
                                                                    	Connector type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: otn_application_code
                                                                    
                                                                    	Otn Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: sonet_application_code
                                                                    
                                                                    	Sonet Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ethernet_compliance_code
                                                                    
                                                                    	Ethernet Compliance Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: date_string
                                                                    
                                                                    	Date string in IDPROM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom))])
                                                                        self._leafs = OrderedDict([
                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                        ])
                                                                        self.inv_card_type = None
                                                                        self.opaque_data = None
                                                                        self.opaque_data_size = None
                                                                        self.has_eeprom = None
                                                                        self.description = None
                                                                        self.form_factor = None
                                                                        self.connector_type = None
                                                                        self.otn_application_code = None
                                                                        self.sonet_application_code = None
                                                                        self.ethernet_compliance_code = None
                                                                        self.date_string = None

                                                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                    class Eeprom(_Entity_):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci_alpha_number
                                                                        
                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                            self._leafs = OrderedDict([
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                            ])
                                                                            self.description = None
                                                                            self.idprom_format_rev = None
                                                                            self.controller_family = None
                                                                            self.controller_type = None
                                                                            self.vid = None
                                                                            self.hwid = None
                                                                            self.pid = None
                                                                            self.udi_description = None
                                                                            self.udi_name = None
                                                                            self.clei = None
                                                                            self.eci = None
                                                                            self.top_assem_part_num = None
                                                                            self.top_assem_vid = None
                                                                            self.pca_num = None
                                                                            self.pcavid = None
                                                                            self.chassis_sid = None
                                                                            self.dev_num1 = None
                                                                            self.dev_num2 = None
                                                                            self.dev_num3 = None
                                                                            self.dev_num4 = None
                                                                            self.dev_num5 = None
                                                                            self.dev_num6 = None
                                                                            self.dev_num7 = None
                                                                            self.manu_test_data = None
                                                                            self.asset_id = None
                                                                            self.asset_alias = None
                                                                            self.base_mac_address1 = None
                                                                            self.mac_add_blk_size1 = None
                                                                            self.base_mac_address2 = None
                                                                            self.mac_add_blk_size2 = None
                                                                            self.base_mac_address3 = None
                                                                            self.mac_add_blk_size3 = None
                                                                            self.base_mac_address4 = None
                                                                            self.mac_add_blk_size4 = None
                                                                            self.pcb_serial_num = None
                                                                            self.power_supply_type = None
                                                                            self.power_consumption = None
                                                                            self.block_signature = None
                                                                            self.block_version = None
                                                                            self.block_length = None
                                                                            self.block_checksum = None
                                                                            self.eeprom_size = None
                                                                            self.block_count = None
                                                                            self.fru_major_type = None
                                                                            self.fru_minor_type = None
                                                                            self.oem_string = None
                                                                            self.product_id = None
                                                                            self.serial_number = None
                                                                            self.part_number = None
                                                                            self.part_revision = None
                                                                            self.mfg_deviation = None
                                                                            self.hw_version = None
                                                                            self.mfg_bits = None
                                                                            self.engineer_use = None
                                                                            self.snmpoid = None
                                                                            self.rma_code = None
                                                                            self.eci_alpha_number = None

                                                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._segment_path = lambda: "eeprom"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                        class Rma(_Entity_):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                ])
                                                                                self.test_history = None
                                                                                self.rma_number = None
                                                                                self.rma_history = None
                                                                                self._segment_path = lambda: "rma"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s']['meta_info']


                                                    class Attributes(_Entity_):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo))])
                                                            self._leafs = OrderedDict()

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"

                                                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._segment_path = lambda: "attributes"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, [], name, value)


                                                        class InvBasicBag(_Entity_):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: allocated_power
                                                            
                                                            	Allocated power for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_capacity
                                                            
                                                            	Power Capacity of a Power Module
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.vendor_type = None
                                                                self.name = None
                                                                self.hardware_revision = None
                                                                self.firmware_revision = None
                                                                self.software_revision = None
                                                                self.chip_hardware_revision = None
                                                                self.serial_number = None
                                                                self.manufacturer_name = None
                                                                self.model_name = None
                                                                self.asset_id_str = None
                                                                self.asset_identification = None
                                                                self.is_field_replaceable_unit = None
                                                                self.manufacturer_asset_tags = None
                                                                self.composite_class_code = None
                                                                self.memory_size = None
                                                                self.environmental_monitor_path = None
                                                                self.alias = None
                                                                self.group_flag = None
                                                                self.new_deviation_number = None
                                                                self.physical_layer_interface_module_type = None
                                                                self.unrecognized_fru = None
                                                                self.redundancystate = None
                                                                self.ceport = None
                                                                self.xr_scoped = None
                                                                self.unique_id = None
                                                                self.allocated_power = None
                                                                self.power_capacity = None
                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag']['meta_info']


                                                        class EnvSensorInfo(_Entity_):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: average
                                                            
                                                            	Average sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minimum
                                                            
                                                            	Minimum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: maximum
                                                            
                                                            	Maximum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: interval
                                                            
                                                            	Time Interval over which sensor value is monitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                ])
                                                                self.field_validity_bitmap = None
                                                                self.device_description = None
                                                                self.units = None
                                                                self.device_id = None
                                                                self.value = None
                                                                self.alarm_type = None
                                                                self.data_type = None
                                                                self.scale = None
                                                                self.precision = None
                                                                self.status = None
                                                                self.age_time_stamp = None
                                                                self.update_rate = None
                                                                self.average = None
                                                                self.minimum = None
                                                                self.maximum = None
                                                                self.interval = None
                                                                self._segment_path = lambda: "env-sensor-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo']['meta_info']


                                                        class PwgInfo(_Entity_):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\: str
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                ])
                                                                self.power_group_redundancy_mode = None
                                                                self.power_group_power_units = None
                                                                self.power_group_available_current = None
                                                                self.power_group_drawn_current = None
                                                                self._segment_path = lambda: "pwg-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo']['meta_info']


                                                        class EnvSensorInfoXml(_Entity_):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold))])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.units = None
                                                                self.value = None
                                                                self.data_type = None
                                                                self.status = None
                                                                self.update_rate = None

                                                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                            class Threshold(_Entity_):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.threshold_array = YList(self)
                                                                    self._segment_path = lambda: "threshold"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                class ThresholdArray(_Entity_):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_name = None
                                                                        self._segment_path = lambda: "threshold-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml']['meta_info']


                                                        class InvAssetBag(_Entity_):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                ])
                                                                self.part_number = None
                                                                self.manufacturer_assembly_number = None
                                                                self.manufacturer_assembly_revision = None
                                                                self.manufacturer_firmware_identifier = None
                                                                self.manufacturer_software_identifier = None
                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                self.original_equipment_manufacturer_string = None
                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag']['meta_info']


                                                        class Threshold(_Entity_):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo))])
                                                                self._leafs = OrderedDict()

                                                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._segment_path = lambda: "threshold"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, [], name, value)


                                                            class MajorLo(_Entity_):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo']['meta_info']


                                                            class CriticalHi(_Entity_):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi']['meta_info']


                                                            class MinorHi(_Entity_):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi']['meta_info']


                                                            class MajorHi(_Entity_):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi']['meta_info']


                                                            class CriticalLo(_Entity_):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo']['meta_info']


                                                            class MinorLo(_Entity_):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold']['meta_info']


                                                        class FruInfo(_Entity_):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime))])
                                                                self._leafs = OrderedDict([
                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                ])
                                                                self.card_administrative_state = None
                                                                self.power_administrative_state = None
                                                                self.card_operational_state = None
                                                                self.card_monitor_state = None
                                                                self.card_reset_reason = None
                                                                self.power_current_measurement = None
                                                                self.power_operational_state = None

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._segment_path = lambda: "fru-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                            class LastOperationalStateChange(_Entity_):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                            class CardUpTime(_Entity_):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "card-up-time"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo']['meta_info']


                                                        class InvEepromInfo(_Entity_):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\: str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: form_factor
                                                            
                                                            	Optics form factor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: connector_type
                                                            
                                                            	Connector type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: otn_application_code
                                                            
                                                            	Otn Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: sonet_application_code
                                                            
                                                            	Sonet Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ethernet_compliance_code
                                                            
                                                            	Ethernet Compliance Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: date_string
                                                            
                                                            	Date string in IDPROM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom))])
                                                                self._leafs = OrderedDict([
                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                ])
                                                                self.inv_card_type = None
                                                                self.opaque_data = None
                                                                self.opaque_data_size = None
                                                                self.has_eeprom = None
                                                                self.description = None
                                                                self.form_factor = None
                                                                self.connector_type = None
                                                                self.otn_application_code = None
                                                                self.sonet_application_code = None
                                                                self.ethernet_compliance_code = None
                                                                self.date_string = None

                                                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                            class Eeprom(_Entity_):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci_alpha_number
                                                                
                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                    self._leafs = OrderedDict([
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                    ])
                                                                    self.description = None
                                                                    self.idprom_format_rev = None
                                                                    self.controller_family = None
                                                                    self.controller_type = None
                                                                    self.vid = None
                                                                    self.hwid = None
                                                                    self.pid = None
                                                                    self.udi_description = None
                                                                    self.udi_name = None
                                                                    self.clei = None
                                                                    self.eci = None
                                                                    self.top_assem_part_num = None
                                                                    self.top_assem_vid = None
                                                                    self.pca_num = None
                                                                    self.pcavid = None
                                                                    self.chassis_sid = None
                                                                    self.dev_num1 = None
                                                                    self.dev_num2 = None
                                                                    self.dev_num3 = None
                                                                    self.dev_num4 = None
                                                                    self.dev_num5 = None
                                                                    self.dev_num6 = None
                                                                    self.dev_num7 = None
                                                                    self.manu_test_data = None
                                                                    self.asset_id = None
                                                                    self.asset_alias = None
                                                                    self.base_mac_address1 = None
                                                                    self.mac_add_blk_size1 = None
                                                                    self.base_mac_address2 = None
                                                                    self.mac_add_blk_size2 = None
                                                                    self.base_mac_address3 = None
                                                                    self.mac_add_blk_size3 = None
                                                                    self.base_mac_address4 = None
                                                                    self.mac_add_blk_size4 = None
                                                                    self.pcb_serial_num = None
                                                                    self.power_supply_type = None
                                                                    self.power_consumption = None
                                                                    self.block_signature = None
                                                                    self.block_version = None
                                                                    self.block_length = None
                                                                    self.block_checksum = None
                                                                    self.eeprom_size = None
                                                                    self.block_count = None
                                                                    self.fru_major_type = None
                                                                    self.fru_minor_type = None
                                                                    self.oem_string = None
                                                                    self.product_id = None
                                                                    self.serial_number = None
                                                                    self.part_number = None
                                                                    self.part_revision = None
                                                                    self.mfg_deviation = None
                                                                    self.hw_version = None
                                                                    self.mfg_bits = None
                                                                    self.engineer_use = None
                                                                    self.snmpoid = None
                                                                    self.rma_code = None
                                                                    self.eci_alpha_number = None

                                                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._segment_path = lambda: "eeprom"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                class Rma(_Entity_):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                        ])
                                                                        self.test_history = None
                                                                        self.rma_number = None
                                                                        self.rma_history = None
                                                                        self._segment_path = lambda: "rma"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s']['meta_info']


                                            class Attributes(_Entity_):
                                                """
                                                Attributes
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo))])
                                                    self._leafs = OrderedDict()

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"

                                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._segment_path = lambda: "attributes"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, [], name, value)


                                                class InvBasicBag(_Entity_):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: allocated_power
                                                    
                                                    	Allocated power for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_capacity
                                                    
                                                    	Power Capacity of a Power Module
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.vendor_type = None
                                                        self.name = None
                                                        self.hardware_revision = None
                                                        self.firmware_revision = None
                                                        self.software_revision = None
                                                        self.chip_hardware_revision = None
                                                        self.serial_number = None
                                                        self.manufacturer_name = None
                                                        self.model_name = None
                                                        self.asset_id_str = None
                                                        self.asset_identification = None
                                                        self.is_field_replaceable_unit = None
                                                        self.manufacturer_asset_tags = None
                                                        self.composite_class_code = None
                                                        self.memory_size = None
                                                        self.environmental_monitor_path = None
                                                        self.alias = None
                                                        self.group_flag = None
                                                        self.new_deviation_number = None
                                                        self.physical_layer_interface_module_type = None
                                                        self.unrecognized_fru = None
                                                        self.redundancystate = None
                                                        self.ceport = None
                                                        self.xr_scoped = None
                                                        self.unique_id = None
                                                        self.allocated_power = None
                                                        self.power_capacity = None
                                                        self._segment_path = lambda: "inv-basic-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag']['meta_info']


                                                class EnvSensorInfo(_Entity_):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: average
                                                    
                                                    	Average sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minimum
                                                    
                                                    	Minimum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: maximum
                                                    
                                                    	Maximum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interval
                                                    
                                                    	Time Interval over which sensor value is monitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                        ])
                                                        self.field_validity_bitmap = None
                                                        self.device_description = None
                                                        self.units = None
                                                        self.device_id = None
                                                        self.value = None
                                                        self.alarm_type = None
                                                        self.data_type = None
                                                        self.scale = None
                                                        self.precision = None
                                                        self.status = None
                                                        self.age_time_stamp = None
                                                        self.update_rate = None
                                                        self.average = None
                                                        self.minimum = None
                                                        self.maximum = None
                                                        self.interval = None
                                                        self._segment_path = lambda: "env-sensor-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo']['meta_info']


                                                class PwgInfo(_Entity_):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                        ])
                                                        self.power_group_redundancy_mode = None
                                                        self.power_group_power_units = None
                                                        self.power_group_available_current = None
                                                        self.power_group_drawn_current = None
                                                        self._segment_path = lambda: "pwg-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo']['meta_info']


                                                class EnvSensorInfoXml(_Entity_):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold))])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.units = None
                                                        self.value = None
                                                        self.data_type = None
                                                        self.status = None
                                                        self.update_rate = None

                                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                    class Threshold(_Entity_):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                            self._leafs = OrderedDict()

                                                            self.threshold_array = YList(self)
                                                            self._segment_path = lambda: "threshold"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                        class ThresholdArray(_Entity_):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_name = None
                                                                self._segment_path = lambda: "threshold-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml']['meta_info']


                                                class InvAssetBag(_Entity_):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                        ])
                                                        self.part_number = None
                                                        self.manufacturer_assembly_number = None
                                                        self.manufacturer_assembly_revision = None
                                                        self.manufacturer_firmware_identifier = None
                                                        self.manufacturer_software_identifier = None
                                                        self.manufacturer_common_language_equipment_identifier = None
                                                        self.original_equipment_manufacturer_string = None
                                                        self._segment_path = lambda: "inv-asset-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag']['meta_info']


                                                class Threshold(_Entity_):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo))])
                                                        self._leafs = OrderedDict()

                                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"

                                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"

                                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._segment_path = lambda: "threshold"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, [], name, value)


                                                    class MajorLo(_Entity_):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo']['meta_info']


                                                    class CriticalHi(_Entity_):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi']['meta_info']


                                                    class MinorHi(_Entity_):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi']['meta_info']


                                                    class MajorHi(_Entity_):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi']['meta_info']


                                                    class CriticalLo(_Entity_):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo']['meta_info']


                                                    class MinorLo(_Entity_):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold']['meta_info']


                                                class FruInfo(_Entity_):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime))])
                                                        self._leafs = OrderedDict([
                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                        ])
                                                        self.card_administrative_state = None
                                                        self.power_administrative_state = None
                                                        self.card_operational_state = None
                                                        self.card_monitor_state = None
                                                        self.card_reset_reason = None
                                                        self.power_current_measurement = None
                                                        self.power_operational_state = None

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._segment_path = lambda: "fru-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                    class LastOperationalStateChange(_Entity_):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "last-operational-state-change"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                    class CardUpTime(_Entity_):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "card-up-time"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo']['meta_info']


                                                class InvEepromInfo(_Entity_):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: form_factor
                                                    
                                                    	Optics form factor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: connector_type
                                                    
                                                    	Connector type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: otn_application_code
                                                    
                                                    	Otn Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: sonet_application_code
                                                    
                                                    	Sonet Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ethernet_compliance_code
                                                    
                                                    	Ethernet Compliance Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: date_string
                                                    
                                                    	Date string in IDPROM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom))])
                                                        self._leafs = OrderedDict([
                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                        ])
                                                        self.inv_card_type = None
                                                        self.opaque_data = None
                                                        self.opaque_data_size = None
                                                        self.has_eeprom = None
                                                        self.description = None
                                                        self.form_factor = None
                                                        self.connector_type = None
                                                        self.otn_application_code = None
                                                        self.sonet_application_code = None
                                                        self.ethernet_compliance_code = None
                                                        self.date_string = None

                                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                    class Eeprom(_Entity_):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci_alpha_number
                                                        
                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                            self._leafs = OrderedDict([
                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                            ])
                                                            self.description = None
                                                            self.idprom_format_rev = None
                                                            self.controller_family = None
                                                            self.controller_type = None
                                                            self.vid = None
                                                            self.hwid = None
                                                            self.pid = None
                                                            self.udi_description = None
                                                            self.udi_name = None
                                                            self.clei = None
                                                            self.eci = None
                                                            self.top_assem_part_num = None
                                                            self.top_assem_vid = None
                                                            self.pca_num = None
                                                            self.pcavid = None
                                                            self.chassis_sid = None
                                                            self.dev_num1 = None
                                                            self.dev_num2 = None
                                                            self.dev_num3 = None
                                                            self.dev_num4 = None
                                                            self.dev_num5 = None
                                                            self.dev_num6 = None
                                                            self.dev_num7 = None
                                                            self.manu_test_data = None
                                                            self.asset_id = None
                                                            self.asset_alias = None
                                                            self.base_mac_address1 = None
                                                            self.mac_add_blk_size1 = None
                                                            self.base_mac_address2 = None
                                                            self.mac_add_blk_size2 = None
                                                            self.base_mac_address3 = None
                                                            self.mac_add_blk_size3 = None
                                                            self.base_mac_address4 = None
                                                            self.mac_add_blk_size4 = None
                                                            self.pcb_serial_num = None
                                                            self.power_supply_type = None
                                                            self.power_consumption = None
                                                            self.block_signature = None
                                                            self.block_version = None
                                                            self.block_length = None
                                                            self.block_checksum = None
                                                            self.eeprom_size = None
                                                            self.block_count = None
                                                            self.fru_major_type = None
                                                            self.fru_minor_type = None
                                                            self.oem_string = None
                                                            self.product_id = None
                                                            self.serial_number = None
                                                            self.part_number = None
                                                            self.part_revision = None
                                                            self.mfg_deviation = None
                                                            self.hw_version = None
                                                            self.mfg_bits = None
                                                            self.engineer_use = None
                                                            self.snmpoid = None
                                                            self.rma_code = None
                                                            self.eci_alpha_number = None

                                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._segment_path = lambda: "eeprom"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                        class Rma(_Entity_):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                ])
                                                                self.test_history = None
                                                                self.rma_number = None
                                                                self.rma_history = None
                                                                self._segment_path = lambda: "rma"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s']['meta_info']


                                    class Attributes(_Entity_):
                                        """
                                        Attributes
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo))])
                                            self._leafs = OrderedDict()

                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"

                                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._segment_path = lambda: "attributes"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, [], name, value)


                                        class InvBasicBag(_Entity_):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: allocated_power
                                            
                                            	Allocated power for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_capacity
                                            
                                            	Power Capacity of a Power Module
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                ])
                                                self.description = None
                                                self.vendor_type = None
                                                self.name = None
                                                self.hardware_revision = None
                                                self.firmware_revision = None
                                                self.software_revision = None
                                                self.chip_hardware_revision = None
                                                self.serial_number = None
                                                self.manufacturer_name = None
                                                self.model_name = None
                                                self.asset_id_str = None
                                                self.asset_identification = None
                                                self.is_field_replaceable_unit = None
                                                self.manufacturer_asset_tags = None
                                                self.composite_class_code = None
                                                self.memory_size = None
                                                self.environmental_monitor_path = None
                                                self.alias = None
                                                self.group_flag = None
                                                self.new_deviation_number = None
                                                self.physical_layer_interface_module_type = None
                                                self.unrecognized_fru = None
                                                self.redundancystate = None
                                                self.ceport = None
                                                self.xr_scoped = None
                                                self.unique_id = None
                                                self.allocated_power = None
                                                self.power_capacity = None
                                                self._segment_path = lambda: "inv-basic-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag']['meta_info']


                                        class EnvSensorInfo(_Entity_):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: average
                                            
                                            	Average sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minimum
                                            
                                            	Minimum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: maximum
                                            
                                            	Maximum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: interval
                                            
                                            	Time Interval over which sensor value is monitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                ])
                                                self.field_validity_bitmap = None
                                                self.device_description = None
                                                self.units = None
                                                self.device_id = None
                                                self.value = None
                                                self.alarm_type = None
                                                self.data_type = None
                                                self.scale = None
                                                self.precision = None
                                                self.status = None
                                                self.age_time_stamp = None
                                                self.update_rate = None
                                                self.average = None
                                                self.minimum = None
                                                self.maximum = None
                                                self.interval = None
                                                self._segment_path = lambda: "env-sensor-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo']['meta_info']


                                        class PwgInfo(_Entity_):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                ])
                                                self.power_group_redundancy_mode = None
                                                self.power_group_power_units = None
                                                self.power_group_available_current = None
                                                self.power_group_drawn_current = None
                                                self._segment_path = lambda: "pwg-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo']['meta_info']


                                        class EnvSensorInfoXml(_Entity_):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold))])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                ])
                                                self.description = None
                                                self.units = None
                                                self.value = None
                                                self.data_type = None
                                                self.status = None
                                                self.update_rate = None

                                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                            class Threshold(_Entity_):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                    self._leafs = OrderedDict()

                                                    self.threshold_array = YList(self)
                                                    self._segment_path = lambda: "threshold"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                class ThresholdArray(_Entity_):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_name = None
                                                        self._segment_path = lambda: "threshold-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml']['meta_info']


                                        class InvAssetBag(_Entity_):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                ])
                                                self.part_number = None
                                                self.manufacturer_assembly_number = None
                                                self.manufacturer_assembly_revision = None
                                                self.manufacturer_firmware_identifier = None
                                                self.manufacturer_software_identifier = None
                                                self.manufacturer_common_language_equipment_identifier = None
                                                self.original_equipment_manufacturer_string = None
                                                self._segment_path = lambda: "inv-asset-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag']['meta_info']


                                        class Threshold(_Entity_):
                                            """
                                            Threshold
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo))])
                                                self._leafs = OrderedDict()

                                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"

                                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"

                                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._segment_path = lambda: "threshold"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, [], name, value)


                                            class MajorLo(_Entity_):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo']['meta_info']


                                            class CriticalHi(_Entity_):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi']['meta_info']


                                            class MinorHi(_Entity_):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi']['meta_info']


                                            class MajorHi(_Entity_):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi']['meta_info']


                                            class CriticalLo(_Entity_):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo']['meta_info']


                                            class MinorLo(_Entity_):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold']['meta_info']


                                        class FruInfo(_Entity_):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime))])
                                                self._leafs = OrderedDict([
                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                ])
                                                self.card_administrative_state = None
                                                self.power_administrative_state = None
                                                self.card_operational_state = None
                                                self.card_monitor_state = None
                                                self.card_reset_reason = None
                                                self.power_current_measurement = None
                                                self.power_operational_state = None

                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._segment_path = lambda: "fru-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                            class LastOperationalStateChange(_Entity_):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "last-operational-state-change"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                            class CardUpTime(_Entity_):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "card-up-time"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo']['meta_info']


                                        class InvEepromInfo(_Entity_):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\: str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: form_factor
                                            
                                            	Optics form factor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: connector_type
                                            
                                            	Connector type
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: otn_application_code
                                            
                                            	Otn Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: sonet_application_code
                                            
                                            	Sonet Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ethernet_compliance_code
                                            
                                            	Ethernet Compliance Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: date_string
                                            
                                            	Date string in IDPROM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom))])
                                                self._leafs = OrderedDict([
                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                ])
                                                self.inv_card_type = None
                                                self.opaque_data = None
                                                self.opaque_data_size = None
                                                self.has_eeprom = None
                                                self.description = None
                                                self.form_factor = None
                                                self.connector_type = None
                                                self.otn_application_code = None
                                                self.sonet_application_code = None
                                                self.ethernet_compliance_code = None
                                                self.date_string = None

                                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._segment_path = lambda: "inv-eeprom-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                            class Eeprom(_Entity_):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci_alpha_number
                                                
                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                    self._leafs = OrderedDict([
                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                    ])
                                                    self.description = None
                                                    self.idprom_format_rev = None
                                                    self.controller_family = None
                                                    self.controller_type = None
                                                    self.vid = None
                                                    self.hwid = None
                                                    self.pid = None
                                                    self.udi_description = None
                                                    self.udi_name = None
                                                    self.clei = None
                                                    self.eci = None
                                                    self.top_assem_part_num = None
                                                    self.top_assem_vid = None
                                                    self.pca_num = None
                                                    self.pcavid = None
                                                    self.chassis_sid = None
                                                    self.dev_num1 = None
                                                    self.dev_num2 = None
                                                    self.dev_num3 = None
                                                    self.dev_num4 = None
                                                    self.dev_num5 = None
                                                    self.dev_num6 = None
                                                    self.dev_num7 = None
                                                    self.manu_test_data = None
                                                    self.asset_id = None
                                                    self.asset_alias = None
                                                    self.base_mac_address1 = None
                                                    self.mac_add_blk_size1 = None
                                                    self.base_mac_address2 = None
                                                    self.mac_add_blk_size2 = None
                                                    self.base_mac_address3 = None
                                                    self.mac_add_blk_size3 = None
                                                    self.base_mac_address4 = None
                                                    self.mac_add_blk_size4 = None
                                                    self.pcb_serial_num = None
                                                    self.power_supply_type = None
                                                    self.power_consumption = None
                                                    self.block_signature = None
                                                    self.block_version = None
                                                    self.block_length = None
                                                    self.block_checksum = None
                                                    self.eeprom_size = None
                                                    self.block_count = None
                                                    self.fru_major_type = None
                                                    self.fru_minor_type = None
                                                    self.oem_string = None
                                                    self.product_id = None
                                                    self.serial_number = None
                                                    self.part_number = None
                                                    self.part_revision = None
                                                    self.mfg_deviation = None
                                                    self.hw_version = None
                                                    self.mfg_bits = None
                                                    self.engineer_use = None
                                                    self.snmpoid = None
                                                    self.rma_code = None
                                                    self.eci_alpha_number = None

                                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._segment_path = lambda: "eeprom"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                class Rma(_Entity_):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                        ])
                                                        self.test_history = None
                                                        self.rma_number = None
                                                        self.rma_history = None
                                                        self._segment_path = lambda: "rma"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Tsi2s']['meta_info']


                            class Attributes(_Entity_):
                                """
                                Attributes
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold>`
                                
                                	**config**\: False
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo))])
                                    self._leafs = OrderedDict()

                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                    self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                    self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                    self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"

                                    self.fru_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._segment_path = lambda: "attributes"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes, [], name, value)


                                class InvBasicBag(_Entity_):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: allocated_power
                                    
                                    	Allocated power for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_capacity
                                    
                                    	Power Capacity of a Power Module
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                        ])
                                        self.description = None
                                        self.vendor_type = None
                                        self.name = None
                                        self.hardware_revision = None
                                        self.firmware_revision = None
                                        self.software_revision = None
                                        self.chip_hardware_revision = None
                                        self.serial_number = None
                                        self.manufacturer_name = None
                                        self.model_name = None
                                        self.asset_id_str = None
                                        self.asset_identification = None
                                        self.is_field_replaceable_unit = None
                                        self.manufacturer_asset_tags = None
                                        self.composite_class_code = None
                                        self.memory_size = None
                                        self.environmental_monitor_path = None
                                        self.alias = None
                                        self.group_flag = None
                                        self.new_deviation_number = None
                                        self.physical_layer_interface_module_type = None
                                        self.unrecognized_fru = None
                                        self.redundancystate = None
                                        self.ceport = None
                                        self.xr_scoped = None
                                        self.unique_id = None
                                        self.allocated_power = None
                                        self.power_capacity = None
                                        self._segment_path = lambda: "inv-basic-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag']['meta_info']


                                class EnvSensorInfo(_Entity_):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: average
                                    
                                    	Average sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minimum
                                    
                                    	Minimum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: maximum
                                    
                                    	Maximum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interval
                                    
                                    	Time Interval over which sensor value is monitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                        ])
                                        self.field_validity_bitmap = None
                                        self.device_description = None
                                        self.units = None
                                        self.device_id = None
                                        self.value = None
                                        self.alarm_type = None
                                        self.data_type = None
                                        self.scale = None
                                        self.precision = None
                                        self.status = None
                                        self.age_time_stamp = None
                                        self.update_rate = None
                                        self.average = None
                                        self.minimum = None
                                        self.maximum = None
                                        self.interval = None
                                        self._segment_path = lambda: "env-sensor-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo']['meta_info']


                                class PwgInfo(_Entity_):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                        ])
                                        self.power_group_redundancy_mode = None
                                        self.power_group_power_units = None
                                        self.power_group_available_current = None
                                        self.power_group_drawn_current = None
                                        self._segment_path = lambda: "pwg-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.PwgInfo']['meta_info']


                                class EnvSensorInfoXml(_Entity_):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold))])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                        ])
                                        self.description = None
                                        self.units = None
                                        self.value = None
                                        self.data_type = None
                                        self.status = None
                                        self.update_rate = None

                                        self.threshold = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._segment_path = lambda: "env-sensor-info-xml"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                    class Threshold(_Entity_):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                            self._leafs = OrderedDict()

                                            self.threshold_array = YList(self)
                                            self._segment_path = lambda: "threshold"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                        class ThresholdArray(_Entity_):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_name = None
                                                self._segment_path = lambda: "threshold-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml']['meta_info']


                                class InvAssetBag(_Entity_):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                        ])
                                        self.part_number = None
                                        self.manufacturer_assembly_number = None
                                        self.manufacturer_assembly_revision = None
                                        self.manufacturer_firmware_identifier = None
                                        self.manufacturer_software_identifier = None
                                        self.manufacturer_common_language_equipment_identifier = None
                                        self.original_equipment_manufacturer_string = None
                                        self._segment_path = lambda: "inv-asset-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag']['meta_info']


                                class Threshold(_Entity_):
                                    """
                                    Threshold
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo))])
                                        self._leafs = OrderedDict()

                                        self.major_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"

                                        self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"

                                        self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"

                                        self.major_hi = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"

                                        self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"

                                        self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._segment_path = lambda: "threshold"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold, [], name, value)


                                    class MajorLo(_Entity_):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo']['meta_info']


                                    class CriticalHi(_Entity_):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi']['meta_info']


                                    class MinorHi(_Entity_):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi']['meta_info']


                                    class MajorHi(_Entity_):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi']['meta_info']


                                    class CriticalLo(_Entity_):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo']['meta_info']


                                    class MinorLo(_Entity_):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.Threshold']['meta_info']


                                class FruInfo(_Entity_):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime))])
                                        self._leafs = OrderedDict([
                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                        ])
                                        self.card_administrative_state = None
                                        self.power_administrative_state = None
                                        self.card_operational_state = None
                                        self.card_monitor_state = None
                                        self.card_reset_reason = None
                                        self.power_current_measurement = None
                                        self.power_operational_state = None

                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                        self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._segment_path = lambda: "fru-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                    class LastOperationalStateChange(_Entity_):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "last-operational-state-change"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                    class CardUpTime(_Entity_):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "card-up-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.FruInfo']['meta_info']


                                class InvEepromInfo(_Entity_):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\: str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: form_factor
                                    
                                    	Optics form factor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connector_type
                                    
                                    	Connector type
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn_application_code
                                    
                                    	Otn Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: sonet_application_code
                                    
                                    	Sonet Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ethernet_compliance_code
                                    
                                    	Ethernet Compliance Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: date_string
                                    
                                    	Date string in IDPROM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom))])
                                        self._leafs = OrderedDict([
                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                        ])
                                        self.inv_card_type = None
                                        self.opaque_data = None
                                        self.opaque_data_size = None
                                        self.has_eeprom = None
                                        self.description = None
                                        self.form_factor = None
                                        self.connector_type = None
                                        self.otn_application_code = None
                                        self.sonet_application_code = None
                                        self.ethernet_compliance_code = None
                                        self.date_string = None

                                        self.eeprom = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._segment_path = lambda: "inv-eeprom-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                    class Eeprom(_Entity_):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci_alpha_number
                                        
                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma))])
                                            self._leafs = OrderedDict([
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                            ])
                                            self.description = None
                                            self.idprom_format_rev = None
                                            self.controller_family = None
                                            self.controller_type = None
                                            self.vid = None
                                            self.hwid = None
                                            self.pid = None
                                            self.udi_description = None
                                            self.udi_name = None
                                            self.clei = None
                                            self.eci = None
                                            self.top_assem_part_num = None
                                            self.top_assem_vid = None
                                            self.pca_num = None
                                            self.pcavid = None
                                            self.chassis_sid = None
                                            self.dev_num1 = None
                                            self.dev_num2 = None
                                            self.dev_num3 = None
                                            self.dev_num4 = None
                                            self.dev_num5 = None
                                            self.dev_num6 = None
                                            self.dev_num7 = None
                                            self.manu_test_data = None
                                            self.asset_id = None
                                            self.asset_alias = None
                                            self.base_mac_address1 = None
                                            self.mac_add_blk_size1 = None
                                            self.base_mac_address2 = None
                                            self.mac_add_blk_size2 = None
                                            self.base_mac_address3 = None
                                            self.mac_add_blk_size3 = None
                                            self.base_mac_address4 = None
                                            self.mac_add_blk_size4 = None
                                            self.pcb_serial_num = None
                                            self.power_supply_type = None
                                            self.power_consumption = None
                                            self.block_signature = None
                                            self.block_version = None
                                            self.block_length = None
                                            self.block_checksum = None
                                            self.eeprom_size = None
                                            self.block_count = None
                                            self.fru_major_type = None
                                            self.fru_minor_type = None
                                            self.oem_string = None
                                            self.product_id = None
                                            self.serial_number = None
                                            self.part_number = None
                                            self.part_revision = None
                                            self.mfg_deviation = None
                                            self.hw_version = None
                                            self.mfg_bits = None
                                            self.engineer_use = None
                                            self.snmpoid = None
                                            self.rma_code = None
                                            self.eci_alpha_number = None

                                            self.rma = Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._segment_path = lambda: "eeprom"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                        class Rma(_Entity_):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                ])
                                                self.test_history = None
                                                self.rma_number = None
                                                self.rma_history = None
                                                self._segment_path = lambda: "rma"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1.Attributes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s.Tsi1']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Tsi1s']['meta_info']


                    class Attributes(_Entity_):
                        """
                        Attributes
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold>`
                        
                        	**config**\: False
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Entity.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo))])
                            self._leafs = OrderedDict()

                            self.inv_basic_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                            self.env_sensor_info = Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                            self.pwg_info = Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                            self.inv_asset_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                            self.threshold = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"

                            self.fru_info = Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"

                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._segment_path = lambda: "attributes"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes, [], name, value)


                        class InvBasicBag(_Entity_):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: allocated_power
                            
                            	Allocated power for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_capacity
                            
                            	Power Capacity of a Power Module
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                ])
                                self.description = None
                                self.vendor_type = None
                                self.name = None
                                self.hardware_revision = None
                                self.firmware_revision = None
                                self.software_revision = None
                                self.chip_hardware_revision = None
                                self.serial_number = None
                                self.manufacturer_name = None
                                self.model_name = None
                                self.asset_id_str = None
                                self.asset_identification = None
                                self.is_field_replaceable_unit = None
                                self.manufacturer_asset_tags = None
                                self.composite_class_code = None
                                self.memory_size = None
                                self.environmental_monitor_path = None
                                self.alias = None
                                self.group_flag = None
                                self.new_deviation_number = None
                                self.physical_layer_interface_module_type = None
                                self.unrecognized_fru = None
                                self.redundancystate = None
                                self.ceport = None
                                self.xr_scoped = None
                                self.unique_id = None
                                self.allocated_power = None
                                self.power_capacity = None
                                self._segment_path = lambda: "inv-basic-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.InvBasicBag']['meta_info']


                        class EnvSensorInfo(_Entity_):
                            """
                            Environment sensor info
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: average
                            
                            	Average sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: minimum
                            
                            	Minimum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: maximum
                            
                            	Maximum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: interval
                            
                            	Time Interval over which sensor value is monitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                ])
                                self.field_validity_bitmap = None
                                self.device_description = None
                                self.units = None
                                self.device_id = None
                                self.value = None
                                self.alarm_type = None
                                self.data_type = None
                                self.scale = None
                                self.precision = None
                                self.status = None
                                self.age_time_stamp = None
                                self.update_rate = None
                                self.average = None
                                self.minimum = None
                                self.maximum = None
                                self.interval = None
                                self._segment_path = lambda: "env-sensor-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfo']['meta_info']


                        class PwgInfo(_Entity_):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                ])
                                self.power_group_redundancy_mode = None
                                self.power_group_power_units = None
                                self.power_group_available_current = None
                                self.power_group_drawn_current = None
                                self._segment_path = lambda: "pwg-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.PwgInfo']['meta_info']


                        class EnvSensorInfoXml(_Entity_):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold))])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                ])
                                self.description = None
                                self.units = None
                                self.value = None
                                self.data_type = None
                                self.status = None
                                self.update_rate = None

                                self.threshold = Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._segment_path = lambda: "env-sensor-info-xml"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                            class Threshold(_Entity_):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                    self._leafs = OrderedDict()

                                    self.threshold_array = YList(self)
                                    self._segment_path = lambda: "threshold"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                class ThresholdArray(_Entity_):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_name = None
                                        self._segment_path = lambda: "threshold-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.EnvSensorInfoXml']['meta_info']


                        class InvAssetBag(_Entity_):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                ])
                                self.part_number = None
                                self.manufacturer_assembly_number = None
                                self.manufacturer_assembly_revision = None
                                self.manufacturer_firmware_identifier = None
                                self.manufacturer_software_identifier = None
                                self.manufacturer_common_language_equipment_identifier = None
                                self.original_equipment_manufacturer_string = None
                                self._segment_path = lambda: "inv-asset-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.InvAssetBag']['meta_info']


                        class Threshold(_Entity_):
                            """
                            Threshold
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo))])
                                self._leafs = OrderedDict()

                                self.major_lo = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"

                                self.critical_hi = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"

                                self.minor_hi = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"

                                self.major_hi = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"

                                self.critical_lo = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"

                                self.minor_lo = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._segment_path = lambda: "threshold"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold, [], name, value)


                            class MajorLo(_Entity_):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorLo']['meta_info']


                            class CriticalHi(_Entity_):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalHi']['meta_info']


                            class MinorHi(_Entity_):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorHi']['meta_info']


                            class MajorHi(_Entity_):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MajorHi']['meta_info']


                            class CriticalLo(_Entity_):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.CriticalLo']['meta_info']


                            class MinorLo(_Entity_):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold.MinorLo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.Threshold']['meta_info']


                        class FruInfo(_Entity_):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime))])
                                self._leafs = OrderedDict([
                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                ])
                                self.card_administrative_state = None
                                self.power_administrative_state = None
                                self.card_operational_state = None
                                self.card_monitor_state = None
                                self.card_reset_reason = None
                                self.power_current_measurement = None
                                self.power_operational_state = None

                                self.last_operational_state_change = Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                self.card_up_time = Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._segment_path = lambda: "fru-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                            class LastOperationalStateChange(_Entity_):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "last-operational-state-change"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                            class CardUpTime(_Entity_):
                                """
                                card up time
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "card-up-time"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo.CardUpTime']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.FruInfo']['meta_info']


                        class InvEepromInfo(_Entity_):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            	**config**\: False
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\: str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: form_factor
                            
                            	Optics form factor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connector_type
                            
                            	Connector type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: otn_application_code
                            
                            	Otn Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sonet_application_code
                            
                            	Sonet Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ethernet_compliance_code
                            
                            	Ethernet Compliance Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: date_string
                            
                            	Date string in IDPROM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom))])
                                self._leafs = OrderedDict([
                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                ])
                                self.inv_card_type = None
                                self.opaque_data = None
                                self.opaque_data_size = None
                                self.has_eeprom = None
                                self.description = None
                                self.form_factor = None
                                self.connector_type = None
                                self.otn_application_code = None
                                self.sonet_application_code = None
                                self.ethernet_compliance_code = None
                                self.date_string = None

                                self.eeprom = Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._segment_path = lambda: "inv-eeprom-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                            class Eeprom(_Entity_):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                	**config**\: False
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci_alpha_number
                                
                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma))])
                                    self._leafs = OrderedDict([
                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                    ])
                                    self.description = None
                                    self.idprom_format_rev = None
                                    self.controller_family = None
                                    self.controller_type = None
                                    self.vid = None
                                    self.hwid = None
                                    self.pid = None
                                    self.udi_description = None
                                    self.udi_name = None
                                    self.clei = None
                                    self.eci = None
                                    self.top_assem_part_num = None
                                    self.top_assem_vid = None
                                    self.pca_num = None
                                    self.pcavid = None
                                    self.chassis_sid = None
                                    self.dev_num1 = None
                                    self.dev_num2 = None
                                    self.dev_num3 = None
                                    self.dev_num4 = None
                                    self.dev_num5 = None
                                    self.dev_num6 = None
                                    self.dev_num7 = None
                                    self.manu_test_data = None
                                    self.asset_id = None
                                    self.asset_alias = None
                                    self.base_mac_address1 = None
                                    self.mac_add_blk_size1 = None
                                    self.base_mac_address2 = None
                                    self.mac_add_blk_size2 = None
                                    self.base_mac_address3 = None
                                    self.mac_add_blk_size3 = None
                                    self.base_mac_address4 = None
                                    self.mac_add_blk_size4 = None
                                    self.pcb_serial_num = None
                                    self.power_supply_type = None
                                    self.power_consumption = None
                                    self.block_signature = None
                                    self.block_version = None
                                    self.block_length = None
                                    self.block_checksum = None
                                    self.eeprom_size = None
                                    self.block_count = None
                                    self.fru_major_type = None
                                    self.fru_minor_type = None
                                    self.oem_string = None
                                    self.product_id = None
                                    self.serial_number = None
                                    self.part_number = None
                                    self.part_revision = None
                                    self.mfg_deviation = None
                                    self.hw_version = None
                                    self.mfg_bits = None
                                    self.engineer_use = None
                                    self.snmpoid = None
                                    self.rma_code = None
                                    self.eci_alpha_number = None

                                    self.rma = Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._segment_path = lambda: "eeprom"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                class Rma(_Entity_):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                        ])
                                        self.test_history = None
                                        self.rma_number = None
                                        self.rma_history = None
                                        self._segment_path = lambda: "rma"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo.Eeprom']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes.InvEepromInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Entity.Slot.Attributes']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Entity.Slot']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Racks.Rack.Entity']['meta_info']


            class Powershelf(_Entity_):
                """
                Powershelf information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of  		 :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Racks.Rack.Powershelf, self).__init__()

                    self.yang_name = "powershelf"
                    self.yang_parent_name = "rack"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slot", ("slot", Inventory.Racks.Rack.Powershelf.Slot))])
                    self._leafs = OrderedDict()

                    self.slot = YList(self)
                    self._segment_path = lambda: "powershelf"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Racks.Rack.Powershelf, [], name, value)


                class Slot(_Entity_):
                    """
                    Slot number
                    
                    .. attribute:: name  (key)
                    
                    	Slot name
                    	**type**\: str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    	**config**\: False
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:  :py:class:`Tsi1s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s>`
                    
                    	**config**\: False
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Powershelf.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "powershelf"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['name']
                        self._child_classes = OrderedDict([("tsi1s", ("tsi1s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Attributes))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                        ])
                        self.name = None

                        self.tsi1s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"

                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._segment_path = lambda: "slot" + "[name='" + str(self.name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot, ['name'], name, value)


                    class Tsi1s(_Entity_):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of  		 :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("tsi1", ("tsi1", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1))])
                            self._leafs = OrderedDict()

                            self.tsi1 = YList(self)
                            self._segment_path = lambda: "tsi1s"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s, [], name, value)


                        class Tsi1(_Entity_):
                            """
                            TSI1
                            
                            .. attribute:: name  (key)
                            
                            	TSI1
                            	**type**\: str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            	**config**\: False
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:  :py:class:`Tsi2s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s>`
                            
                            	**config**\: False
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['name']
                                self._child_classes = OrderedDict([("tsi2s", ("tsi2s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes))])
                                self._leafs = OrderedDict([
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ])
                                self.name = None

                                self.tsi2s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"

                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._segment_path = lambda: "tsi1" + "[name='" + str(self.name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1, ['name'], name, value)


                            class Tsi2s(_Entity_):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of  		 :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("tsi2", ("tsi2", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2))])
                                    self._leafs = OrderedDict()

                                    self.tsi2 = YList(self)
                                    self._segment_path = lambda: "tsi2s"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s, [], name, value)


                                class Tsi2(_Entity_):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  (key)
                                    
                                    	TSI2
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:  :py:class:`Tsi3s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['name']
                                        self._child_classes = OrderedDict([("tsi3s", ("tsi3s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ])
                                        self.name = None

                                        self.tsi3s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"

                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._segment_path = lambda: "tsi2" + "[name='" + str(self.name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, ['name'], name, value)


                                    class Tsi3s(_Entity_):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of  		 :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("tsi3", ("tsi3", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3))])
                                            self._leafs = OrderedDict()

                                            self.tsi3 = YList(self)
                                            self._segment_path = lambda: "tsi3s"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, [], name, value)


                                        class Tsi3(_Entity_):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  (key)
                                            
                                            	TSI3
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:  :py:class:`Tsi4s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['name']
                                                self._child_classes = OrderedDict([("tsi4s", ("tsi4s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ])
                                                self.name = None

                                                self.tsi4s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"

                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._segment_path = lambda: "tsi3" + "[name='" + str(self.name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, ['name'], name, value)


                                            class Tsi4s(_Entity_):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of  		 :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("tsi4", ("tsi4", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4))])
                                                    self._leafs = OrderedDict()

                                                    self.tsi4 = YList(self)
                                                    self._segment_path = lambda: "tsi4s"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, [], name, value)


                                                class Tsi4(_Entity_):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  (key)
                                                    
                                                    	TSI4
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:  :py:class:`Tsi5s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['name']
                                                        self._child_classes = OrderedDict([("tsi5s", ("tsi5s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes))])
                                                        self._leafs = OrderedDict([
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ])
                                                        self.name = None

                                                        self.tsi5s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"

                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._segment_path = lambda: "tsi4" + "[name='" + str(self.name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, ['name'], name, value)


                                                    class Tsi5s(_Entity_):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of  		 :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("tsi5", ("tsi5", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5))])
                                                            self._leafs = OrderedDict()

                                                            self.tsi5 = YList(self)
                                                            self._segment_path = lambda: "tsi5s"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, [], name, value)


                                                        class Tsi5(_Entity_):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  (key)
                                                            
                                                            	TSI5
                                                            	**type**\: str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:  :py:class:`Tsi6s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = ['name']
                                                                self._child_classes = OrderedDict([("tsi6s", ("tsi6s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes))])
                                                                self._leafs = OrderedDict([
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                ])
                                                                self.name = None

                                                                self.tsi6s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"

                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._segment_path = lambda: "tsi5" + "[name='" + str(self.name) + "']"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, ['name'], name, value)


                                                            class Tsi6s(_Entity_):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of  		 :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("tsi6", ("tsi6", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6))])
                                                                    self._leafs = OrderedDict()

                                                                    self.tsi6 = YList(self)
                                                                    self._segment_path = lambda: "tsi6s"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, [], name, value)


                                                                class Tsi6(_Entity_):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  (key)
                                                                    
                                                                    	TSI6
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:  :py:class:`Tsi7s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = ['name']
                                                                        self._child_classes = OrderedDict([("tsi7s", ("tsi7s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes))])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ])
                                                                        self.name = None

                                                                        self.tsi7s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"

                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._segment_path = lambda: "tsi6" + "[name='" + str(self.name) + "']"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, ['name'], name, value)


                                                                    class Tsi7s(_Entity_):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of  		 :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("tsi7", ("tsi7", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7))])
                                                                            self._leafs = OrderedDict()

                                                                            self.tsi7 = YList(self)
                                                                            self._segment_path = lambda: "tsi7s"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, [], name, value)


                                                                        class Tsi7(_Entity_):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  (key)
                                                                            
                                                                            	TSI7
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:  :py:class:`Tsi8s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = ['name']
                                                                                self._child_classes = OrderedDict([("tsi8s", ("tsi8s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ])
                                                                                self.name = None

                                                                                self.tsi8s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"

                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._segment_path = lambda: "tsi7" + "[name='" + str(self.name) + "']"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, ['name'], name, value)


                                                                            class Tsi8s(_Entity_):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of  		 :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("tsi8", ("tsi8", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.tsi8 = YList(self)
                                                                                    self._segment_path = lambda: "tsi8s"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, [], name, value)


                                                                                class Tsi8(_Entity_):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  (key)
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:  :py:class:`Tsi9s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = ['name']
                                                                                        self._child_classes = OrderedDict([("tsi9s", ("tsi9s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ])
                                                                                        self.name = None

                                                                                        self.tsi9s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"

                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._segment_path = lambda: "tsi8" + "[name='" + str(self.name) + "']"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, ['name'], name, value)


                                                                                    class Tsi9s(_Entity_):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of  		 :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("tsi9", ("tsi9", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.tsi9 = YList(self)
                                                                                            self._segment_path = lambda: "tsi9s"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, [], name, value)


                                                                                        class Tsi9(_Entity_):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  (key)
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:  :py:class:`Tsi10s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = ['name']
                                                                                                self._child_classes = OrderedDict([("tsi10s", ("tsi10s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                ])
                                                                                                self.name = None

                                                                                                self.tsi10s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"

                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._segment_path = lambda: "tsi9" + "[name='" + str(self.name) + "']"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, ['name'], name, value)


                                                                                            class Tsi10s(_Entity_):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of  		 :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("tsi10", ("tsi10", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.tsi10 = YList(self)
                                                                                                    self._segment_path = lambda: "tsi10s"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, [], name, value)


                                                                                                class Tsi10(_Entity_):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  (key)
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:  :py:class:`Tsi11s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = ['name']
                                                                                                        self._child_classes = OrderedDict([("tsi11s", ("tsi11s", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s)), ("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                        ])
                                                                                                        self.name = None

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"

                                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._segment_path = lambda: "tsi10" + "[name='" + str(self.name) + "']"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, ['name'], name, value)


                                                                                                    class Tsi11s(_Entity_):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of  		 :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("tsi11", ("tsi11", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.tsi11 = YList(self)
                                                                                                            self._segment_path = lambda: "tsi11s"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, [], name, value)


                                                                                                        class Tsi11(_Entity_):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  (key)
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = ['name']
                                                                                                                self._child_classes = OrderedDict([("attributes", ("attributes", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                ])
                                                                                                                self.name = None

                                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._segment_path = lambda: "tsi11" + "[name='" + str(self.name) + "']"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, ['name'], name, value)


                                                                                                            class Attributes(_Entity_):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, [], name, value)


                                                                                                                class InvBasicBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: allocated_power
                                                                                                                    
                                                                                                                    	Allocated power for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_capacity
                                                                                                                    
                                                                                                                    	Power Capacity of a Power Module
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.vendor_type = None
                                                                                                                        self.name = None
                                                                                                                        self.hardware_revision = None
                                                                                                                        self.firmware_revision = None
                                                                                                                        self.software_revision = None
                                                                                                                        self.chip_hardware_revision = None
                                                                                                                        self.serial_number = None
                                                                                                                        self.manufacturer_name = None
                                                                                                                        self.model_name = None
                                                                                                                        self.asset_id_str = None
                                                                                                                        self.asset_identification = None
                                                                                                                        self.is_field_replaceable_unit = None
                                                                                                                        self.manufacturer_asset_tags = None
                                                                                                                        self.composite_class_code = None
                                                                                                                        self.memory_size = None
                                                                                                                        self.environmental_monitor_path = None
                                                                                                                        self.alias = None
                                                                                                                        self.group_flag = None
                                                                                                                        self.new_deviation_number = None
                                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                                        self.unrecognized_fru = None
                                                                                                                        self.redundancystate = None
                                                                                                                        self.ceport = None
                                                                                                                        self.xr_scoped = None
                                                                                                                        self.unique_id = None
                                                                                                                        self.allocated_power = None
                                                                                                                        self.power_capacity = None
                                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag']['meta_info']


                                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: average
                                                                                                                    
                                                                                                                    	Average sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minimum
                                                                                                                    
                                                                                                                    	Minimum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: maximum
                                                                                                                    
                                                                                                                    	Maximum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: interval
                                                                                                                    
                                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.field_validity_bitmap = None
                                                                                                                        self.device_description = None
                                                                                                                        self.units = None
                                                                                                                        self.device_id = None
                                                                                                                        self.value = None
                                                                                                                        self.alarm_type = None
                                                                                                                        self.data_type = None
                                                                                                                        self.scale = None
                                                                                                                        self.precision = None
                                                                                                                        self.status = None
                                                                                                                        self.age_time_stamp = None
                                                                                                                        self.update_rate = None
                                                                                                                        self.average = None
                                                                                                                        self.minimum = None
                                                                                                                        self.maximum = None
                                                                                                                        self.interval = None
                                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo']['meta_info']


                                                                                                                class PwgInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.power_group_redundancy_mode = None
                                                                                                                        self.power_group_power_units = None
                                                                                                                        self.power_group_available_current = None
                                                                                                                        self.power_group_drawn_current = None
                                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo']['meta_info']


                                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.units = None
                                                                                                                        self.value = None
                                                                                                                        self.data_type = None
                                                                                                                        self.status = None
                                                                                                                        self.update_rate = None

                                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                                    class Threshold(_Entity_):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.threshold_array = YList(self)
                                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                        class ThresholdArray(_Entity_):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_name = None
                                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                                class InvAssetBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.part_number = None
                                                                                                                        self.manufacturer_assembly_number = None
                                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                                        self.manufacturer_software_identifier = None
                                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag']['meta_info']


                                                                                                                class Threshold(_Entity_):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo))])
                                                                                                                        self._leafs = OrderedDict()

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, [], name, value)


                                                                                                                    class MajorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                                    class CriticalHi(_Entity_):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                                    class MinorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                                    class MajorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                                    class CriticalLo(_Entity_):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                                    class MinorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold']['meta_info']


                                                                                                                class FruInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.card_administrative_state = None
                                                                                                                        self.power_administrative_state = None
                                                                                                                        self.card_operational_state = None
                                                                                                                        self.card_monitor_state = None
                                                                                                                        self.card_reset_reason = None
                                                                                                                        self.power_current_measurement = None
                                                                                                                        self.power_operational_state = None

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                                    class CardUpTime(_Entity_):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo']['meta_info']


                                                                                                                class InvEepromInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: form_factor
                                                                                                                    
                                                                                                                    	Optics form factor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: connector_type
                                                                                                                    
                                                                                                                    	Connector type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: otn_application_code
                                                                                                                    
                                                                                                                    	Otn Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: sonet_application_code
                                                                                                                    
                                                                                                                    	Sonet Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                                    
                                                                                                                    	Ethernet Compliance Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: date_string
                                                                                                                    
                                                                                                                    	Date string in IDPROM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.inv_card_type = None
                                                                                                                        self.opaque_data = None
                                                                                                                        self.opaque_data_size = None
                                                                                                                        self.has_eeprom = None
                                                                                                                        self.description = None
                                                                                                                        self.form_factor = None
                                                                                                                        self.connector_type = None
                                                                                                                        self.otn_application_code = None
                                                                                                                        self.sonet_application_code = None
                                                                                                                        self.ethernet_compliance_code = None
                                                                                                                        self.date_string = None

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                                    class Eeprom(_Entity_):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci_alpha_number
                                                                                                                        
                                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                            ])
                                                                                                                            self.description = None
                                                                                                                            self.idprom_format_rev = None
                                                                                                                            self.controller_family = None
                                                                                                                            self.controller_type = None
                                                                                                                            self.vid = None
                                                                                                                            self.hwid = None
                                                                                                                            self.pid = None
                                                                                                                            self.udi_description = None
                                                                                                                            self.udi_name = None
                                                                                                                            self.clei = None
                                                                                                                            self.eci = None
                                                                                                                            self.top_assem_part_num = None
                                                                                                                            self.top_assem_vid = None
                                                                                                                            self.pca_num = None
                                                                                                                            self.pcavid = None
                                                                                                                            self.chassis_sid = None
                                                                                                                            self.dev_num1 = None
                                                                                                                            self.dev_num2 = None
                                                                                                                            self.dev_num3 = None
                                                                                                                            self.dev_num4 = None
                                                                                                                            self.dev_num5 = None
                                                                                                                            self.dev_num6 = None
                                                                                                                            self.dev_num7 = None
                                                                                                                            self.manu_test_data = None
                                                                                                                            self.asset_id = None
                                                                                                                            self.asset_alias = None
                                                                                                                            self.base_mac_address1 = None
                                                                                                                            self.mac_add_blk_size1 = None
                                                                                                                            self.base_mac_address2 = None
                                                                                                                            self.mac_add_blk_size2 = None
                                                                                                                            self.base_mac_address3 = None
                                                                                                                            self.mac_add_blk_size3 = None
                                                                                                                            self.base_mac_address4 = None
                                                                                                                            self.mac_add_blk_size4 = None
                                                                                                                            self.pcb_serial_num = None
                                                                                                                            self.power_supply_type = None
                                                                                                                            self.power_consumption = None
                                                                                                                            self.block_signature = None
                                                                                                                            self.block_version = None
                                                                                                                            self.block_length = None
                                                                                                                            self.block_checksum = None
                                                                                                                            self.eeprom_size = None
                                                                                                                            self.block_count = None
                                                                                                                            self.fru_major_type = None
                                                                                                                            self.fru_minor_type = None
                                                                                                                            self.oem_string = None
                                                                                                                            self.product_id = None
                                                                                                                            self.serial_number = None
                                                                                                                            self.part_number = None
                                                                                                                            self.part_revision = None
                                                                                                                            self.mfg_deviation = None
                                                                                                                            self.hw_version = None
                                                                                                                            self.mfg_bits = None
                                                                                                                            self.engineer_use = None
                                                                                                                            self.snmpoid = None
                                                                                                                            self.rma_code = None
                                                                                                                            self.eci_alpha_number = None

                                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                        class Rma(_Entity_):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.test_history = None
                                                                                                                                self.rma_number = None
                                                                                                                                self.rma_history = None
                                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s']['meta_info']


                                                                                                    class Attributes(_Entity_):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._segment_path = lambda: "attributes"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, [], name, value)


                                                                                                        class InvBasicBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: allocated_power
                                                                                                            
                                                                                                            	Allocated power for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_capacity
                                                                                                            
                                                                                                            	Power Capacity of a Power Module
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.vendor_type = None
                                                                                                                self.name = None
                                                                                                                self.hardware_revision = None
                                                                                                                self.firmware_revision = None
                                                                                                                self.software_revision = None
                                                                                                                self.chip_hardware_revision = None
                                                                                                                self.serial_number = None
                                                                                                                self.manufacturer_name = None
                                                                                                                self.model_name = None
                                                                                                                self.asset_id_str = None
                                                                                                                self.asset_identification = None
                                                                                                                self.is_field_replaceable_unit = None
                                                                                                                self.manufacturer_asset_tags = None
                                                                                                                self.composite_class_code = None
                                                                                                                self.memory_size = None
                                                                                                                self.environmental_monitor_path = None
                                                                                                                self.alias = None
                                                                                                                self.group_flag = None
                                                                                                                self.new_deviation_number = None
                                                                                                                self.physical_layer_interface_module_type = None
                                                                                                                self.unrecognized_fru = None
                                                                                                                self.redundancystate = None
                                                                                                                self.ceport = None
                                                                                                                self.xr_scoped = None
                                                                                                                self.unique_id = None
                                                                                                                self.allocated_power = None
                                                                                                                self.power_capacity = None
                                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag']['meta_info']


                                                                                                        class EnvSensorInfo(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: average
                                                                                                            
                                                                                                            	Average sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minimum
                                                                                                            
                                                                                                            	Minimum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: maximum
                                                                                                            
                                                                                                            	Maximum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: interval
                                                                                                            
                                                                                                            	Time Interval over which sensor value is monitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                ])
                                                                                                                self.field_validity_bitmap = None
                                                                                                                self.device_description = None
                                                                                                                self.units = None
                                                                                                                self.device_id = None
                                                                                                                self.value = None
                                                                                                                self.alarm_type = None
                                                                                                                self.data_type = None
                                                                                                                self.scale = None
                                                                                                                self.precision = None
                                                                                                                self.status = None
                                                                                                                self.age_time_stamp = None
                                                                                                                self.update_rate = None
                                                                                                                self.average = None
                                                                                                                self.minimum = None
                                                                                                                self.maximum = None
                                                                                                                self.interval = None
                                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo']['meta_info']


                                                                                                        class PwgInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                ])
                                                                                                                self.power_group_redundancy_mode = None
                                                                                                                self.power_group_power_units = None
                                                                                                                self.power_group_available_current = None
                                                                                                                self.power_group_drawn_current = None
                                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo']['meta_info']


                                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.units = None
                                                                                                                self.value = None
                                                                                                                self.data_type = None
                                                                                                                self.status = None
                                                                                                                self.update_rate = None

                                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                            class Threshold(_Entity_):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.threshold_array = YList(self)
                                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                class ThresholdArray(_Entity_):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_name = None
                                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                        class InvAssetBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.part_number = None
                                                                                                                self.manufacturer_assembly_number = None
                                                                                                                self.manufacturer_assembly_revision = None
                                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                                self.manufacturer_software_identifier = None
                                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag']['meta_info']


                                                                                                        class Threshold(_Entity_):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo))])
                                                                                                                self._leafs = OrderedDict()

                                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._segment_path = lambda: "threshold"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, [], name, value)


                                                                                                            class MajorLo(_Entity_):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                            class CriticalHi(_Entity_):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                            class MinorHi(_Entity_):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                            class MajorHi(_Entity_):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                            class CriticalLo(_Entity_):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                            class MinorLo(_Entity_):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold']['meta_info']


                                                                                                        class FruInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                ])
                                                                                                                self.card_administrative_state = None
                                                                                                                self.power_administrative_state = None
                                                                                                                self.card_operational_state = None
                                                                                                                self.card_monitor_state = None
                                                                                                                self.card_reset_reason = None
                                                                                                                self.power_current_measurement = None
                                                                                                                self.power_operational_state = None

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                            class CardUpTime(_Entity_):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo']['meta_info']


                                                                                                        class InvEepromInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: form_factor
                                                                                                            
                                                                                                            	Optics form factor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: connector_type
                                                                                                            
                                                                                                            	Connector type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: otn_application_code
                                                                                                            
                                                                                                            	Otn Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: sonet_application_code
                                                                                                            
                                                                                                            	Sonet Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ethernet_compliance_code
                                                                                                            
                                                                                                            	Ethernet Compliance Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: date_string
                                                                                                            
                                                                                                            	Date string in IDPROM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.inv_card_type = None
                                                                                                                self.opaque_data = None
                                                                                                                self.opaque_data_size = None
                                                                                                                self.has_eeprom = None
                                                                                                                self.description = None
                                                                                                                self.form_factor = None
                                                                                                                self.connector_type = None
                                                                                                                self.otn_application_code = None
                                                                                                                self.sonet_application_code = None
                                                                                                                self.ethernet_compliance_code = None
                                                                                                                self.date_string = None

                                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                            class Eeprom(_Entity_):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci_alpha_number
                                                                                                                
                                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                    ])
                                                                                                                    self.description = None
                                                                                                                    self.idprom_format_rev = None
                                                                                                                    self.controller_family = None
                                                                                                                    self.controller_type = None
                                                                                                                    self.vid = None
                                                                                                                    self.hwid = None
                                                                                                                    self.pid = None
                                                                                                                    self.udi_description = None
                                                                                                                    self.udi_name = None
                                                                                                                    self.clei = None
                                                                                                                    self.eci = None
                                                                                                                    self.top_assem_part_num = None
                                                                                                                    self.top_assem_vid = None
                                                                                                                    self.pca_num = None
                                                                                                                    self.pcavid = None
                                                                                                                    self.chassis_sid = None
                                                                                                                    self.dev_num1 = None
                                                                                                                    self.dev_num2 = None
                                                                                                                    self.dev_num3 = None
                                                                                                                    self.dev_num4 = None
                                                                                                                    self.dev_num5 = None
                                                                                                                    self.dev_num6 = None
                                                                                                                    self.dev_num7 = None
                                                                                                                    self.manu_test_data = None
                                                                                                                    self.asset_id = None
                                                                                                                    self.asset_alias = None
                                                                                                                    self.base_mac_address1 = None
                                                                                                                    self.mac_add_blk_size1 = None
                                                                                                                    self.base_mac_address2 = None
                                                                                                                    self.mac_add_blk_size2 = None
                                                                                                                    self.base_mac_address3 = None
                                                                                                                    self.mac_add_blk_size3 = None
                                                                                                                    self.base_mac_address4 = None
                                                                                                                    self.mac_add_blk_size4 = None
                                                                                                                    self.pcb_serial_num = None
                                                                                                                    self.power_supply_type = None
                                                                                                                    self.power_consumption = None
                                                                                                                    self.block_signature = None
                                                                                                                    self.block_version = None
                                                                                                                    self.block_length = None
                                                                                                                    self.block_checksum = None
                                                                                                                    self.eeprom_size = None
                                                                                                                    self.block_count = None
                                                                                                                    self.fru_major_type = None
                                                                                                                    self.fru_minor_type = None
                                                                                                                    self.oem_string = None
                                                                                                                    self.product_id = None
                                                                                                                    self.serial_number = None
                                                                                                                    self.part_number = None
                                                                                                                    self.part_revision = None
                                                                                                                    self.mfg_deviation = None
                                                                                                                    self.hw_version = None
                                                                                                                    self.mfg_bits = None
                                                                                                                    self.engineer_use = None
                                                                                                                    self.snmpoid = None
                                                                                                                    self.rma_code = None
                                                                                                                    self.eci_alpha_number = None

                                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                class Rma(_Entity_):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.test_history = None
                                                                                                                        self.rma_number = None
                                                                                                                        self.rma_history = None
                                                                                                                        self._segment_path = lambda: "rma"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s']['meta_info']


                                                                                            class Attributes(_Entity_):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, [], name, value)


                                                                                                class InvBasicBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: allocated_power
                                                                                                    
                                                                                                    	Allocated power for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_capacity
                                                                                                    
                                                                                                    	Power Capacity of a Power Module
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.vendor_type = None
                                                                                                        self.name = None
                                                                                                        self.hardware_revision = None
                                                                                                        self.firmware_revision = None
                                                                                                        self.software_revision = None
                                                                                                        self.chip_hardware_revision = None
                                                                                                        self.serial_number = None
                                                                                                        self.manufacturer_name = None
                                                                                                        self.model_name = None
                                                                                                        self.asset_id_str = None
                                                                                                        self.asset_identification = None
                                                                                                        self.is_field_replaceable_unit = None
                                                                                                        self.manufacturer_asset_tags = None
                                                                                                        self.composite_class_code = None
                                                                                                        self.memory_size = None
                                                                                                        self.environmental_monitor_path = None
                                                                                                        self.alias = None
                                                                                                        self.group_flag = None
                                                                                                        self.new_deviation_number = None
                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                        self.unrecognized_fru = None
                                                                                                        self.redundancystate = None
                                                                                                        self.ceport = None
                                                                                                        self.xr_scoped = None
                                                                                                        self.unique_id = None
                                                                                                        self.allocated_power = None
                                                                                                        self.power_capacity = None
                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag']['meta_info']


                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: average
                                                                                                    
                                                                                                    	Average sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minimum
                                                                                                    
                                                                                                    	Minimum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: maximum
                                                                                                    
                                                                                                    	Maximum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: interval
                                                                                                    
                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                        ])
                                                                                                        self.field_validity_bitmap = None
                                                                                                        self.device_description = None
                                                                                                        self.units = None
                                                                                                        self.device_id = None
                                                                                                        self.value = None
                                                                                                        self.alarm_type = None
                                                                                                        self.data_type = None
                                                                                                        self.scale = None
                                                                                                        self.precision = None
                                                                                                        self.status = None
                                                                                                        self.age_time_stamp = None
                                                                                                        self.update_rate = None
                                                                                                        self.average = None
                                                                                                        self.minimum = None
                                                                                                        self.maximum = None
                                                                                                        self.interval = None
                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo']['meta_info']


                                                                                                class PwgInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                        ])
                                                                                                        self.power_group_redundancy_mode = None
                                                                                                        self.power_group_power_units = None
                                                                                                        self.power_group_available_current = None
                                                                                                        self.power_group_drawn_current = None
                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo']['meta_info']


                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.units = None
                                                                                                        self.value = None
                                                                                                        self.data_type = None
                                                                                                        self.status = None
                                                                                                        self.update_rate = None

                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                    class Threshold(_Entity_):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.threshold_array = YList(self)
                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                        class ThresholdArray(_Entity_):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_name = None
                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                class InvAssetBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.part_number = None
                                                                                                        self.manufacturer_assembly_number = None
                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                        self.manufacturer_software_identifier = None
                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag']['meta_info']


                                                                                                class Threshold(_Entity_):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, [], name, value)


                                                                                                    class MajorLo(_Entity_):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                    class CriticalHi(_Entity_):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                    class MinorHi(_Entity_):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                    class MajorHi(_Entity_):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                    class CriticalLo(_Entity_):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                    class MinorLo(_Entity_):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold']['meta_info']


                                                                                                class FruInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                        ])
                                                                                                        self.card_administrative_state = None
                                                                                                        self.power_administrative_state = None
                                                                                                        self.card_operational_state = None
                                                                                                        self.card_monitor_state = None
                                                                                                        self.card_reset_reason = None
                                                                                                        self.power_current_measurement = None
                                                                                                        self.power_operational_state = None

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                    class CardUpTime(_Entity_):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo']['meta_info']


                                                                                                class InvEepromInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: form_factor
                                                                                                    
                                                                                                    	Optics form factor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: connector_type
                                                                                                    
                                                                                                    	Connector type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: otn_application_code
                                                                                                    
                                                                                                    	Otn Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: sonet_application_code
                                                                                                    
                                                                                                    	Sonet Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                    
                                                                                                    	Ethernet Compliance Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: date_string
                                                                                                    
                                                                                                    	Date string in IDPROM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.inv_card_type = None
                                                                                                        self.opaque_data = None
                                                                                                        self.opaque_data_size = None
                                                                                                        self.has_eeprom = None
                                                                                                        self.description = None
                                                                                                        self.form_factor = None
                                                                                                        self.connector_type = None
                                                                                                        self.otn_application_code = None
                                                                                                        self.sonet_application_code = None
                                                                                                        self.ethernet_compliance_code = None
                                                                                                        self.date_string = None

                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                    class Eeprom(_Entity_):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci_alpha_number
                                                                                                        
                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                            ])
                                                                                                            self.description = None
                                                                                                            self.idprom_format_rev = None
                                                                                                            self.controller_family = None
                                                                                                            self.controller_type = None
                                                                                                            self.vid = None
                                                                                                            self.hwid = None
                                                                                                            self.pid = None
                                                                                                            self.udi_description = None
                                                                                                            self.udi_name = None
                                                                                                            self.clei = None
                                                                                                            self.eci = None
                                                                                                            self.top_assem_part_num = None
                                                                                                            self.top_assem_vid = None
                                                                                                            self.pca_num = None
                                                                                                            self.pcavid = None
                                                                                                            self.chassis_sid = None
                                                                                                            self.dev_num1 = None
                                                                                                            self.dev_num2 = None
                                                                                                            self.dev_num3 = None
                                                                                                            self.dev_num4 = None
                                                                                                            self.dev_num5 = None
                                                                                                            self.dev_num6 = None
                                                                                                            self.dev_num7 = None
                                                                                                            self.manu_test_data = None
                                                                                                            self.asset_id = None
                                                                                                            self.asset_alias = None
                                                                                                            self.base_mac_address1 = None
                                                                                                            self.mac_add_blk_size1 = None
                                                                                                            self.base_mac_address2 = None
                                                                                                            self.mac_add_blk_size2 = None
                                                                                                            self.base_mac_address3 = None
                                                                                                            self.mac_add_blk_size3 = None
                                                                                                            self.base_mac_address4 = None
                                                                                                            self.mac_add_blk_size4 = None
                                                                                                            self.pcb_serial_num = None
                                                                                                            self.power_supply_type = None
                                                                                                            self.power_consumption = None
                                                                                                            self.block_signature = None
                                                                                                            self.block_version = None
                                                                                                            self.block_length = None
                                                                                                            self.block_checksum = None
                                                                                                            self.eeprom_size = None
                                                                                                            self.block_count = None
                                                                                                            self.fru_major_type = None
                                                                                                            self.fru_minor_type = None
                                                                                                            self.oem_string = None
                                                                                                            self.product_id = None
                                                                                                            self.serial_number = None
                                                                                                            self.part_number = None
                                                                                                            self.part_revision = None
                                                                                                            self.mfg_deviation = None
                                                                                                            self.hw_version = None
                                                                                                            self.mfg_bits = None
                                                                                                            self.engineer_use = None
                                                                                                            self.snmpoid = None
                                                                                                            self.rma_code = None
                                                                                                            self.eci_alpha_number = None

                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                        class Rma(_Entity_):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                ])
                                                                                                                self.test_history = None
                                                                                                                self.rma_number = None
                                                                                                                self.rma_history = None
                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s']['meta_info']


                                                                                    class Attributes(_Entity_):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._segment_path = lambda: "attributes"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, [], name, value)


                                                                                        class InvBasicBag(_Entity_):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: allocated_power
                                                                                            
                                                                                            	Allocated power for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_capacity
                                                                                            
                                                                                            	Power Capacity of a Power Module
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.vendor_type = None
                                                                                                self.name = None
                                                                                                self.hardware_revision = None
                                                                                                self.firmware_revision = None
                                                                                                self.software_revision = None
                                                                                                self.chip_hardware_revision = None
                                                                                                self.serial_number = None
                                                                                                self.manufacturer_name = None
                                                                                                self.model_name = None
                                                                                                self.asset_id_str = None
                                                                                                self.asset_identification = None
                                                                                                self.is_field_replaceable_unit = None
                                                                                                self.manufacturer_asset_tags = None
                                                                                                self.composite_class_code = None
                                                                                                self.memory_size = None
                                                                                                self.environmental_monitor_path = None
                                                                                                self.alias = None
                                                                                                self.group_flag = None
                                                                                                self.new_deviation_number = None
                                                                                                self.physical_layer_interface_module_type = None
                                                                                                self.unrecognized_fru = None
                                                                                                self.redundancystate = None
                                                                                                self.ceport = None
                                                                                                self.xr_scoped = None
                                                                                                self.unique_id = None
                                                                                                self.allocated_power = None
                                                                                                self.power_capacity = None
                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag']['meta_info']


                                                                                        class EnvSensorInfo(_Entity_):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: average
                                                                                            
                                                                                            	Average sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minimum
                                                                                            
                                                                                            	Minimum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: maximum
                                                                                            
                                                                                            	Maximum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: interval
                                                                                            
                                                                                            	Time Interval over which sensor value is monitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                ])
                                                                                                self.field_validity_bitmap = None
                                                                                                self.device_description = None
                                                                                                self.units = None
                                                                                                self.device_id = None
                                                                                                self.value = None
                                                                                                self.alarm_type = None
                                                                                                self.data_type = None
                                                                                                self.scale = None
                                                                                                self.precision = None
                                                                                                self.status = None
                                                                                                self.age_time_stamp = None
                                                                                                self.update_rate = None
                                                                                                self.average = None
                                                                                                self.minimum = None
                                                                                                self.maximum = None
                                                                                                self.interval = None
                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo']['meta_info']


                                                                                        class PwgInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                ])
                                                                                                self.power_group_redundancy_mode = None
                                                                                                self.power_group_power_units = None
                                                                                                self.power_group_available_current = None
                                                                                                self.power_group_drawn_current = None
                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo']['meta_info']


                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.units = None
                                                                                                self.value = None
                                                                                                self.data_type = None
                                                                                                self.status = None
                                                                                                self.update_rate = None

                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                            class Threshold(_Entity_):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.threshold_array = YList(self)
                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                class ThresholdArray(_Entity_):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_name = None
                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                        class InvAssetBag(_Entity_):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                ])
                                                                                                self.part_number = None
                                                                                                self.manufacturer_assembly_number = None
                                                                                                self.manufacturer_assembly_revision = None
                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                self.manufacturer_software_identifier = None
                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag']['meta_info']


                                                                                        class Threshold(_Entity_):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._segment_path = lambda: "threshold"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, [], name, value)


                                                                                            class MajorLo(_Entity_):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo']['meta_info']


                                                                                            class CriticalHi(_Entity_):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                            class MinorHi(_Entity_):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi']['meta_info']


                                                                                            class MajorHi(_Entity_):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi']['meta_info']


                                                                                            class CriticalLo(_Entity_):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                            class MinorLo(_Entity_):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold']['meta_info']


                                                                                        class FruInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                ])
                                                                                                self.card_administrative_state = None
                                                                                                self.power_administrative_state = None
                                                                                                self.card_operational_state = None
                                                                                                self.card_monitor_state = None
                                                                                                self.card_reset_reason = None
                                                                                                self.power_current_measurement = None
                                                                                                self.power_operational_state = None

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                            class CardUpTime(_Entity_):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo']['meta_info']


                                                                                        class InvEepromInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: form_factor
                                                                                            
                                                                                            	Optics form factor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: connector_type
                                                                                            
                                                                                            	Connector type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: otn_application_code
                                                                                            
                                                                                            	Otn Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: sonet_application_code
                                                                                            
                                                                                            	Sonet Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ethernet_compliance_code
                                                                                            
                                                                                            	Ethernet Compliance Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: date_string
                                                                                            
                                                                                            	Date string in IDPROM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                ])
                                                                                                self.inv_card_type = None
                                                                                                self.opaque_data = None
                                                                                                self.opaque_data_size = None
                                                                                                self.has_eeprom = None
                                                                                                self.description = None
                                                                                                self.form_factor = None
                                                                                                self.connector_type = None
                                                                                                self.otn_application_code = None
                                                                                                self.sonet_application_code = None
                                                                                                self.ethernet_compliance_code = None
                                                                                                self.date_string = None

                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                            class Eeprom(_Entity_):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci_alpha_number
                                                                                                
                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                    ])
                                                                                                    self.description = None
                                                                                                    self.idprom_format_rev = None
                                                                                                    self.controller_family = None
                                                                                                    self.controller_type = None
                                                                                                    self.vid = None
                                                                                                    self.hwid = None
                                                                                                    self.pid = None
                                                                                                    self.udi_description = None
                                                                                                    self.udi_name = None
                                                                                                    self.clei = None
                                                                                                    self.eci = None
                                                                                                    self.top_assem_part_num = None
                                                                                                    self.top_assem_vid = None
                                                                                                    self.pca_num = None
                                                                                                    self.pcavid = None
                                                                                                    self.chassis_sid = None
                                                                                                    self.dev_num1 = None
                                                                                                    self.dev_num2 = None
                                                                                                    self.dev_num3 = None
                                                                                                    self.dev_num4 = None
                                                                                                    self.dev_num5 = None
                                                                                                    self.dev_num6 = None
                                                                                                    self.dev_num7 = None
                                                                                                    self.manu_test_data = None
                                                                                                    self.asset_id = None
                                                                                                    self.asset_alias = None
                                                                                                    self.base_mac_address1 = None
                                                                                                    self.mac_add_blk_size1 = None
                                                                                                    self.base_mac_address2 = None
                                                                                                    self.mac_add_blk_size2 = None
                                                                                                    self.base_mac_address3 = None
                                                                                                    self.mac_add_blk_size3 = None
                                                                                                    self.base_mac_address4 = None
                                                                                                    self.mac_add_blk_size4 = None
                                                                                                    self.pcb_serial_num = None
                                                                                                    self.power_supply_type = None
                                                                                                    self.power_consumption = None
                                                                                                    self.block_signature = None
                                                                                                    self.block_version = None
                                                                                                    self.block_length = None
                                                                                                    self.block_checksum = None
                                                                                                    self.eeprom_size = None
                                                                                                    self.block_count = None
                                                                                                    self.fru_major_type = None
                                                                                                    self.fru_minor_type = None
                                                                                                    self.oem_string = None
                                                                                                    self.product_id = None
                                                                                                    self.serial_number = None
                                                                                                    self.part_number = None
                                                                                                    self.part_revision = None
                                                                                                    self.mfg_deviation = None
                                                                                                    self.hw_version = None
                                                                                                    self.mfg_bits = None
                                                                                                    self.engineer_use = None
                                                                                                    self.snmpoid = None
                                                                                                    self.rma_code = None
                                                                                                    self.eci_alpha_number = None

                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                class Rma(_Entity_):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                        ])
                                                                                                        self.test_history = None
                                                                                                        self.rma_number = None
                                                                                                        self.rma_history = None
                                                                                                        self._segment_path = lambda: "rma"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s']['meta_info']


                                                                            class Attributes(_Entity_):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._segment_path = lambda: "attributes"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, [], name, value)


                                                                                class InvBasicBag(_Entity_):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: allocated_power
                                                                                    
                                                                                    	Allocated power for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_capacity
                                                                                    
                                                                                    	Power Capacity of a Power Module
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.vendor_type = None
                                                                                        self.name = None
                                                                                        self.hardware_revision = None
                                                                                        self.firmware_revision = None
                                                                                        self.software_revision = None
                                                                                        self.chip_hardware_revision = None
                                                                                        self.serial_number = None
                                                                                        self.manufacturer_name = None
                                                                                        self.model_name = None
                                                                                        self.asset_id_str = None
                                                                                        self.asset_identification = None
                                                                                        self.is_field_replaceable_unit = None
                                                                                        self.manufacturer_asset_tags = None
                                                                                        self.composite_class_code = None
                                                                                        self.memory_size = None
                                                                                        self.environmental_monitor_path = None
                                                                                        self.alias = None
                                                                                        self.group_flag = None
                                                                                        self.new_deviation_number = None
                                                                                        self.physical_layer_interface_module_type = None
                                                                                        self.unrecognized_fru = None
                                                                                        self.redundancystate = None
                                                                                        self.ceport = None
                                                                                        self.xr_scoped = None
                                                                                        self.unique_id = None
                                                                                        self.allocated_power = None
                                                                                        self.power_capacity = None
                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag']['meta_info']


                                                                                class EnvSensorInfo(_Entity_):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: average
                                                                                    
                                                                                    	Average sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minimum
                                                                                    
                                                                                    	Minimum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: maximum
                                                                                    
                                                                                    	Maximum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: interval
                                                                                    
                                                                                    	Time Interval over which sensor value is monitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                        ])
                                                                                        self.field_validity_bitmap = None
                                                                                        self.device_description = None
                                                                                        self.units = None
                                                                                        self.device_id = None
                                                                                        self.value = None
                                                                                        self.alarm_type = None
                                                                                        self.data_type = None
                                                                                        self.scale = None
                                                                                        self.precision = None
                                                                                        self.status = None
                                                                                        self.age_time_stamp = None
                                                                                        self.update_rate = None
                                                                                        self.average = None
                                                                                        self.minimum = None
                                                                                        self.maximum = None
                                                                                        self.interval = None
                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo']['meta_info']


                                                                                class PwgInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                        ])
                                                                                        self.power_group_redundancy_mode = None
                                                                                        self.power_group_power_units = None
                                                                                        self.power_group_available_current = None
                                                                                        self.power_group_drawn_current = None
                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo']['meta_info']


                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.units = None
                                                                                        self.value = None
                                                                                        self.data_type = None
                                                                                        self.status = None
                                                                                        self.update_rate = None

                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                    class Threshold(_Entity_):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.threshold_array = YList(self)
                                                                                            self._segment_path = lambda: "threshold"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                        class ThresholdArray(_Entity_):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_name = None
                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                class InvAssetBag(_Entity_):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                        ])
                                                                                        self.part_number = None
                                                                                        self.manufacturer_assembly_number = None
                                                                                        self.manufacturer_assembly_revision = None
                                                                                        self.manufacturer_firmware_identifier = None
                                                                                        self.manufacturer_software_identifier = None
                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                        self.original_equipment_manufacturer_string = None
                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag']['meta_info']


                                                                                class Threshold(_Entity_):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._segment_path = lambda: "threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, [], name, value)


                                                                                    class MajorLo(_Entity_):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo']['meta_info']


                                                                                    class CriticalHi(_Entity_):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                    class MinorHi(_Entity_):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi']['meta_info']


                                                                                    class MajorHi(_Entity_):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi']['meta_info']


                                                                                    class CriticalLo(_Entity_):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                    class MinorLo(_Entity_):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold']['meta_info']


                                                                                class FruInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                        ])
                                                                                        self.card_administrative_state = None
                                                                                        self.power_administrative_state = None
                                                                                        self.card_operational_state = None
                                                                                        self.card_monitor_state = None
                                                                                        self.card_reset_reason = None
                                                                                        self.power_current_measurement = None
                                                                                        self.power_operational_state = None

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._segment_path = lambda: "fru-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                    class CardUpTime(_Entity_):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo']['meta_info']


                                                                                class InvEepromInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: form_factor
                                                                                    
                                                                                    	Optics form factor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: connector_type
                                                                                    
                                                                                    	Connector type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: otn_application_code
                                                                                    
                                                                                    	Otn Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: sonet_application_code
                                                                                    
                                                                                    	Sonet Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ethernet_compliance_code
                                                                                    
                                                                                    	Ethernet Compliance Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: date_string
                                                                                    
                                                                                    	Date string in IDPROM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                        ])
                                                                                        self.inv_card_type = None
                                                                                        self.opaque_data = None
                                                                                        self.opaque_data_size = None
                                                                                        self.has_eeprom = None
                                                                                        self.description = None
                                                                                        self.form_factor = None
                                                                                        self.connector_type = None
                                                                                        self.otn_application_code = None
                                                                                        self.sonet_application_code = None
                                                                                        self.ethernet_compliance_code = None
                                                                                        self.date_string = None

                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                    class Eeprom(_Entity_):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci_alpha_number
                                                                                        
                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                            ])
                                                                                            self.description = None
                                                                                            self.idprom_format_rev = None
                                                                                            self.controller_family = None
                                                                                            self.controller_type = None
                                                                                            self.vid = None
                                                                                            self.hwid = None
                                                                                            self.pid = None
                                                                                            self.udi_description = None
                                                                                            self.udi_name = None
                                                                                            self.clei = None
                                                                                            self.eci = None
                                                                                            self.top_assem_part_num = None
                                                                                            self.top_assem_vid = None
                                                                                            self.pca_num = None
                                                                                            self.pcavid = None
                                                                                            self.chassis_sid = None
                                                                                            self.dev_num1 = None
                                                                                            self.dev_num2 = None
                                                                                            self.dev_num3 = None
                                                                                            self.dev_num4 = None
                                                                                            self.dev_num5 = None
                                                                                            self.dev_num6 = None
                                                                                            self.dev_num7 = None
                                                                                            self.manu_test_data = None
                                                                                            self.asset_id = None
                                                                                            self.asset_alias = None
                                                                                            self.base_mac_address1 = None
                                                                                            self.mac_add_blk_size1 = None
                                                                                            self.base_mac_address2 = None
                                                                                            self.mac_add_blk_size2 = None
                                                                                            self.base_mac_address3 = None
                                                                                            self.mac_add_blk_size3 = None
                                                                                            self.base_mac_address4 = None
                                                                                            self.mac_add_blk_size4 = None
                                                                                            self.pcb_serial_num = None
                                                                                            self.power_supply_type = None
                                                                                            self.power_consumption = None
                                                                                            self.block_signature = None
                                                                                            self.block_version = None
                                                                                            self.block_length = None
                                                                                            self.block_checksum = None
                                                                                            self.eeprom_size = None
                                                                                            self.block_count = None
                                                                                            self.fru_major_type = None
                                                                                            self.fru_minor_type = None
                                                                                            self.oem_string = None
                                                                                            self.product_id = None
                                                                                            self.serial_number = None
                                                                                            self.part_number = None
                                                                                            self.part_revision = None
                                                                                            self.mfg_deviation = None
                                                                                            self.hw_version = None
                                                                                            self.mfg_bits = None
                                                                                            self.engineer_use = None
                                                                                            self.snmpoid = None
                                                                                            self.rma_code = None
                                                                                            self.eci_alpha_number = None

                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._segment_path = lambda: "eeprom"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                        class Rma(_Entity_):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                ])
                                                                                                self.test_history = None
                                                                                                self.rma_number = None
                                                                                                self.rma_history = None
                                                                                                self._segment_path = lambda: "rma"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s']['meta_info']


                                                                    class Attributes(_Entity_):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"

                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._segment_path = lambda: "attributes"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, [], name, value)


                                                                        class InvBasicBag(_Entity_):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: allocated_power
                                                                            
                                                                            	Allocated power for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_capacity
                                                                            
                                                                            	Power Capacity of a Power Module
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.vendor_type = None
                                                                                self.name = None
                                                                                self.hardware_revision = None
                                                                                self.firmware_revision = None
                                                                                self.software_revision = None
                                                                                self.chip_hardware_revision = None
                                                                                self.serial_number = None
                                                                                self.manufacturer_name = None
                                                                                self.model_name = None
                                                                                self.asset_id_str = None
                                                                                self.asset_identification = None
                                                                                self.is_field_replaceable_unit = None
                                                                                self.manufacturer_asset_tags = None
                                                                                self.composite_class_code = None
                                                                                self.memory_size = None
                                                                                self.environmental_monitor_path = None
                                                                                self.alias = None
                                                                                self.group_flag = None
                                                                                self.new_deviation_number = None
                                                                                self.physical_layer_interface_module_type = None
                                                                                self.unrecognized_fru = None
                                                                                self.redundancystate = None
                                                                                self.ceport = None
                                                                                self.xr_scoped = None
                                                                                self.unique_id = None
                                                                                self.allocated_power = None
                                                                                self.power_capacity = None
                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag']['meta_info']


                                                                        class EnvSensorInfo(_Entity_):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: average
                                                                            
                                                                            	Average sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minimum
                                                                            
                                                                            	Minimum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: maximum
                                                                            
                                                                            	Maximum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: interval
                                                                            
                                                                            	Time Interval over which sensor value is monitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                ])
                                                                                self.field_validity_bitmap = None
                                                                                self.device_description = None
                                                                                self.units = None
                                                                                self.device_id = None
                                                                                self.value = None
                                                                                self.alarm_type = None
                                                                                self.data_type = None
                                                                                self.scale = None
                                                                                self.precision = None
                                                                                self.status = None
                                                                                self.age_time_stamp = None
                                                                                self.update_rate = None
                                                                                self.average = None
                                                                                self.minimum = None
                                                                                self.maximum = None
                                                                                self.interval = None
                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo']['meta_info']


                                                                        class PwgInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\: str
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                ])
                                                                                self.power_group_redundancy_mode = None
                                                                                self.power_group_power_units = None
                                                                                self.power_group_available_current = None
                                                                                self.power_group_drawn_current = None
                                                                                self._segment_path = lambda: "pwg-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo']['meta_info']


                                                                        class EnvSensorInfoXml(_Entity_):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.units = None
                                                                                self.value = None
                                                                                self.data_type = None
                                                                                self.status = None
                                                                                self.update_rate = None

                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                            class Threshold(_Entity_):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.threshold_array = YList(self)
                                                                                    self._segment_path = lambda: "threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                class ThresholdArray(_Entity_):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_name = None
                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml']['meta_info']


                                                                        class InvAssetBag(_Entity_):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                ])
                                                                                self.part_number = None
                                                                                self.manufacturer_assembly_number = None
                                                                                self.manufacturer_assembly_revision = None
                                                                                self.manufacturer_firmware_identifier = None
                                                                                self.manufacturer_software_identifier = None
                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                self.original_equipment_manufacturer_string = None
                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag']['meta_info']


                                                                        class Threshold(_Entity_):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._segment_path = lambda: "threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, [], name, value)


                                                                            class MajorLo(_Entity_):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo']['meta_info']


                                                                            class CriticalHi(_Entity_):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi']['meta_info']


                                                                            class MinorHi(_Entity_):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi']['meta_info']


                                                                            class MajorHi(_Entity_):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi']['meta_info']


                                                                            class CriticalLo(_Entity_):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo']['meta_info']


                                                                            class MinorLo(_Entity_):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold']['meta_info']


                                                                        class FruInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                ])
                                                                                self.card_administrative_state = None
                                                                                self.power_administrative_state = None
                                                                                self.card_operational_state = None
                                                                                self.card_monitor_state = None
                                                                                self.card_reset_reason = None
                                                                                self.power_current_measurement = None
                                                                                self.power_operational_state = None

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._segment_path = lambda: "fru-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                            class LastOperationalStateChange(_Entity_):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                            class CardUpTime(_Entity_):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo']['meta_info']


                                                                        class InvEepromInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: form_factor
                                                                            
                                                                            	Optics form factor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: connector_type
                                                                            
                                                                            	Connector type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: otn_application_code
                                                                            
                                                                            	Otn Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: sonet_application_code
                                                                            
                                                                            	Sonet Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ethernet_compliance_code
                                                                            
                                                                            	Ethernet Compliance Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: date_string
                                                                            
                                                                            	Date string in IDPROM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                ])
                                                                                self.inv_card_type = None
                                                                                self.opaque_data = None
                                                                                self.opaque_data_size = None
                                                                                self.has_eeprom = None
                                                                                self.description = None
                                                                                self.form_factor = None
                                                                                self.connector_type = None
                                                                                self.otn_application_code = None
                                                                                self.sonet_application_code = None
                                                                                self.ethernet_compliance_code = None
                                                                                self.date_string = None

                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                            class Eeprom(_Entity_):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci_alpha_number
                                                                                
                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                    ])
                                                                                    self.description = None
                                                                                    self.idprom_format_rev = None
                                                                                    self.controller_family = None
                                                                                    self.controller_type = None
                                                                                    self.vid = None
                                                                                    self.hwid = None
                                                                                    self.pid = None
                                                                                    self.udi_description = None
                                                                                    self.udi_name = None
                                                                                    self.clei = None
                                                                                    self.eci = None
                                                                                    self.top_assem_part_num = None
                                                                                    self.top_assem_vid = None
                                                                                    self.pca_num = None
                                                                                    self.pcavid = None
                                                                                    self.chassis_sid = None
                                                                                    self.dev_num1 = None
                                                                                    self.dev_num2 = None
                                                                                    self.dev_num3 = None
                                                                                    self.dev_num4 = None
                                                                                    self.dev_num5 = None
                                                                                    self.dev_num6 = None
                                                                                    self.dev_num7 = None
                                                                                    self.manu_test_data = None
                                                                                    self.asset_id = None
                                                                                    self.asset_alias = None
                                                                                    self.base_mac_address1 = None
                                                                                    self.mac_add_blk_size1 = None
                                                                                    self.base_mac_address2 = None
                                                                                    self.mac_add_blk_size2 = None
                                                                                    self.base_mac_address3 = None
                                                                                    self.mac_add_blk_size3 = None
                                                                                    self.base_mac_address4 = None
                                                                                    self.mac_add_blk_size4 = None
                                                                                    self.pcb_serial_num = None
                                                                                    self.power_supply_type = None
                                                                                    self.power_consumption = None
                                                                                    self.block_signature = None
                                                                                    self.block_version = None
                                                                                    self.block_length = None
                                                                                    self.block_checksum = None
                                                                                    self.eeprom_size = None
                                                                                    self.block_count = None
                                                                                    self.fru_major_type = None
                                                                                    self.fru_minor_type = None
                                                                                    self.oem_string = None
                                                                                    self.product_id = None
                                                                                    self.serial_number = None
                                                                                    self.part_number = None
                                                                                    self.part_revision = None
                                                                                    self.mfg_deviation = None
                                                                                    self.hw_version = None
                                                                                    self.mfg_bits = None
                                                                                    self.engineer_use = None
                                                                                    self.snmpoid = None
                                                                                    self.rma_code = None
                                                                                    self.eci_alpha_number = None

                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._segment_path = lambda: "eeprom"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                class Rma(_Entity_):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                        ])
                                                                                        self.test_history = None
                                                                                        self.rma_number = None
                                                                                        self.rma_history = None
                                                                                        self._segment_path = lambda: "rma"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s']['meta_info']


                                                            class Attributes(_Entity_):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"

                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._segment_path = lambda: "attributes"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, [], name, value)


                                                                class InvBasicBag(_Entity_):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: allocated_power
                                                                    
                                                                    	Allocated power for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_capacity
                                                                    
                                                                    	Power Capacity of a Power Module
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.vendor_type = None
                                                                        self.name = None
                                                                        self.hardware_revision = None
                                                                        self.firmware_revision = None
                                                                        self.software_revision = None
                                                                        self.chip_hardware_revision = None
                                                                        self.serial_number = None
                                                                        self.manufacturer_name = None
                                                                        self.model_name = None
                                                                        self.asset_id_str = None
                                                                        self.asset_identification = None
                                                                        self.is_field_replaceable_unit = None
                                                                        self.manufacturer_asset_tags = None
                                                                        self.composite_class_code = None
                                                                        self.memory_size = None
                                                                        self.environmental_monitor_path = None
                                                                        self.alias = None
                                                                        self.group_flag = None
                                                                        self.new_deviation_number = None
                                                                        self.physical_layer_interface_module_type = None
                                                                        self.unrecognized_fru = None
                                                                        self.redundancystate = None
                                                                        self.ceport = None
                                                                        self.xr_scoped = None
                                                                        self.unique_id = None
                                                                        self.allocated_power = None
                                                                        self.power_capacity = None
                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag']['meta_info']


                                                                class EnvSensorInfo(_Entity_):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: average
                                                                    
                                                                    	Average sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minimum
                                                                    
                                                                    	Minimum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: maximum
                                                                    
                                                                    	Maximum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: interval
                                                                    
                                                                    	Time Interval over which sensor value is monitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                        ])
                                                                        self.field_validity_bitmap = None
                                                                        self.device_description = None
                                                                        self.units = None
                                                                        self.device_id = None
                                                                        self.value = None
                                                                        self.alarm_type = None
                                                                        self.data_type = None
                                                                        self.scale = None
                                                                        self.precision = None
                                                                        self.status = None
                                                                        self.age_time_stamp = None
                                                                        self.update_rate = None
                                                                        self.average = None
                                                                        self.minimum = None
                                                                        self.maximum = None
                                                                        self.interval = None
                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo']['meta_info']


                                                                class PwgInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\: str
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                        ])
                                                                        self.power_group_redundancy_mode = None
                                                                        self.power_group_power_units = None
                                                                        self.power_group_available_current = None
                                                                        self.power_group_drawn_current = None
                                                                        self._segment_path = lambda: "pwg-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo']['meta_info']


                                                                class EnvSensorInfoXml(_Entity_):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.units = None
                                                                        self.value = None
                                                                        self.data_type = None
                                                                        self.status = None
                                                                        self.update_rate = None

                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                    class Threshold(_Entity_):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.threshold_array = YList(self)
                                                                            self._segment_path = lambda: "threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                        class ThresholdArray(_Entity_):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_name = None
                                                                                self._segment_path = lambda: "threshold-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml']['meta_info']


                                                                class InvAssetBag(_Entity_):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                        ])
                                                                        self.part_number = None
                                                                        self.manufacturer_assembly_number = None
                                                                        self.manufacturer_assembly_revision = None
                                                                        self.manufacturer_firmware_identifier = None
                                                                        self.manufacturer_software_identifier = None
                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                        self.original_equipment_manufacturer_string = None
                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag']['meta_info']


                                                                class Threshold(_Entity_):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._segment_path = lambda: "threshold"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, [], name, value)


                                                                    class MajorLo(_Entity_):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo']['meta_info']


                                                                    class CriticalHi(_Entity_):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi']['meta_info']


                                                                    class MinorHi(_Entity_):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi']['meta_info']


                                                                    class MajorHi(_Entity_):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi']['meta_info']


                                                                    class CriticalLo(_Entity_):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo']['meta_info']


                                                                    class MinorLo(_Entity_):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold']['meta_info']


                                                                class FruInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime))])
                                                                        self._leafs = OrderedDict([
                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                        ])
                                                                        self.card_administrative_state = None
                                                                        self.power_administrative_state = None
                                                                        self.card_operational_state = None
                                                                        self.card_monitor_state = None
                                                                        self.card_reset_reason = None
                                                                        self.power_current_measurement = None
                                                                        self.power_operational_state = None

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._segment_path = lambda: "fru-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                    class LastOperationalStateChange(_Entity_):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                    class CardUpTime(_Entity_):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "card-up-time"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo']['meta_info']


                                                                class InvEepromInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: form_factor
                                                                    
                                                                    	Optics form factor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: connector_type
                                                                    
                                                                    	Connector type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: otn_application_code
                                                                    
                                                                    	Otn Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: sonet_application_code
                                                                    
                                                                    	Sonet Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ethernet_compliance_code
                                                                    
                                                                    	Ethernet Compliance Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: date_string
                                                                    
                                                                    	Date string in IDPROM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom))])
                                                                        self._leafs = OrderedDict([
                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                        ])
                                                                        self.inv_card_type = None
                                                                        self.opaque_data = None
                                                                        self.opaque_data_size = None
                                                                        self.has_eeprom = None
                                                                        self.description = None
                                                                        self.form_factor = None
                                                                        self.connector_type = None
                                                                        self.otn_application_code = None
                                                                        self.sonet_application_code = None
                                                                        self.ethernet_compliance_code = None
                                                                        self.date_string = None

                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                    class Eeprom(_Entity_):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci_alpha_number
                                                                        
                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                            self._leafs = OrderedDict([
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                            ])
                                                                            self.description = None
                                                                            self.idprom_format_rev = None
                                                                            self.controller_family = None
                                                                            self.controller_type = None
                                                                            self.vid = None
                                                                            self.hwid = None
                                                                            self.pid = None
                                                                            self.udi_description = None
                                                                            self.udi_name = None
                                                                            self.clei = None
                                                                            self.eci = None
                                                                            self.top_assem_part_num = None
                                                                            self.top_assem_vid = None
                                                                            self.pca_num = None
                                                                            self.pcavid = None
                                                                            self.chassis_sid = None
                                                                            self.dev_num1 = None
                                                                            self.dev_num2 = None
                                                                            self.dev_num3 = None
                                                                            self.dev_num4 = None
                                                                            self.dev_num5 = None
                                                                            self.dev_num6 = None
                                                                            self.dev_num7 = None
                                                                            self.manu_test_data = None
                                                                            self.asset_id = None
                                                                            self.asset_alias = None
                                                                            self.base_mac_address1 = None
                                                                            self.mac_add_blk_size1 = None
                                                                            self.base_mac_address2 = None
                                                                            self.mac_add_blk_size2 = None
                                                                            self.base_mac_address3 = None
                                                                            self.mac_add_blk_size3 = None
                                                                            self.base_mac_address4 = None
                                                                            self.mac_add_blk_size4 = None
                                                                            self.pcb_serial_num = None
                                                                            self.power_supply_type = None
                                                                            self.power_consumption = None
                                                                            self.block_signature = None
                                                                            self.block_version = None
                                                                            self.block_length = None
                                                                            self.block_checksum = None
                                                                            self.eeprom_size = None
                                                                            self.block_count = None
                                                                            self.fru_major_type = None
                                                                            self.fru_minor_type = None
                                                                            self.oem_string = None
                                                                            self.product_id = None
                                                                            self.serial_number = None
                                                                            self.part_number = None
                                                                            self.part_revision = None
                                                                            self.mfg_deviation = None
                                                                            self.hw_version = None
                                                                            self.mfg_bits = None
                                                                            self.engineer_use = None
                                                                            self.snmpoid = None
                                                                            self.rma_code = None
                                                                            self.eci_alpha_number = None

                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._segment_path = lambda: "eeprom"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                        class Rma(_Entity_):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                ])
                                                                                self.test_history = None
                                                                                self.rma_number = None
                                                                                self.rma_history = None
                                                                                self._segment_path = lambda: "rma"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s']['meta_info']


                                                    class Attributes(_Entity_):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo))])
                                                            self._leafs = OrderedDict()

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"

                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._segment_path = lambda: "attributes"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, [], name, value)


                                                        class InvBasicBag(_Entity_):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: allocated_power
                                                            
                                                            	Allocated power for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_capacity
                                                            
                                                            	Power Capacity of a Power Module
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.vendor_type = None
                                                                self.name = None
                                                                self.hardware_revision = None
                                                                self.firmware_revision = None
                                                                self.software_revision = None
                                                                self.chip_hardware_revision = None
                                                                self.serial_number = None
                                                                self.manufacturer_name = None
                                                                self.model_name = None
                                                                self.asset_id_str = None
                                                                self.asset_identification = None
                                                                self.is_field_replaceable_unit = None
                                                                self.manufacturer_asset_tags = None
                                                                self.composite_class_code = None
                                                                self.memory_size = None
                                                                self.environmental_monitor_path = None
                                                                self.alias = None
                                                                self.group_flag = None
                                                                self.new_deviation_number = None
                                                                self.physical_layer_interface_module_type = None
                                                                self.unrecognized_fru = None
                                                                self.redundancystate = None
                                                                self.ceport = None
                                                                self.xr_scoped = None
                                                                self.unique_id = None
                                                                self.allocated_power = None
                                                                self.power_capacity = None
                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag']['meta_info']


                                                        class EnvSensorInfo(_Entity_):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: average
                                                            
                                                            	Average sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minimum
                                                            
                                                            	Minimum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: maximum
                                                            
                                                            	Maximum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: interval
                                                            
                                                            	Time Interval over which sensor value is monitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                ])
                                                                self.field_validity_bitmap = None
                                                                self.device_description = None
                                                                self.units = None
                                                                self.device_id = None
                                                                self.value = None
                                                                self.alarm_type = None
                                                                self.data_type = None
                                                                self.scale = None
                                                                self.precision = None
                                                                self.status = None
                                                                self.age_time_stamp = None
                                                                self.update_rate = None
                                                                self.average = None
                                                                self.minimum = None
                                                                self.maximum = None
                                                                self.interval = None
                                                                self._segment_path = lambda: "env-sensor-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo']['meta_info']


                                                        class PwgInfo(_Entity_):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\: str
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                ])
                                                                self.power_group_redundancy_mode = None
                                                                self.power_group_power_units = None
                                                                self.power_group_available_current = None
                                                                self.power_group_drawn_current = None
                                                                self._segment_path = lambda: "pwg-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo']['meta_info']


                                                        class EnvSensorInfoXml(_Entity_):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold))])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.units = None
                                                                self.value = None
                                                                self.data_type = None
                                                                self.status = None
                                                                self.update_rate = None

                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                            class Threshold(_Entity_):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.threshold_array = YList(self)
                                                                    self._segment_path = lambda: "threshold"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                class ThresholdArray(_Entity_):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_name = None
                                                                        self._segment_path = lambda: "threshold-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml']['meta_info']


                                                        class InvAssetBag(_Entity_):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                ])
                                                                self.part_number = None
                                                                self.manufacturer_assembly_number = None
                                                                self.manufacturer_assembly_revision = None
                                                                self.manufacturer_firmware_identifier = None
                                                                self.manufacturer_software_identifier = None
                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                self.original_equipment_manufacturer_string = None
                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag']['meta_info']


                                                        class Threshold(_Entity_):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo))])
                                                                self._leafs = OrderedDict()

                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._segment_path = lambda: "threshold"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, [], name, value)


                                                            class MajorLo(_Entity_):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo']['meta_info']


                                                            class CriticalHi(_Entity_):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi']['meta_info']


                                                            class MinorHi(_Entity_):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi']['meta_info']


                                                            class MajorHi(_Entity_):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi']['meta_info']


                                                            class CriticalLo(_Entity_):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo']['meta_info']


                                                            class MinorLo(_Entity_):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold']['meta_info']


                                                        class FruInfo(_Entity_):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime))])
                                                                self._leafs = OrderedDict([
                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                ])
                                                                self.card_administrative_state = None
                                                                self.power_administrative_state = None
                                                                self.card_operational_state = None
                                                                self.card_monitor_state = None
                                                                self.card_reset_reason = None
                                                                self.power_current_measurement = None
                                                                self.power_operational_state = None

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._segment_path = lambda: "fru-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                            class LastOperationalStateChange(_Entity_):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                            class CardUpTime(_Entity_):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "card-up-time"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo']['meta_info']


                                                        class InvEepromInfo(_Entity_):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\: str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: form_factor
                                                            
                                                            	Optics form factor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: connector_type
                                                            
                                                            	Connector type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: otn_application_code
                                                            
                                                            	Otn Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: sonet_application_code
                                                            
                                                            	Sonet Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ethernet_compliance_code
                                                            
                                                            	Ethernet Compliance Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: date_string
                                                            
                                                            	Date string in IDPROM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom))])
                                                                self._leafs = OrderedDict([
                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                ])
                                                                self.inv_card_type = None
                                                                self.opaque_data = None
                                                                self.opaque_data_size = None
                                                                self.has_eeprom = None
                                                                self.description = None
                                                                self.form_factor = None
                                                                self.connector_type = None
                                                                self.otn_application_code = None
                                                                self.sonet_application_code = None
                                                                self.ethernet_compliance_code = None
                                                                self.date_string = None

                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                            class Eeprom(_Entity_):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci_alpha_number
                                                                
                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                    self._leafs = OrderedDict([
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                    ])
                                                                    self.description = None
                                                                    self.idprom_format_rev = None
                                                                    self.controller_family = None
                                                                    self.controller_type = None
                                                                    self.vid = None
                                                                    self.hwid = None
                                                                    self.pid = None
                                                                    self.udi_description = None
                                                                    self.udi_name = None
                                                                    self.clei = None
                                                                    self.eci = None
                                                                    self.top_assem_part_num = None
                                                                    self.top_assem_vid = None
                                                                    self.pca_num = None
                                                                    self.pcavid = None
                                                                    self.chassis_sid = None
                                                                    self.dev_num1 = None
                                                                    self.dev_num2 = None
                                                                    self.dev_num3 = None
                                                                    self.dev_num4 = None
                                                                    self.dev_num5 = None
                                                                    self.dev_num6 = None
                                                                    self.dev_num7 = None
                                                                    self.manu_test_data = None
                                                                    self.asset_id = None
                                                                    self.asset_alias = None
                                                                    self.base_mac_address1 = None
                                                                    self.mac_add_blk_size1 = None
                                                                    self.base_mac_address2 = None
                                                                    self.mac_add_blk_size2 = None
                                                                    self.base_mac_address3 = None
                                                                    self.mac_add_blk_size3 = None
                                                                    self.base_mac_address4 = None
                                                                    self.mac_add_blk_size4 = None
                                                                    self.pcb_serial_num = None
                                                                    self.power_supply_type = None
                                                                    self.power_consumption = None
                                                                    self.block_signature = None
                                                                    self.block_version = None
                                                                    self.block_length = None
                                                                    self.block_checksum = None
                                                                    self.eeprom_size = None
                                                                    self.block_count = None
                                                                    self.fru_major_type = None
                                                                    self.fru_minor_type = None
                                                                    self.oem_string = None
                                                                    self.product_id = None
                                                                    self.serial_number = None
                                                                    self.part_number = None
                                                                    self.part_revision = None
                                                                    self.mfg_deviation = None
                                                                    self.hw_version = None
                                                                    self.mfg_bits = None
                                                                    self.engineer_use = None
                                                                    self.snmpoid = None
                                                                    self.rma_code = None
                                                                    self.eci_alpha_number = None

                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._segment_path = lambda: "eeprom"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                class Rma(_Entity_):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                        ])
                                                                        self.test_history = None
                                                                        self.rma_number = None
                                                                        self.rma_history = None
                                                                        self._segment_path = lambda: "rma"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s']['meta_info']


                                            class Attributes(_Entity_):
                                                """
                                                Attributes
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo))])
                                                    self._leafs = OrderedDict()

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"

                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._segment_path = lambda: "attributes"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, [], name, value)


                                                class InvBasicBag(_Entity_):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: allocated_power
                                                    
                                                    	Allocated power for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_capacity
                                                    
                                                    	Power Capacity of a Power Module
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.vendor_type = None
                                                        self.name = None
                                                        self.hardware_revision = None
                                                        self.firmware_revision = None
                                                        self.software_revision = None
                                                        self.chip_hardware_revision = None
                                                        self.serial_number = None
                                                        self.manufacturer_name = None
                                                        self.model_name = None
                                                        self.asset_id_str = None
                                                        self.asset_identification = None
                                                        self.is_field_replaceable_unit = None
                                                        self.manufacturer_asset_tags = None
                                                        self.composite_class_code = None
                                                        self.memory_size = None
                                                        self.environmental_monitor_path = None
                                                        self.alias = None
                                                        self.group_flag = None
                                                        self.new_deviation_number = None
                                                        self.physical_layer_interface_module_type = None
                                                        self.unrecognized_fru = None
                                                        self.redundancystate = None
                                                        self.ceport = None
                                                        self.xr_scoped = None
                                                        self.unique_id = None
                                                        self.allocated_power = None
                                                        self.power_capacity = None
                                                        self._segment_path = lambda: "inv-basic-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag']['meta_info']


                                                class EnvSensorInfo(_Entity_):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: average
                                                    
                                                    	Average sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minimum
                                                    
                                                    	Minimum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: maximum
                                                    
                                                    	Maximum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interval
                                                    
                                                    	Time Interval over which sensor value is monitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                        ])
                                                        self.field_validity_bitmap = None
                                                        self.device_description = None
                                                        self.units = None
                                                        self.device_id = None
                                                        self.value = None
                                                        self.alarm_type = None
                                                        self.data_type = None
                                                        self.scale = None
                                                        self.precision = None
                                                        self.status = None
                                                        self.age_time_stamp = None
                                                        self.update_rate = None
                                                        self.average = None
                                                        self.minimum = None
                                                        self.maximum = None
                                                        self.interval = None
                                                        self._segment_path = lambda: "env-sensor-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo']['meta_info']


                                                class PwgInfo(_Entity_):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                        ])
                                                        self.power_group_redundancy_mode = None
                                                        self.power_group_power_units = None
                                                        self.power_group_available_current = None
                                                        self.power_group_drawn_current = None
                                                        self._segment_path = lambda: "pwg-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo']['meta_info']


                                                class EnvSensorInfoXml(_Entity_):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold))])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.units = None
                                                        self.value = None
                                                        self.data_type = None
                                                        self.status = None
                                                        self.update_rate = None

                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                    class Threshold(_Entity_):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                            self._leafs = OrderedDict()

                                                            self.threshold_array = YList(self)
                                                            self._segment_path = lambda: "threshold"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                        class ThresholdArray(_Entity_):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_name = None
                                                                self._segment_path = lambda: "threshold-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml']['meta_info']


                                                class InvAssetBag(_Entity_):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                        ])
                                                        self.part_number = None
                                                        self.manufacturer_assembly_number = None
                                                        self.manufacturer_assembly_revision = None
                                                        self.manufacturer_firmware_identifier = None
                                                        self.manufacturer_software_identifier = None
                                                        self.manufacturer_common_language_equipment_identifier = None
                                                        self.original_equipment_manufacturer_string = None
                                                        self._segment_path = lambda: "inv-asset-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag']['meta_info']


                                                class Threshold(_Entity_):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo))])
                                                        self._leafs = OrderedDict()

                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"

                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"

                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._segment_path = lambda: "threshold"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, [], name, value)


                                                    class MajorLo(_Entity_):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo']['meta_info']


                                                    class CriticalHi(_Entity_):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi']['meta_info']


                                                    class MinorHi(_Entity_):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi']['meta_info']


                                                    class MajorHi(_Entity_):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi']['meta_info']


                                                    class CriticalLo(_Entity_):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo']['meta_info']


                                                    class MinorLo(_Entity_):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold']['meta_info']


                                                class FruInfo(_Entity_):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime))])
                                                        self._leafs = OrderedDict([
                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                        ])
                                                        self.card_administrative_state = None
                                                        self.power_administrative_state = None
                                                        self.card_operational_state = None
                                                        self.card_monitor_state = None
                                                        self.card_reset_reason = None
                                                        self.power_current_measurement = None
                                                        self.power_operational_state = None

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._segment_path = lambda: "fru-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                    class LastOperationalStateChange(_Entity_):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "last-operational-state-change"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                    class CardUpTime(_Entity_):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "card-up-time"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo']['meta_info']


                                                class InvEepromInfo(_Entity_):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: form_factor
                                                    
                                                    	Optics form factor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: connector_type
                                                    
                                                    	Connector type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: otn_application_code
                                                    
                                                    	Otn Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: sonet_application_code
                                                    
                                                    	Sonet Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ethernet_compliance_code
                                                    
                                                    	Ethernet Compliance Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: date_string
                                                    
                                                    	Date string in IDPROM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom))])
                                                        self._leafs = OrderedDict([
                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                        ])
                                                        self.inv_card_type = None
                                                        self.opaque_data = None
                                                        self.opaque_data_size = None
                                                        self.has_eeprom = None
                                                        self.description = None
                                                        self.form_factor = None
                                                        self.connector_type = None
                                                        self.otn_application_code = None
                                                        self.sonet_application_code = None
                                                        self.ethernet_compliance_code = None
                                                        self.date_string = None

                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                    class Eeprom(_Entity_):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci_alpha_number
                                                        
                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                            self._leafs = OrderedDict([
                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                            ])
                                                            self.description = None
                                                            self.idprom_format_rev = None
                                                            self.controller_family = None
                                                            self.controller_type = None
                                                            self.vid = None
                                                            self.hwid = None
                                                            self.pid = None
                                                            self.udi_description = None
                                                            self.udi_name = None
                                                            self.clei = None
                                                            self.eci = None
                                                            self.top_assem_part_num = None
                                                            self.top_assem_vid = None
                                                            self.pca_num = None
                                                            self.pcavid = None
                                                            self.chassis_sid = None
                                                            self.dev_num1 = None
                                                            self.dev_num2 = None
                                                            self.dev_num3 = None
                                                            self.dev_num4 = None
                                                            self.dev_num5 = None
                                                            self.dev_num6 = None
                                                            self.dev_num7 = None
                                                            self.manu_test_data = None
                                                            self.asset_id = None
                                                            self.asset_alias = None
                                                            self.base_mac_address1 = None
                                                            self.mac_add_blk_size1 = None
                                                            self.base_mac_address2 = None
                                                            self.mac_add_blk_size2 = None
                                                            self.base_mac_address3 = None
                                                            self.mac_add_blk_size3 = None
                                                            self.base_mac_address4 = None
                                                            self.mac_add_blk_size4 = None
                                                            self.pcb_serial_num = None
                                                            self.power_supply_type = None
                                                            self.power_consumption = None
                                                            self.block_signature = None
                                                            self.block_version = None
                                                            self.block_length = None
                                                            self.block_checksum = None
                                                            self.eeprom_size = None
                                                            self.block_count = None
                                                            self.fru_major_type = None
                                                            self.fru_minor_type = None
                                                            self.oem_string = None
                                                            self.product_id = None
                                                            self.serial_number = None
                                                            self.part_number = None
                                                            self.part_revision = None
                                                            self.mfg_deviation = None
                                                            self.hw_version = None
                                                            self.mfg_bits = None
                                                            self.engineer_use = None
                                                            self.snmpoid = None
                                                            self.rma_code = None
                                                            self.eci_alpha_number = None

                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._segment_path = lambda: "eeprom"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                        class Rma(_Entity_):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                ])
                                                                self.test_history = None
                                                                self.rma_number = None
                                                                self.rma_history = None
                                                                self._segment_path = lambda: "rma"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s']['meta_info']


                                    class Attributes(_Entity_):
                                        """
                                        Attributes
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo))])
                                            self._leafs = OrderedDict()

                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"

                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._segment_path = lambda: "attributes"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, [], name, value)


                                        class InvBasicBag(_Entity_):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: allocated_power
                                            
                                            	Allocated power for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_capacity
                                            
                                            	Power Capacity of a Power Module
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                ])
                                                self.description = None
                                                self.vendor_type = None
                                                self.name = None
                                                self.hardware_revision = None
                                                self.firmware_revision = None
                                                self.software_revision = None
                                                self.chip_hardware_revision = None
                                                self.serial_number = None
                                                self.manufacturer_name = None
                                                self.model_name = None
                                                self.asset_id_str = None
                                                self.asset_identification = None
                                                self.is_field_replaceable_unit = None
                                                self.manufacturer_asset_tags = None
                                                self.composite_class_code = None
                                                self.memory_size = None
                                                self.environmental_monitor_path = None
                                                self.alias = None
                                                self.group_flag = None
                                                self.new_deviation_number = None
                                                self.physical_layer_interface_module_type = None
                                                self.unrecognized_fru = None
                                                self.redundancystate = None
                                                self.ceport = None
                                                self.xr_scoped = None
                                                self.unique_id = None
                                                self.allocated_power = None
                                                self.power_capacity = None
                                                self._segment_path = lambda: "inv-basic-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag']['meta_info']


                                        class EnvSensorInfo(_Entity_):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: average
                                            
                                            	Average sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minimum
                                            
                                            	Minimum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: maximum
                                            
                                            	Maximum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: interval
                                            
                                            	Time Interval over which sensor value is monitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                ])
                                                self.field_validity_bitmap = None
                                                self.device_description = None
                                                self.units = None
                                                self.device_id = None
                                                self.value = None
                                                self.alarm_type = None
                                                self.data_type = None
                                                self.scale = None
                                                self.precision = None
                                                self.status = None
                                                self.age_time_stamp = None
                                                self.update_rate = None
                                                self.average = None
                                                self.minimum = None
                                                self.maximum = None
                                                self.interval = None
                                                self._segment_path = lambda: "env-sensor-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo']['meta_info']


                                        class PwgInfo(_Entity_):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                ])
                                                self.power_group_redundancy_mode = None
                                                self.power_group_power_units = None
                                                self.power_group_available_current = None
                                                self.power_group_drawn_current = None
                                                self._segment_path = lambda: "pwg-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo']['meta_info']


                                        class EnvSensorInfoXml(_Entity_):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold))])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                ])
                                                self.description = None
                                                self.units = None
                                                self.value = None
                                                self.data_type = None
                                                self.status = None
                                                self.update_rate = None

                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                            class Threshold(_Entity_):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                    self._leafs = OrderedDict()

                                                    self.threshold_array = YList(self)
                                                    self._segment_path = lambda: "threshold"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                class ThresholdArray(_Entity_):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_name = None
                                                        self._segment_path = lambda: "threshold-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml']['meta_info']


                                        class InvAssetBag(_Entity_):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                ])
                                                self.part_number = None
                                                self.manufacturer_assembly_number = None
                                                self.manufacturer_assembly_revision = None
                                                self.manufacturer_firmware_identifier = None
                                                self.manufacturer_software_identifier = None
                                                self.manufacturer_common_language_equipment_identifier = None
                                                self.original_equipment_manufacturer_string = None
                                                self._segment_path = lambda: "inv-asset-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag']['meta_info']


                                        class Threshold(_Entity_):
                                            """
                                            Threshold
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo))])
                                                self._leafs = OrderedDict()

                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"

                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"

                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._segment_path = lambda: "threshold"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, [], name, value)


                                            class MajorLo(_Entity_):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo']['meta_info']


                                            class CriticalHi(_Entity_):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi']['meta_info']


                                            class MinorHi(_Entity_):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi']['meta_info']


                                            class MajorHi(_Entity_):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi']['meta_info']


                                            class CriticalLo(_Entity_):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo']['meta_info']


                                            class MinorLo(_Entity_):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold']['meta_info']


                                        class FruInfo(_Entity_):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime))])
                                                self._leafs = OrderedDict([
                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                ])
                                                self.card_administrative_state = None
                                                self.power_administrative_state = None
                                                self.card_operational_state = None
                                                self.card_monitor_state = None
                                                self.card_reset_reason = None
                                                self.power_current_measurement = None
                                                self.power_operational_state = None

                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._segment_path = lambda: "fru-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                            class LastOperationalStateChange(_Entity_):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "last-operational-state-change"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                            class CardUpTime(_Entity_):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "card-up-time"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo']['meta_info']


                                        class InvEepromInfo(_Entity_):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\: str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: form_factor
                                            
                                            	Optics form factor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: connector_type
                                            
                                            	Connector type
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: otn_application_code
                                            
                                            	Otn Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: sonet_application_code
                                            
                                            	Sonet Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ethernet_compliance_code
                                            
                                            	Ethernet Compliance Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: date_string
                                            
                                            	Date string in IDPROM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom))])
                                                self._leafs = OrderedDict([
                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                ])
                                                self.inv_card_type = None
                                                self.opaque_data = None
                                                self.opaque_data_size = None
                                                self.has_eeprom = None
                                                self.description = None
                                                self.form_factor = None
                                                self.connector_type = None
                                                self.otn_application_code = None
                                                self.sonet_application_code = None
                                                self.ethernet_compliance_code = None
                                                self.date_string = None

                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._segment_path = lambda: "inv-eeprom-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                            class Eeprom(_Entity_):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci_alpha_number
                                                
                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                    self._leafs = OrderedDict([
                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                    ])
                                                    self.description = None
                                                    self.idprom_format_rev = None
                                                    self.controller_family = None
                                                    self.controller_type = None
                                                    self.vid = None
                                                    self.hwid = None
                                                    self.pid = None
                                                    self.udi_description = None
                                                    self.udi_name = None
                                                    self.clei = None
                                                    self.eci = None
                                                    self.top_assem_part_num = None
                                                    self.top_assem_vid = None
                                                    self.pca_num = None
                                                    self.pcavid = None
                                                    self.chassis_sid = None
                                                    self.dev_num1 = None
                                                    self.dev_num2 = None
                                                    self.dev_num3 = None
                                                    self.dev_num4 = None
                                                    self.dev_num5 = None
                                                    self.dev_num6 = None
                                                    self.dev_num7 = None
                                                    self.manu_test_data = None
                                                    self.asset_id = None
                                                    self.asset_alias = None
                                                    self.base_mac_address1 = None
                                                    self.mac_add_blk_size1 = None
                                                    self.base_mac_address2 = None
                                                    self.mac_add_blk_size2 = None
                                                    self.base_mac_address3 = None
                                                    self.mac_add_blk_size3 = None
                                                    self.base_mac_address4 = None
                                                    self.mac_add_blk_size4 = None
                                                    self.pcb_serial_num = None
                                                    self.power_supply_type = None
                                                    self.power_consumption = None
                                                    self.block_signature = None
                                                    self.block_version = None
                                                    self.block_length = None
                                                    self.block_checksum = None
                                                    self.eeprom_size = None
                                                    self.block_count = None
                                                    self.fru_major_type = None
                                                    self.fru_minor_type = None
                                                    self.oem_string = None
                                                    self.product_id = None
                                                    self.serial_number = None
                                                    self.part_number = None
                                                    self.part_revision = None
                                                    self.mfg_deviation = None
                                                    self.hw_version = None
                                                    self.mfg_bits = None
                                                    self.engineer_use = None
                                                    self.snmpoid = None
                                                    self.rma_code = None
                                                    self.eci_alpha_number = None

                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._segment_path = lambda: "eeprom"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                class Rma(_Entity_):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                        ])
                                                        self.test_history = None
                                                        self.rma_number = None
                                                        self.rma_history = None
                                                        self._segment_path = lambda: "rma"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Tsi2s']['meta_info']


                            class Attributes(_Entity_):
                                """
                                Attributes
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold>`
                                
                                	**config**\: False
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo))])
                                    self._leafs = OrderedDict()

                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"

                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._segment_path = lambda: "attributes"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes, [], name, value)


                                class InvBasicBag(_Entity_):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: allocated_power
                                    
                                    	Allocated power for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_capacity
                                    
                                    	Power Capacity of a Power Module
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                        ])
                                        self.description = None
                                        self.vendor_type = None
                                        self.name = None
                                        self.hardware_revision = None
                                        self.firmware_revision = None
                                        self.software_revision = None
                                        self.chip_hardware_revision = None
                                        self.serial_number = None
                                        self.manufacturer_name = None
                                        self.model_name = None
                                        self.asset_id_str = None
                                        self.asset_identification = None
                                        self.is_field_replaceable_unit = None
                                        self.manufacturer_asset_tags = None
                                        self.composite_class_code = None
                                        self.memory_size = None
                                        self.environmental_monitor_path = None
                                        self.alias = None
                                        self.group_flag = None
                                        self.new_deviation_number = None
                                        self.physical_layer_interface_module_type = None
                                        self.unrecognized_fru = None
                                        self.redundancystate = None
                                        self.ceport = None
                                        self.xr_scoped = None
                                        self.unique_id = None
                                        self.allocated_power = None
                                        self.power_capacity = None
                                        self._segment_path = lambda: "inv-basic-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag']['meta_info']


                                class EnvSensorInfo(_Entity_):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: average
                                    
                                    	Average sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minimum
                                    
                                    	Minimum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: maximum
                                    
                                    	Maximum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interval
                                    
                                    	Time Interval over which sensor value is monitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                        ])
                                        self.field_validity_bitmap = None
                                        self.device_description = None
                                        self.units = None
                                        self.device_id = None
                                        self.value = None
                                        self.alarm_type = None
                                        self.data_type = None
                                        self.scale = None
                                        self.precision = None
                                        self.status = None
                                        self.age_time_stamp = None
                                        self.update_rate = None
                                        self.average = None
                                        self.minimum = None
                                        self.maximum = None
                                        self.interval = None
                                        self._segment_path = lambda: "env-sensor-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo']['meta_info']


                                class PwgInfo(_Entity_):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                        ])
                                        self.power_group_redundancy_mode = None
                                        self.power_group_power_units = None
                                        self.power_group_available_current = None
                                        self.power_group_drawn_current = None
                                        self._segment_path = lambda: "pwg-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.PwgInfo']['meta_info']


                                class EnvSensorInfoXml(_Entity_):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold))])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                        ])
                                        self.description = None
                                        self.units = None
                                        self.value = None
                                        self.data_type = None
                                        self.status = None
                                        self.update_rate = None

                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._segment_path = lambda: "env-sensor-info-xml"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                    class Threshold(_Entity_):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                            self._leafs = OrderedDict()

                                            self.threshold_array = YList(self)
                                            self._segment_path = lambda: "threshold"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                        class ThresholdArray(_Entity_):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_name = None
                                                self._segment_path = lambda: "threshold-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml']['meta_info']


                                class InvAssetBag(_Entity_):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                        ])
                                        self.part_number = None
                                        self.manufacturer_assembly_number = None
                                        self.manufacturer_assembly_revision = None
                                        self.manufacturer_firmware_identifier = None
                                        self.manufacturer_software_identifier = None
                                        self.manufacturer_common_language_equipment_identifier = None
                                        self.original_equipment_manufacturer_string = None
                                        self._segment_path = lambda: "inv-asset-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag']['meta_info']


                                class Threshold(_Entity_):
                                    """
                                    Threshold
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo))])
                                        self._leafs = OrderedDict()

                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"

                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"

                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"

                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"

                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"

                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._segment_path = lambda: "threshold"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold, [], name, value)


                                    class MajorLo(_Entity_):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo']['meta_info']


                                    class CriticalHi(_Entity_):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi']['meta_info']


                                    class MinorHi(_Entity_):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi']['meta_info']


                                    class MajorHi(_Entity_):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi']['meta_info']


                                    class CriticalLo(_Entity_):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo']['meta_info']


                                    class MinorLo(_Entity_):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.Threshold']['meta_info']


                                class FruInfo(_Entity_):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime))])
                                        self._leafs = OrderedDict([
                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                        ])
                                        self.card_administrative_state = None
                                        self.power_administrative_state = None
                                        self.card_operational_state = None
                                        self.card_monitor_state = None
                                        self.card_reset_reason = None
                                        self.power_current_measurement = None
                                        self.power_operational_state = None

                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._segment_path = lambda: "fru-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                    class LastOperationalStateChange(_Entity_):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "last-operational-state-change"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                    class CardUpTime(_Entity_):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "card-up-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.FruInfo']['meta_info']


                                class InvEepromInfo(_Entity_):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\: str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: form_factor
                                    
                                    	Optics form factor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connector_type
                                    
                                    	Connector type
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn_application_code
                                    
                                    	Otn Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: sonet_application_code
                                    
                                    	Sonet Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ethernet_compliance_code
                                    
                                    	Ethernet Compliance Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: date_string
                                    
                                    	Date string in IDPROM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom))])
                                        self._leafs = OrderedDict([
                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                        ])
                                        self.inv_card_type = None
                                        self.opaque_data = None
                                        self.opaque_data_size = None
                                        self.has_eeprom = None
                                        self.description = None
                                        self.form_factor = None
                                        self.connector_type = None
                                        self.otn_application_code = None
                                        self.sonet_application_code = None
                                        self.ethernet_compliance_code = None
                                        self.date_string = None

                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._segment_path = lambda: "inv-eeprom-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                    class Eeprom(_Entity_):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci_alpha_number
                                        
                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma))])
                                            self._leafs = OrderedDict([
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                            ])
                                            self.description = None
                                            self.idprom_format_rev = None
                                            self.controller_family = None
                                            self.controller_type = None
                                            self.vid = None
                                            self.hwid = None
                                            self.pid = None
                                            self.udi_description = None
                                            self.udi_name = None
                                            self.clei = None
                                            self.eci = None
                                            self.top_assem_part_num = None
                                            self.top_assem_vid = None
                                            self.pca_num = None
                                            self.pcavid = None
                                            self.chassis_sid = None
                                            self.dev_num1 = None
                                            self.dev_num2 = None
                                            self.dev_num3 = None
                                            self.dev_num4 = None
                                            self.dev_num5 = None
                                            self.dev_num6 = None
                                            self.dev_num7 = None
                                            self.manu_test_data = None
                                            self.asset_id = None
                                            self.asset_alias = None
                                            self.base_mac_address1 = None
                                            self.mac_add_blk_size1 = None
                                            self.base_mac_address2 = None
                                            self.mac_add_blk_size2 = None
                                            self.base_mac_address3 = None
                                            self.mac_add_blk_size3 = None
                                            self.base_mac_address4 = None
                                            self.mac_add_blk_size4 = None
                                            self.pcb_serial_num = None
                                            self.power_supply_type = None
                                            self.power_consumption = None
                                            self.block_signature = None
                                            self.block_version = None
                                            self.block_length = None
                                            self.block_checksum = None
                                            self.eeprom_size = None
                                            self.block_count = None
                                            self.fru_major_type = None
                                            self.fru_minor_type = None
                                            self.oem_string = None
                                            self.product_id = None
                                            self.serial_number = None
                                            self.part_number = None
                                            self.part_revision = None
                                            self.mfg_deviation = None
                                            self.hw_version = None
                                            self.mfg_bits = None
                                            self.engineer_use = None
                                            self.snmpoid = None
                                            self.rma_code = None
                                            self.eci_alpha_number = None

                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._segment_path = lambda: "eeprom"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                        class Rma(_Entity_):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                ])
                                                self.test_history = None
                                                self.rma_number = None
                                                self.rma_history = None
                                                self._segment_path = lambda: "rma"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1.Attributes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s.Tsi1']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Tsi1s']['meta_info']


                    class Attributes(_Entity_):
                        """
                        Attributes
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold>`
                        
                        	**config**\: False
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo))])
                            self._leafs = OrderedDict()

                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"

                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"

                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._segment_path = lambda: "attributes"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes, [], name, value)


                        class InvBasicBag(_Entity_):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: allocated_power
                            
                            	Allocated power for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_capacity
                            
                            	Power Capacity of a Power Module
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                ])
                                self.description = None
                                self.vendor_type = None
                                self.name = None
                                self.hardware_revision = None
                                self.firmware_revision = None
                                self.software_revision = None
                                self.chip_hardware_revision = None
                                self.serial_number = None
                                self.manufacturer_name = None
                                self.model_name = None
                                self.asset_id_str = None
                                self.asset_identification = None
                                self.is_field_replaceable_unit = None
                                self.manufacturer_asset_tags = None
                                self.composite_class_code = None
                                self.memory_size = None
                                self.environmental_monitor_path = None
                                self.alias = None
                                self.group_flag = None
                                self.new_deviation_number = None
                                self.physical_layer_interface_module_type = None
                                self.unrecognized_fru = None
                                self.redundancystate = None
                                self.ceport = None
                                self.xr_scoped = None
                                self.unique_id = None
                                self.allocated_power = None
                                self.power_capacity = None
                                self._segment_path = lambda: "inv-basic-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag']['meta_info']


                        class EnvSensorInfo(_Entity_):
                            """
                            Environment sensor info
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: average
                            
                            	Average sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: minimum
                            
                            	Minimum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: maximum
                            
                            	Maximum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: interval
                            
                            	Time Interval over which sensor value is monitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                ])
                                self.field_validity_bitmap = None
                                self.device_description = None
                                self.units = None
                                self.device_id = None
                                self.value = None
                                self.alarm_type = None
                                self.data_type = None
                                self.scale = None
                                self.precision = None
                                self.status = None
                                self.age_time_stamp = None
                                self.update_rate = None
                                self.average = None
                                self.minimum = None
                                self.maximum = None
                                self.interval = None
                                self._segment_path = lambda: "env-sensor-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo']['meta_info']


                        class PwgInfo(_Entity_):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                ])
                                self.power_group_redundancy_mode = None
                                self.power_group_power_units = None
                                self.power_group_available_current = None
                                self.power_group_drawn_current = None
                                self._segment_path = lambda: "pwg-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo']['meta_info']


                        class EnvSensorInfoXml(_Entity_):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold))])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                ])
                                self.description = None
                                self.units = None
                                self.value = None
                                self.data_type = None
                                self.status = None
                                self.update_rate = None

                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._segment_path = lambda: "env-sensor-info-xml"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                            class Threshold(_Entity_):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                    self._leafs = OrderedDict()

                                    self.threshold_array = YList(self)
                                    self._segment_path = lambda: "threshold"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                class ThresholdArray(_Entity_):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_name = None
                                        self._segment_path = lambda: "threshold-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml']['meta_info']


                        class InvAssetBag(_Entity_):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                ])
                                self.part_number = None
                                self.manufacturer_assembly_number = None
                                self.manufacturer_assembly_revision = None
                                self.manufacturer_firmware_identifier = None
                                self.manufacturer_software_identifier = None
                                self.manufacturer_common_language_equipment_identifier = None
                                self.original_equipment_manufacturer_string = None
                                self._segment_path = lambda: "inv-asset-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag']['meta_info']


                        class Threshold(_Entity_):
                            """
                            Threshold
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo))])
                                self._leafs = OrderedDict()

                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"

                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"

                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"

                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"

                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"

                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._segment_path = lambda: "threshold"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold, [], name, value)


                            class MajorLo(_Entity_):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo']['meta_info']


                            class CriticalHi(_Entity_):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi']['meta_info']


                            class MinorHi(_Entity_):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi']['meta_info']


                            class MajorHi(_Entity_):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi']['meta_info']


                            class CriticalLo(_Entity_):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo']['meta_info']


                            class MinorLo(_Entity_):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold']['meta_info']


                        class FruInfo(_Entity_):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime))])
                                self._leafs = OrderedDict([
                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                ])
                                self.card_administrative_state = None
                                self.power_administrative_state = None
                                self.card_operational_state = None
                                self.card_monitor_state = None
                                self.card_reset_reason = None
                                self.power_current_measurement = None
                                self.power_operational_state = None

                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._segment_path = lambda: "fru-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                            class LastOperationalStateChange(_Entity_):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "last-operational-state-change"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                            class CardUpTime(_Entity_):
                                """
                                card up time
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "card-up-time"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo']['meta_info']


                        class InvEepromInfo(_Entity_):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            	**config**\: False
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\: str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: form_factor
                            
                            	Optics form factor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connector_type
                            
                            	Connector type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: otn_application_code
                            
                            	Otn Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sonet_application_code
                            
                            	Sonet Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ethernet_compliance_code
                            
                            	Ethernet Compliance Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: date_string
                            
                            	Date string in IDPROM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom))])
                                self._leafs = OrderedDict([
                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                ])
                                self.inv_card_type = None
                                self.opaque_data = None
                                self.opaque_data_size = None
                                self.has_eeprom = None
                                self.description = None
                                self.form_factor = None
                                self.connector_type = None
                                self.otn_application_code = None
                                self.sonet_application_code = None
                                self.ethernet_compliance_code = None
                                self.date_string = None

                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._segment_path = lambda: "inv-eeprom-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                            class Eeprom(_Entity_):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                	**config**\: False
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci_alpha_number
                                
                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma))])
                                    self._leafs = OrderedDict([
                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                    ])
                                    self.description = None
                                    self.idprom_format_rev = None
                                    self.controller_family = None
                                    self.controller_type = None
                                    self.vid = None
                                    self.hwid = None
                                    self.pid = None
                                    self.udi_description = None
                                    self.udi_name = None
                                    self.clei = None
                                    self.eci = None
                                    self.top_assem_part_num = None
                                    self.top_assem_vid = None
                                    self.pca_num = None
                                    self.pcavid = None
                                    self.chassis_sid = None
                                    self.dev_num1 = None
                                    self.dev_num2 = None
                                    self.dev_num3 = None
                                    self.dev_num4 = None
                                    self.dev_num5 = None
                                    self.dev_num6 = None
                                    self.dev_num7 = None
                                    self.manu_test_data = None
                                    self.asset_id = None
                                    self.asset_alias = None
                                    self.base_mac_address1 = None
                                    self.mac_add_blk_size1 = None
                                    self.base_mac_address2 = None
                                    self.mac_add_blk_size2 = None
                                    self.base_mac_address3 = None
                                    self.mac_add_blk_size3 = None
                                    self.base_mac_address4 = None
                                    self.mac_add_blk_size4 = None
                                    self.pcb_serial_num = None
                                    self.power_supply_type = None
                                    self.power_consumption = None
                                    self.block_signature = None
                                    self.block_version = None
                                    self.block_length = None
                                    self.block_checksum = None
                                    self.eeprom_size = None
                                    self.block_count = None
                                    self.fru_major_type = None
                                    self.fru_minor_type = None
                                    self.oem_string = None
                                    self.product_id = None
                                    self.serial_number = None
                                    self.part_number = None
                                    self.part_revision = None
                                    self.mfg_deviation = None
                                    self.hw_version = None
                                    self.mfg_bits = None
                                    self.engineer_use = None
                                    self.snmpoid = None
                                    self.rma_code = None
                                    self.eci_alpha_number = None

                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._segment_path = lambda: "eeprom"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                class Rma(_Entity_):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                        ])
                                        self.test_history = None
                                        self.rma_number = None
                                        self.rma_history = None
                                        self._segment_path = lambda: "rma"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot.Attributes']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Powershelf.Slot']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Racks.Rack.Powershelf']['meta_info']


            class Fantray(_Entity_):
                """
                Fantray information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of  		 :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Racks.Rack.Fantray, self).__init__()

                    self.yang_name = "fantray"
                    self.yang_parent_name = "rack"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slot", ("slot", Inventory.Racks.Rack.Fantray.Slot))])
                    self._leafs = OrderedDict()

                    self.slot = YList(self)
                    self._segment_path = lambda: "fantray"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Racks.Rack.Fantray, [], name, value)


                class Slot(_Entity_):
                    """
                    Slot number
                    
                    .. attribute:: name  (key)
                    
                    	Slot name
                    	**type**\: str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    	**config**\: False
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:  :py:class:`Tsi1s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s>`
                    
                    	**config**\: False
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Fantray.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "fantray"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['name']
                        self._child_classes = OrderedDict([("tsi1s", ("tsi1s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Attributes))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                        ])
                        self.name = None

                        self.tsi1s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"

                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._segment_path = lambda: "slot" + "[name='" + str(self.name) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot, ['name'], name, value)


                    class Tsi1s(_Entity_):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of  		 :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("tsi1", ("tsi1", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1))])
                            self._leafs = OrderedDict()

                            self.tsi1 = YList(self)
                            self._segment_path = lambda: "tsi1s"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s, [], name, value)


                        class Tsi1(_Entity_):
                            """
                            TSI1
                            
                            .. attribute:: name  (key)
                            
                            	TSI1
                            	**type**\: str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            	**config**\: False
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:  :py:class:`Tsi2s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s>`
                            
                            	**config**\: False
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['name']
                                self._child_classes = OrderedDict([("tsi2s", ("tsi2s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes))])
                                self._leafs = OrderedDict([
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ])
                                self.name = None

                                self.tsi2s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"

                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._segment_path = lambda: "tsi1" + "[name='" + str(self.name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1, ['name'], name, value)


                            class Tsi2s(_Entity_):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of  		 :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("tsi2", ("tsi2", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2))])
                                    self._leafs = OrderedDict()

                                    self.tsi2 = YList(self)
                                    self._segment_path = lambda: "tsi2s"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s, [], name, value)


                                class Tsi2(_Entity_):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  (key)
                                    
                                    	TSI2
                                    	**type**\: str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:  :py:class:`Tsi3s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['name']
                                        self._child_classes = OrderedDict([("tsi3s", ("tsi3s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ])
                                        self.name = None

                                        self.tsi3s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"

                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._segment_path = lambda: "tsi2" + "[name='" + str(self.name) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2, ['name'], name, value)


                                    class Tsi3s(_Entity_):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of  		 :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("tsi3", ("tsi3", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3))])
                                            self._leafs = OrderedDict()

                                            self.tsi3 = YList(self)
                                            self._segment_path = lambda: "tsi3s"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s, [], name, value)


                                        class Tsi3(_Entity_):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  (key)
                                            
                                            	TSI3
                                            	**type**\: str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:  :py:class:`Tsi4s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = ['name']
                                                self._child_classes = OrderedDict([("tsi4s", ("tsi4s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ])
                                                self.name = None

                                                self.tsi4s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"

                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._segment_path = lambda: "tsi3" + "[name='" + str(self.name) + "']"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3, ['name'], name, value)


                                            class Tsi4s(_Entity_):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of  		 :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("tsi4", ("tsi4", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4))])
                                                    self._leafs = OrderedDict()

                                                    self.tsi4 = YList(self)
                                                    self._segment_path = lambda: "tsi4s"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s, [], name, value)


                                                class Tsi4(_Entity_):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  (key)
                                                    
                                                    	TSI4
                                                    	**type**\: str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:  :py:class:`Tsi5s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = ['name']
                                                        self._child_classes = OrderedDict([("tsi5s", ("tsi5s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes))])
                                                        self._leafs = OrderedDict([
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ])
                                                        self.name = None

                                                        self.tsi5s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"

                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._segment_path = lambda: "tsi4" + "[name='" + str(self.name) + "']"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4, ['name'], name, value)


                                                    class Tsi5s(_Entity_):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of  		 :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("tsi5", ("tsi5", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5))])
                                                            self._leafs = OrderedDict()

                                                            self.tsi5 = YList(self)
                                                            self._segment_path = lambda: "tsi5s"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s, [], name, value)


                                                        class Tsi5(_Entity_):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  (key)
                                                            
                                                            	TSI5
                                                            	**type**\: str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:  :py:class:`Tsi6s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = ['name']
                                                                self._child_classes = OrderedDict([("tsi6s", ("tsi6s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes))])
                                                                self._leafs = OrderedDict([
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                ])
                                                                self.name = None

                                                                self.tsi6s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"

                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._segment_path = lambda: "tsi5" + "[name='" + str(self.name) + "']"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5, ['name'], name, value)


                                                            class Tsi6s(_Entity_):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of  		 :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("tsi6", ("tsi6", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6))])
                                                                    self._leafs = OrderedDict()

                                                                    self.tsi6 = YList(self)
                                                                    self._segment_path = lambda: "tsi6s"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s, [], name, value)


                                                                class Tsi6(_Entity_):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  (key)
                                                                    
                                                                    	TSI6
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:  :py:class:`Tsi7s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = ['name']
                                                                        self._child_classes = OrderedDict([("tsi7s", ("tsi7s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes))])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ])
                                                                        self.name = None

                                                                        self.tsi7s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"

                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._segment_path = lambda: "tsi6" + "[name='" + str(self.name) + "']"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6, ['name'], name, value)


                                                                    class Tsi7s(_Entity_):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of  		 :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("tsi7", ("tsi7", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7))])
                                                                            self._leafs = OrderedDict()

                                                                            self.tsi7 = YList(self)
                                                                            self._segment_path = lambda: "tsi7s"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s, [], name, value)


                                                                        class Tsi7(_Entity_):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  (key)
                                                                            
                                                                            	TSI7
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:  :py:class:`Tsi8s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = ['name']
                                                                                self._child_classes = OrderedDict([("tsi8s", ("tsi8s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ])
                                                                                self.name = None

                                                                                self.tsi8s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"

                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._segment_path = lambda: "tsi7" + "[name='" + str(self.name) + "']"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7, ['name'], name, value)


                                                                            class Tsi8s(_Entity_):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of  		 :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("tsi8", ("tsi8", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.tsi8 = YList(self)
                                                                                    self._segment_path = lambda: "tsi8s"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s, [], name, value)


                                                                                class Tsi8(_Entity_):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  (key)
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:  :py:class:`Tsi9s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = ['name']
                                                                                        self._child_classes = OrderedDict([("tsi9s", ("tsi9s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ])
                                                                                        self.name = None

                                                                                        self.tsi9s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"

                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._segment_path = lambda: "tsi8" + "[name='" + str(self.name) + "']"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8, ['name'], name, value)


                                                                                    class Tsi9s(_Entity_):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of  		 :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("tsi9", ("tsi9", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.tsi9 = YList(self)
                                                                                            self._segment_path = lambda: "tsi9s"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s, [], name, value)


                                                                                        class Tsi9(_Entity_):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  (key)
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:  :py:class:`Tsi10s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = ['name']
                                                                                                self._child_classes = OrderedDict([("tsi10s", ("tsi10s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                ])
                                                                                                self.name = None

                                                                                                self.tsi10s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"

                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._segment_path = lambda: "tsi9" + "[name='" + str(self.name) + "']"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9, ['name'], name, value)


                                                                                            class Tsi10s(_Entity_):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of  		 :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("tsi10", ("tsi10", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.tsi10 = YList(self)
                                                                                                    self._segment_path = lambda: "tsi10s"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s, [], name, value)


                                                                                                class Tsi10(_Entity_):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  (key)
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:  :py:class:`Tsi11s <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = ['name']
                                                                                                        self._child_classes = OrderedDict([("tsi11s", ("tsi11s", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s)), ("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                        ])
                                                                                                        self.name = None

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"

                                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._segment_path = lambda: "tsi10" + "[name='" + str(self.name) + "']"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10, ['name'], name, value)


                                                                                                    class Tsi11s(_Entity_):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of  		 :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("tsi11", ("tsi11", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.tsi11 = YList(self)
                                                                                                            self._segment_path = lambda: "tsi11s"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s, [], name, value)


                                                                                                        class Tsi11(_Entity_):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  (key)
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:  :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = ['name']
                                                                                                                self._child_classes = OrderedDict([("attributes", ("attributes", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                ])
                                                                                                                self.name = None

                                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._segment_path = lambda: "tsi11" + "[name='" + str(self.name) + "']"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11, ['name'], name, value)


                                                                                                            class Attributes(_Entity_):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes, [], name, value)


                                                                                                                class InvBasicBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: allocated_power
                                                                                                                    
                                                                                                                    	Allocated power for an entity
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_capacity
                                                                                                                    
                                                                                                                    	Power Capacity of a Power Module
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.vendor_type = None
                                                                                                                        self.name = None
                                                                                                                        self.hardware_revision = None
                                                                                                                        self.firmware_revision = None
                                                                                                                        self.software_revision = None
                                                                                                                        self.chip_hardware_revision = None
                                                                                                                        self.serial_number = None
                                                                                                                        self.manufacturer_name = None
                                                                                                                        self.model_name = None
                                                                                                                        self.asset_id_str = None
                                                                                                                        self.asset_identification = None
                                                                                                                        self.is_field_replaceable_unit = None
                                                                                                                        self.manufacturer_asset_tags = None
                                                                                                                        self.composite_class_code = None
                                                                                                                        self.memory_size = None
                                                                                                                        self.environmental_monitor_path = None
                                                                                                                        self.alias = None
                                                                                                                        self.group_flag = None
                                                                                                                        self.new_deviation_number = None
                                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                                        self.unrecognized_fru = None
                                                                                                                        self.redundancystate = None
                                                                                                                        self.ceport = None
                                                                                                                        self.xr_scoped = None
                                                                                                                        self.unique_id = None
                                                                                                                        self.allocated_power = None
                                                                                                                        self.power_capacity = None
                                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvBasicBag']['meta_info']


                                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: average
                                                                                                                    
                                                                                                                    	Average sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minimum
                                                                                                                    
                                                                                                                    	Minimum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: maximum
                                                                                                                    
                                                                                                                    	Maximum Sensor value over time interval
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: interval
                                                                                                                    
                                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.field_validity_bitmap = None
                                                                                                                        self.device_description = None
                                                                                                                        self.units = None
                                                                                                                        self.device_id = None
                                                                                                                        self.value = None
                                                                                                                        self.alarm_type = None
                                                                                                                        self.data_type = None
                                                                                                                        self.scale = None
                                                                                                                        self.precision = None
                                                                                                                        self.status = None
                                                                                                                        self.age_time_stamp = None
                                                                                                                        self.update_rate = None
                                                                                                                        self.average = None
                                                                                                                        self.minimum = None
                                                                                                                        self.maximum = None
                                                                                                                        self.interval = None
                                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfo']['meta_info']


                                                                                                                class PwgInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.power_group_redundancy_mode = None
                                                                                                                        self.power_group_power_units = None
                                                                                                                        self.power_group_available_current = None
                                                                                                                        self.power_group_drawn_current = None
                                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.PwgInfo']['meta_info']


                                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.description = None
                                                                                                                        self.units = None
                                                                                                                        self.value = None
                                                                                                                        self.data_type = None
                                                                                                                        self.status = None
                                                                                                                        self.update_rate = None

                                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                                    class Threshold(_Entity_):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.threshold_array = YList(self)
                                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                        class ThresholdArray(_Entity_):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_name = None
                                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                                class InvAssetBag(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.part_number = None
                                                                                                                        self.manufacturer_assembly_number = None
                                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                                        self.manufacturer_software_identifier = None
                                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvAssetBag']['meta_info']


                                                                                                                class Threshold(_Entity_):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo))])
                                                                                                                        self._leafs = OrderedDict()

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold, [], name, value)


                                                                                                                    class MajorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                                    class CriticalHi(_Entity_):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                                    class MinorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                                    class MajorHi(_Entity_):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                                    class CriticalLo(_Entity_):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                                    class MinorLo(_Entity_):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                            self._leafs = OrderedDict()

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                        class ThreshBag(_Entity_):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\: int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\: bool
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                                ])
                                                                                                                                self.threshold_severity = None
                                                                                                                                self.threshold_relation = None
                                                                                                                                self.threshold_value = None
                                                                                                                                self.threshold_evaluation = None
                                                                                                                                self.threshold_notification_enabled = None
                                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.Threshold']['meta_info']


                                                                                                                class FruInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                        ])
                                                                                                                        self.card_administrative_state = None
                                                                                                                        self.power_administrative_state = None
                                                                                                                        self.card_operational_state = None
                                                                                                                        self.card_monitor_state = None
                                                                                                                        self.card_reset_reason = None
                                                                                                                        self.power_current_measurement = None
                                                                                                                        self.power_operational_state = None

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                                    class CardUpTime(_Entity_):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\: int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                            ])
                                                                                                                            self.time_in_seconds = None
                                                                                                                            self.time_in_nano_seconds = None
                                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.FruInfo']['meta_info']


                                                                                                                class InvEepromInfo(_Entity_):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: form_factor
                                                                                                                    
                                                                                                                    	Optics form factor
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: connector_type
                                                                                                                    
                                                                                                                    	Connector type
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: otn_application_code
                                                                                                                    
                                                                                                                    	Otn Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: sonet_application_code
                                                                                                                    
                                                                                                                    	Sonet Application Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                                    
                                                                                                                    	Ethernet Compliance Code
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: date_string
                                                                                                                    
                                                                                                                    	Date string in IDPROM
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.inv_card_type = None
                                                                                                                        self.opaque_data = None
                                                                                                                        self.opaque_data_size = None
                                                                                                                        self.has_eeprom = None
                                                                                                                        self.description = None
                                                                                                                        self.form_factor = None
                                                                                                                        self.connector_type = None
                                                                                                                        self.otn_application_code = None
                                                                                                                        self.sonet_application_code = None
                                                                                                                        self.ethernet_compliance_code = None
                                                                                                                        self.date_string = None

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                                    class Eeprom(_Entity_):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        .. attribute:: eci_alpha_number
                                                                                                                        
                                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\: str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        	**config**\: False
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2018-04-19'

                                                                                                                        def __init__(self):
                                                                                                                            if sys.version_info > (3,):
                                                                                                                                super().__init__()
                                                                                                                            else:
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                                            self.is_top_level_class = False
                                                                                                                            self.has_list_ancestor = True
                                                                                                                            self.ylist_key_names = []
                                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                            self._leafs = OrderedDict([
                                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                            ])
                                                                                                                            self.description = None
                                                                                                                            self.idprom_format_rev = None
                                                                                                                            self.controller_family = None
                                                                                                                            self.controller_type = None
                                                                                                                            self.vid = None
                                                                                                                            self.hwid = None
                                                                                                                            self.pid = None
                                                                                                                            self.udi_description = None
                                                                                                                            self.udi_name = None
                                                                                                                            self.clei = None
                                                                                                                            self.eci = None
                                                                                                                            self.top_assem_part_num = None
                                                                                                                            self.top_assem_vid = None
                                                                                                                            self.pca_num = None
                                                                                                                            self.pcavid = None
                                                                                                                            self.chassis_sid = None
                                                                                                                            self.dev_num1 = None
                                                                                                                            self.dev_num2 = None
                                                                                                                            self.dev_num3 = None
                                                                                                                            self.dev_num4 = None
                                                                                                                            self.dev_num5 = None
                                                                                                                            self.dev_num6 = None
                                                                                                                            self.dev_num7 = None
                                                                                                                            self.manu_test_data = None
                                                                                                                            self.asset_id = None
                                                                                                                            self.asset_alias = None
                                                                                                                            self.base_mac_address1 = None
                                                                                                                            self.mac_add_blk_size1 = None
                                                                                                                            self.base_mac_address2 = None
                                                                                                                            self.mac_add_blk_size2 = None
                                                                                                                            self.base_mac_address3 = None
                                                                                                                            self.mac_add_blk_size3 = None
                                                                                                                            self.base_mac_address4 = None
                                                                                                                            self.mac_add_blk_size4 = None
                                                                                                                            self.pcb_serial_num = None
                                                                                                                            self.power_supply_type = None
                                                                                                                            self.power_consumption = None
                                                                                                                            self.block_signature = None
                                                                                                                            self.block_version = None
                                                                                                                            self.block_length = None
                                                                                                                            self.block_checksum = None
                                                                                                                            self.eeprom_size = None
                                                                                                                            self.block_count = None
                                                                                                                            self.fru_major_type = None
                                                                                                                            self.fru_minor_type = None
                                                                                                                            self.oem_string = None
                                                                                                                            self.product_id = None
                                                                                                                            self.serial_number = None
                                                                                                                            self.part_number = None
                                                                                                                            self.part_revision = None
                                                                                                                            self.mfg_deviation = None
                                                                                                                            self.hw_version = None
                                                                                                                            self.mfg_bits = None
                                                                                                                            self.engineer_use = None
                                                                                                                            self.snmpoid = None
                                                                                                                            self.rma_code = None
                                                                                                                            self.eci_alpha_number = None

                                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                                            self._is_frozen = True

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                        class Rma(_Entity_):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\: str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            	**config**\: False
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2018-04-19'

                                                                                                                            def __init__(self):
                                                                                                                                if sys.version_info > (3,):
                                                                                                                                    super().__init__()
                                                                                                                                else:
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                                self.is_top_level_class = False
                                                                                                                                self.has_list_ancestor = True
                                                                                                                                self.ylist_key_names = []
                                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                                self._leafs = OrderedDict([
                                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                                ])
                                                                                                                                self.test_history = None
                                                                                                                                self.rma_number = None
                                                                                                                                self.rma_history = None
                                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                                self._is_frozen = True

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                            @staticmethod
                                                                                                                            def _meta_info():
                                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                        @staticmethod
                                                                                                                        def _meta_info():
                                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes.InvEepromInfo']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11.Attributes']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s.Tsi11']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Tsi11s']['meta_info']


                                                                                                    class Attributes(_Entity_):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._segment_path = lambda: "attributes"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes, [], name, value)


                                                                                                        class InvBasicBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: allocated_power
                                                                                                            
                                                                                                            	Allocated power for an entity
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_capacity
                                                                                                            
                                                                                                            	Power Capacity of a Power Module
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.vendor_type = None
                                                                                                                self.name = None
                                                                                                                self.hardware_revision = None
                                                                                                                self.firmware_revision = None
                                                                                                                self.software_revision = None
                                                                                                                self.chip_hardware_revision = None
                                                                                                                self.serial_number = None
                                                                                                                self.manufacturer_name = None
                                                                                                                self.model_name = None
                                                                                                                self.asset_id_str = None
                                                                                                                self.asset_identification = None
                                                                                                                self.is_field_replaceable_unit = None
                                                                                                                self.manufacturer_asset_tags = None
                                                                                                                self.composite_class_code = None
                                                                                                                self.memory_size = None
                                                                                                                self.environmental_monitor_path = None
                                                                                                                self.alias = None
                                                                                                                self.group_flag = None
                                                                                                                self.new_deviation_number = None
                                                                                                                self.physical_layer_interface_module_type = None
                                                                                                                self.unrecognized_fru = None
                                                                                                                self.redundancystate = None
                                                                                                                self.ceport = None
                                                                                                                self.xr_scoped = None
                                                                                                                self.unique_id = None
                                                                                                                self.allocated_power = None
                                                                                                                self.power_capacity = None
                                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvBasicBag']['meta_info']


                                                                                                        class EnvSensorInfo(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: average
                                                                                                            
                                                                                                            	Average sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minimum
                                                                                                            
                                                                                                            	Minimum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: maximum
                                                                                                            
                                                                                                            	Maximum Sensor value over time interval
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: interval
                                                                                                            
                                                                                                            	Time Interval over which sensor value is monitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                                ])
                                                                                                                self.field_validity_bitmap = None
                                                                                                                self.device_description = None
                                                                                                                self.units = None
                                                                                                                self.device_id = None
                                                                                                                self.value = None
                                                                                                                self.alarm_type = None
                                                                                                                self.data_type = None
                                                                                                                self.scale = None
                                                                                                                self.precision = None
                                                                                                                self.status = None
                                                                                                                self.age_time_stamp = None
                                                                                                                self.update_rate = None
                                                                                                                self.average = None
                                                                                                                self.minimum = None
                                                                                                                self.maximum = None
                                                                                                                self.interval = None
                                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfo']['meta_info']


                                                                                                        class PwgInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                                ])
                                                                                                                self.power_group_redundancy_mode = None
                                                                                                                self.power_group_power_units = None
                                                                                                                self.power_group_available_current = None
                                                                                                                self.power_group_drawn_current = None
                                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.PwgInfo']['meta_info']


                                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                                ])
                                                                                                                self.description = None
                                                                                                                self.units = None
                                                                                                                self.value = None
                                                                                                                self.data_type = None
                                                                                                                self.status = None
                                                                                                                self.update_rate = None

                                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                            class Threshold(_Entity_):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.threshold_array = YList(self)
                                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                                class ThresholdArray(_Entity_):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_name = None
                                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                        class InvAssetBag(_Entity_):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.part_number = None
                                                                                                                self.manufacturer_assembly_number = None
                                                                                                                self.manufacturer_assembly_revision = None
                                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                                self.manufacturer_software_identifier = None
                                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvAssetBag']['meta_info']


                                                                                                        class Threshold(_Entity_):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo))])
                                                                                                                self._leafs = OrderedDict()

                                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._segment_path = lambda: "threshold"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold, [], name, value)


                                                                                                            class MajorLo(_Entity_):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                            class CriticalHi(_Entity_):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                            class MinorHi(_Entity_):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                            class MajorHi(_Entity_):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                            class CriticalLo(_Entity_):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                            class MinorLo(_Entity_):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                                    self._leafs = OrderedDict()

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                                class ThreshBag(_Entity_):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\: int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\: bool
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                        ])
                                                                                                                        self.threshold_severity = None
                                                                                                                        self.threshold_relation = None
                                                                                                                        self.threshold_value = None
                                                                                                                        self.threshold_evaluation = None
                                                                                                                        self.threshold_notification_enabled = None
                                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.Threshold']['meta_info']


                                                                                                        class FruInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                                ])
                                                                                                                self.card_administrative_state = None
                                                                                                                self.power_administrative_state = None
                                                                                                                self.card_operational_state = None
                                                                                                                self.card_monitor_state = None
                                                                                                                self.card_reset_reason = None
                                                                                                                self.power_current_measurement = None
                                                                                                                self.power_operational_state = None

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                            class CardUpTime(_Entity_):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\: int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                                    ])
                                                                                                                    self.time_in_seconds = None
                                                                                                                    self.time_in_nano_seconds = None
                                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.FruInfo']['meta_info']


                                                                                                        class InvEepromInfo(_Entity_):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: form_factor
                                                                                                            
                                                                                                            	Optics form factor
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: connector_type
                                                                                                            
                                                                                                            	Connector type
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: otn_application_code
                                                                                                            
                                                                                                            	Otn Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: sonet_application_code
                                                                                                            
                                                                                                            	Sonet Application Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: ethernet_compliance_code
                                                                                                            
                                                                                                            	Ethernet Compliance Code
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: date_string
                                                                                                            
                                                                                                            	Date string in IDPROM
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom))])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                                ])
                                                                                                                self.inv_card_type = None
                                                                                                                self.opaque_data = None
                                                                                                                self.opaque_data_size = None
                                                                                                                self.has_eeprom = None
                                                                                                                self.description = None
                                                                                                                self.form_factor = None
                                                                                                                self.connector_type = None
                                                                                                                self.otn_application_code = None
                                                                                                                self.sonet_application_code = None
                                                                                                                self.ethernet_compliance_code = None
                                                                                                                self.date_string = None

                                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                            class Eeprom(_Entity_):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                .. attribute:: eci_alpha_number
                                                                                                                
                                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                                	**type**\: str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                	**config**\: False
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2018-04-19'

                                                                                                                def __init__(self):
                                                                                                                    if sys.version_info > (3,):
                                                                                                                        super().__init__()
                                                                                                                    else:
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                                    self.is_top_level_class = False
                                                                                                                    self.has_list_ancestor = True
                                                                                                                    self.ylist_key_names = []
                                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                                    self._leafs = OrderedDict([
                                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                                    ])
                                                                                                                    self.description = None
                                                                                                                    self.idprom_format_rev = None
                                                                                                                    self.controller_family = None
                                                                                                                    self.controller_type = None
                                                                                                                    self.vid = None
                                                                                                                    self.hwid = None
                                                                                                                    self.pid = None
                                                                                                                    self.udi_description = None
                                                                                                                    self.udi_name = None
                                                                                                                    self.clei = None
                                                                                                                    self.eci = None
                                                                                                                    self.top_assem_part_num = None
                                                                                                                    self.top_assem_vid = None
                                                                                                                    self.pca_num = None
                                                                                                                    self.pcavid = None
                                                                                                                    self.chassis_sid = None
                                                                                                                    self.dev_num1 = None
                                                                                                                    self.dev_num2 = None
                                                                                                                    self.dev_num3 = None
                                                                                                                    self.dev_num4 = None
                                                                                                                    self.dev_num5 = None
                                                                                                                    self.dev_num6 = None
                                                                                                                    self.dev_num7 = None
                                                                                                                    self.manu_test_data = None
                                                                                                                    self.asset_id = None
                                                                                                                    self.asset_alias = None
                                                                                                                    self.base_mac_address1 = None
                                                                                                                    self.mac_add_blk_size1 = None
                                                                                                                    self.base_mac_address2 = None
                                                                                                                    self.mac_add_blk_size2 = None
                                                                                                                    self.base_mac_address3 = None
                                                                                                                    self.mac_add_blk_size3 = None
                                                                                                                    self.base_mac_address4 = None
                                                                                                                    self.mac_add_blk_size4 = None
                                                                                                                    self.pcb_serial_num = None
                                                                                                                    self.power_supply_type = None
                                                                                                                    self.power_consumption = None
                                                                                                                    self.block_signature = None
                                                                                                                    self.block_version = None
                                                                                                                    self.block_length = None
                                                                                                                    self.block_checksum = None
                                                                                                                    self.eeprom_size = None
                                                                                                                    self.block_count = None
                                                                                                                    self.fru_major_type = None
                                                                                                                    self.fru_minor_type = None
                                                                                                                    self.oem_string = None
                                                                                                                    self.product_id = None
                                                                                                                    self.serial_number = None
                                                                                                                    self.part_number = None
                                                                                                                    self.part_revision = None
                                                                                                                    self.mfg_deviation = None
                                                                                                                    self.hw_version = None
                                                                                                                    self.mfg_bits = None
                                                                                                                    self.engineer_use = None
                                                                                                                    self.snmpoid = None
                                                                                                                    self.rma_code = None
                                                                                                                    self.eci_alpha_number = None

                                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                                    self._is_frozen = True

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                                class Rma(_Entity_):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\: str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    	**config**\: False
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2018-04-19'

                                                                                                                    def __init__(self):
                                                                                                                        if sys.version_info > (3,):
                                                                                                                            super().__init__()
                                                                                                                        else:
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                                        self.is_top_level_class = False
                                                                                                                        self.has_list_ancestor = True
                                                                                                                        self.ylist_key_names = []
                                                                                                                        self._child_classes = OrderedDict([])
                                                                                                                        self._leafs = OrderedDict([
                                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                        ])
                                                                                                                        self.test_history = None
                                                                                                                        self.rma_number = None
                                                                                                                        self.rma_history = None
                                                                                                                        self._segment_path = lambda: "rma"
                                                                                                                        self._is_frozen = True

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                                    @staticmethod
                                                                                                                    def _meta_info():
                                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                                @staticmethod
                                                                                                                def _meta_info():
                                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes.InvEepromInfo']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10.Attributes']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s.Tsi10']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Tsi10s']['meta_info']


                                                                                            class Attributes(_Entity_):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._segment_path = lambda: "attributes"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes, [], name, value)


                                                                                                class InvBasicBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: allocated_power
                                                                                                    
                                                                                                    	Allocated power for an entity
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_capacity
                                                                                                    
                                                                                                    	Power Capacity of a Power Module
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.vendor_type = None
                                                                                                        self.name = None
                                                                                                        self.hardware_revision = None
                                                                                                        self.firmware_revision = None
                                                                                                        self.software_revision = None
                                                                                                        self.chip_hardware_revision = None
                                                                                                        self.serial_number = None
                                                                                                        self.manufacturer_name = None
                                                                                                        self.model_name = None
                                                                                                        self.asset_id_str = None
                                                                                                        self.asset_identification = None
                                                                                                        self.is_field_replaceable_unit = None
                                                                                                        self.manufacturer_asset_tags = None
                                                                                                        self.composite_class_code = None
                                                                                                        self.memory_size = None
                                                                                                        self.environmental_monitor_path = None
                                                                                                        self.alias = None
                                                                                                        self.group_flag = None
                                                                                                        self.new_deviation_number = None
                                                                                                        self.physical_layer_interface_module_type = None
                                                                                                        self.unrecognized_fru = None
                                                                                                        self.redundancystate = None
                                                                                                        self.ceport = None
                                                                                                        self.xr_scoped = None
                                                                                                        self.unique_id = None
                                                                                                        self.allocated_power = None
                                                                                                        self.power_capacity = None
                                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvBasicBag']['meta_info']


                                                                                                class EnvSensorInfo(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: average
                                                                                                    
                                                                                                    	Average sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minimum
                                                                                                    
                                                                                                    	Minimum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: maximum
                                                                                                    
                                                                                                    	Maximum Sensor value over time interval
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: interval
                                                                                                    
                                                                                                    	Time Interval over which sensor value is monitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                        ])
                                                                                                        self.field_validity_bitmap = None
                                                                                                        self.device_description = None
                                                                                                        self.units = None
                                                                                                        self.device_id = None
                                                                                                        self.value = None
                                                                                                        self.alarm_type = None
                                                                                                        self.data_type = None
                                                                                                        self.scale = None
                                                                                                        self.precision = None
                                                                                                        self.status = None
                                                                                                        self.age_time_stamp = None
                                                                                                        self.update_rate = None
                                                                                                        self.average = None
                                                                                                        self.minimum = None
                                                                                                        self.maximum = None
                                                                                                        self.interval = None
                                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfo']['meta_info']


                                                                                                class PwgInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                        ])
                                                                                                        self.power_group_redundancy_mode = None
                                                                                                        self.power_group_power_units = None
                                                                                                        self.power_group_available_current = None
                                                                                                        self.power_group_drawn_current = None
                                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.PwgInfo']['meta_info']


                                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                        ])
                                                                                                        self.description = None
                                                                                                        self.units = None
                                                                                                        self.value = None
                                                                                                        self.data_type = None
                                                                                                        self.status = None
                                                                                                        self.update_rate = None

                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                                    class Threshold(_Entity_):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.threshold_array = YList(self)
                                                                                                            self._segment_path = lambda: "threshold"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                        class ThresholdArray(_Entity_):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_name = None
                                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                                class InvAssetBag(_Entity_):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.part_number = None
                                                                                                        self.manufacturer_assembly_number = None
                                                                                                        self.manufacturer_assembly_revision = None
                                                                                                        self.manufacturer_firmware_identifier = None
                                                                                                        self.manufacturer_software_identifier = None
                                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                                        self.original_equipment_manufacturer_string = None
                                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvAssetBag']['meta_info']


                                                                                                class Threshold(_Entity_):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._segment_path = lambda: "threshold"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold, [], name, value)


                                                                                                    class MajorLo(_Entity_):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorLo']['meta_info']


                                                                                                    class CriticalHi(_Entity_):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                                    class MinorHi(_Entity_):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorHi']['meta_info']


                                                                                                    class MajorHi(_Entity_):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "major-hi"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MajorHi']['meta_info']


                                                                                                    class CriticalLo(_Entity_):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                                    class MinorLo(_Entity_):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                            self._leafs = OrderedDict()

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                        class ThreshBag(_Entity_):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\: int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\: bool
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                                ])
                                                                                                                self.threshold_severity = None
                                                                                                                self.threshold_relation = None
                                                                                                                self.threshold_value = None
                                                                                                                self.threshold_evaluation = None
                                                                                                                self.threshold_notification_enabled = None
                                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold.MinorLo']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.Threshold']['meta_info']


                                                                                                class FruInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                        ])
                                                                                                        self.card_administrative_state = None
                                                                                                        self.power_administrative_state = None
                                                                                                        self.card_operational_state = None
                                                                                                        self.card_monitor_state = None
                                                                                                        self.card_reset_reason = None
                                                                                                        self.power_current_measurement = None
                                                                                                        self.power_operational_state = None

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._segment_path = lambda: "fru-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                                    class CardUpTime(_Entity_):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                            ])
                                                                                                            self.time_in_seconds = None
                                                                                                            self.time_in_nano_seconds = None
                                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.FruInfo']['meta_info']


                                                                                                class InvEepromInfo(_Entity_):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: form_factor
                                                                                                    
                                                                                                    	Optics form factor
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: connector_type
                                                                                                    
                                                                                                    	Connector type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: otn_application_code
                                                                                                    
                                                                                                    	Otn Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: sonet_application_code
                                                                                                    
                                                                                                    	Sonet Application Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: ethernet_compliance_code
                                                                                                    
                                                                                                    	Ethernet Compliance Code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: date_string
                                                                                                    
                                                                                                    	Date string in IDPROM
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                        ])
                                                                                                        self.inv_card_type = None
                                                                                                        self.opaque_data = None
                                                                                                        self.opaque_data_size = None
                                                                                                        self.has_eeprom = None
                                                                                                        self.description = None
                                                                                                        self.form_factor = None
                                                                                                        self.connector_type = None
                                                                                                        self.otn_application_code = None
                                                                                                        self.sonet_application_code = None
                                                                                                        self.ethernet_compliance_code = None
                                                                                                        self.date_string = None

                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                                    class Eeprom(_Entity_):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        .. attribute:: eci_alpha_number
                                                                                                        
                                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        	**config**\: False
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2018-04-19'

                                                                                                        def __init__(self):
                                                                                                            if sys.version_info > (3,):
                                                                                                                super().__init__()
                                                                                                            else:
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                            ])
                                                                                                            self.description = None
                                                                                                            self.idprom_format_rev = None
                                                                                                            self.controller_family = None
                                                                                                            self.controller_type = None
                                                                                                            self.vid = None
                                                                                                            self.hwid = None
                                                                                                            self.pid = None
                                                                                                            self.udi_description = None
                                                                                                            self.udi_name = None
                                                                                                            self.clei = None
                                                                                                            self.eci = None
                                                                                                            self.top_assem_part_num = None
                                                                                                            self.top_assem_vid = None
                                                                                                            self.pca_num = None
                                                                                                            self.pcavid = None
                                                                                                            self.chassis_sid = None
                                                                                                            self.dev_num1 = None
                                                                                                            self.dev_num2 = None
                                                                                                            self.dev_num3 = None
                                                                                                            self.dev_num4 = None
                                                                                                            self.dev_num5 = None
                                                                                                            self.dev_num6 = None
                                                                                                            self.dev_num7 = None
                                                                                                            self.manu_test_data = None
                                                                                                            self.asset_id = None
                                                                                                            self.asset_alias = None
                                                                                                            self.base_mac_address1 = None
                                                                                                            self.mac_add_blk_size1 = None
                                                                                                            self.base_mac_address2 = None
                                                                                                            self.mac_add_blk_size2 = None
                                                                                                            self.base_mac_address3 = None
                                                                                                            self.mac_add_blk_size3 = None
                                                                                                            self.base_mac_address4 = None
                                                                                                            self.mac_add_blk_size4 = None
                                                                                                            self.pcb_serial_num = None
                                                                                                            self.power_supply_type = None
                                                                                                            self.power_consumption = None
                                                                                                            self.block_signature = None
                                                                                                            self.block_version = None
                                                                                                            self.block_length = None
                                                                                                            self.block_checksum = None
                                                                                                            self.eeprom_size = None
                                                                                                            self.block_count = None
                                                                                                            self.fru_major_type = None
                                                                                                            self.fru_minor_type = None
                                                                                                            self.oem_string = None
                                                                                                            self.product_id = None
                                                                                                            self.serial_number = None
                                                                                                            self.part_number = None
                                                                                                            self.part_revision = None
                                                                                                            self.mfg_deviation = None
                                                                                                            self.hw_version = None
                                                                                                            self.mfg_bits = None
                                                                                                            self.engineer_use = None
                                                                                                            self.snmpoid = None
                                                                                                            self.rma_code = None
                                                                                                            self.eci_alpha_number = None

                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._segment_path = lambda: "eeprom"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                        class Rma(_Entity_):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\: str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            	**config**\: False
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2018-04-19'

                                                                                                            def __init__(self):
                                                                                                                if sys.version_info > (3,):
                                                                                                                    super().__init__()
                                                                                                                else:
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"
                                                                                                                self.is_top_level_class = False
                                                                                                                self.has_list_ancestor = True
                                                                                                                self.ylist_key_names = []
                                                                                                                self._child_classes = OrderedDict([])
                                                                                                                self._leafs = OrderedDict([
                                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                                ])
                                                                                                                self.test_history = None
                                                                                                                self.rma_number = None
                                                                                                                self.rma_history = None
                                                                                                                self._segment_path = lambda: "rma"
                                                                                                                self._is_frozen = True

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                            @staticmethod
                                                                                                            def _meta_info():
                                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                        @staticmethod
                                                                                                        def _meta_info():
                                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes.InvEepromInfo']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9.Attributes']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s.Tsi9']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Tsi9s']['meta_info']


                                                                                    class Attributes(_Entity_):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"

                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._segment_path = lambda: "attributes"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes, [], name, value)


                                                                                        class InvBasicBag(_Entity_):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if applicable to this entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: allocated_power
                                                                                            
                                                                                            	Allocated power for an entity
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_capacity
                                                                                            
                                                                                            	Power Capacity of a Power Module
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.vendor_type = None
                                                                                                self.name = None
                                                                                                self.hardware_revision = None
                                                                                                self.firmware_revision = None
                                                                                                self.software_revision = None
                                                                                                self.chip_hardware_revision = None
                                                                                                self.serial_number = None
                                                                                                self.manufacturer_name = None
                                                                                                self.model_name = None
                                                                                                self.asset_id_str = None
                                                                                                self.asset_identification = None
                                                                                                self.is_field_replaceable_unit = None
                                                                                                self.manufacturer_asset_tags = None
                                                                                                self.composite_class_code = None
                                                                                                self.memory_size = None
                                                                                                self.environmental_monitor_path = None
                                                                                                self.alias = None
                                                                                                self.group_flag = None
                                                                                                self.new_deviation_number = None
                                                                                                self.physical_layer_interface_module_type = None
                                                                                                self.unrecognized_fru = None
                                                                                                self.redundancystate = None
                                                                                                self.ceport = None
                                                                                                self.xr_scoped = None
                                                                                                self.unique_id = None
                                                                                                self.allocated_power = None
                                                                                                self.power_capacity = None
                                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvBasicBag']['meta_info']


                                                                                        class EnvSensorInfo(_Entity_):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: average
                                                                                            
                                                                                            	Average sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minimum
                                                                                            
                                                                                            	Minimum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: maximum
                                                                                            
                                                                                            	Maximum Sensor value over time interval
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: interval
                                                                                            
                                                                                            	Time Interval over which sensor value is monitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                                ])
                                                                                                self.field_validity_bitmap = None
                                                                                                self.device_description = None
                                                                                                self.units = None
                                                                                                self.device_id = None
                                                                                                self.value = None
                                                                                                self.alarm_type = None
                                                                                                self.data_type = None
                                                                                                self.scale = None
                                                                                                self.precision = None
                                                                                                self.status = None
                                                                                                self.age_time_stamp = None
                                                                                                self.update_rate = None
                                                                                                self.average = None
                                                                                                self.minimum = None
                                                                                                self.maximum = None
                                                                                                self.interval = None
                                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfo']['meta_info']


                                                                                        class PwgInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                                ])
                                                                                                self.power_group_redundancy_mode = None
                                                                                                self.power_group_power_units = None
                                                                                                self.power_group_available_current = None
                                                                                                self.power_group_drawn_current = None
                                                                                                self._segment_path = lambda: "pwg-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.PwgInfo']['meta_info']


                                                                                        class EnvSensorInfoXml(_Entity_):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                                ])
                                                                                                self.description = None
                                                                                                self.units = None
                                                                                                self.value = None
                                                                                                self.data_type = None
                                                                                                self.status = None
                                                                                                self.update_rate = None

                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                            class Threshold(_Entity_):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.threshold_array = YList(self)
                                                                                                    self._segment_path = lambda: "threshold"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                                class ThresholdArray(_Entity_):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_name = None
                                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                        class InvAssetBag(_Entity_):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                                ])
                                                                                                self.part_number = None
                                                                                                self.manufacturer_assembly_number = None
                                                                                                self.manufacturer_assembly_revision = None
                                                                                                self.manufacturer_firmware_identifier = None
                                                                                                self.manufacturer_software_identifier = None
                                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                                self.original_equipment_manufacturer_string = None
                                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvAssetBag']['meta_info']


                                                                                        class Threshold(_Entity_):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._segment_path = lambda: "threshold"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold, [], name, value)


                                                                                            class MajorLo(_Entity_):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorLo']['meta_info']


                                                                                            class CriticalHi(_Entity_):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                            class MinorHi(_Entity_):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorHi']['meta_info']


                                                                                            class MajorHi(_Entity_):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "major-hi"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MajorHi']['meta_info']


                                                                                            class CriticalLo(_Entity_):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                            class MinorLo(_Entity_):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo, [], name, value)


                                                                                                class ThreshBag(_Entity_):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                        ])
                                                                                                        self.threshold_severity = None
                                                                                                        self.threshold_relation = None
                                                                                                        self.threshold_value = None
                                                                                                        self.threshold_evaluation = None
                                                                                                        self.threshold_notification_enabled = None
                                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold.MinorLo']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.Threshold']['meta_info']


                                                                                        class FruInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                                ])
                                                                                                self.card_administrative_state = None
                                                                                                self.power_administrative_state = None
                                                                                                self.card_operational_state = None
                                                                                                self.card_monitor_state = None
                                                                                                self.card_reset_reason = None
                                                                                                self.power_current_measurement = None
                                                                                                self.power_operational_state = None

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._segment_path = lambda: "fru-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                            class LastOperationalStateChange(_Entity_):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                            class CardUpTime(_Entity_):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                                    ])
                                                                                                    self.time_in_seconds = None
                                                                                                    self.time_in_nano_seconds = None
                                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.FruInfo']['meta_info']


                                                                                        class InvEepromInfo(_Entity_):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: form_factor
                                                                                            
                                                                                            	Optics form factor
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: connector_type
                                                                                            
                                                                                            	Connector type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: otn_application_code
                                                                                            
                                                                                            	Otn Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: sonet_application_code
                                                                                            
                                                                                            	Sonet Application Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: ethernet_compliance_code
                                                                                            
                                                                                            	Ethernet Compliance Code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: date_string
                                                                                            
                                                                                            	Date string in IDPROM
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                                ])
                                                                                                self.inv_card_type = None
                                                                                                self.opaque_data = None
                                                                                                self.opaque_data_size = None
                                                                                                self.has_eeprom = None
                                                                                                self.description = None
                                                                                                self.form_factor = None
                                                                                                self.connector_type = None
                                                                                                self.otn_application_code = None
                                                                                                self.sonet_application_code = None
                                                                                                self.ethernet_compliance_code = None
                                                                                                self.date_string = None

                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                            class Eeprom(_Entity_):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                .. attribute:: eci_alpha_number
                                                                                                
                                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                	**config**\: False
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2018-04-19'

                                                                                                def __init__(self):
                                                                                                    if sys.version_info > (3,):
                                                                                                        super().__init__()
                                                                                                    else:
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                                    ])
                                                                                                    self.description = None
                                                                                                    self.idprom_format_rev = None
                                                                                                    self.controller_family = None
                                                                                                    self.controller_type = None
                                                                                                    self.vid = None
                                                                                                    self.hwid = None
                                                                                                    self.pid = None
                                                                                                    self.udi_description = None
                                                                                                    self.udi_name = None
                                                                                                    self.clei = None
                                                                                                    self.eci = None
                                                                                                    self.top_assem_part_num = None
                                                                                                    self.top_assem_vid = None
                                                                                                    self.pca_num = None
                                                                                                    self.pcavid = None
                                                                                                    self.chassis_sid = None
                                                                                                    self.dev_num1 = None
                                                                                                    self.dev_num2 = None
                                                                                                    self.dev_num3 = None
                                                                                                    self.dev_num4 = None
                                                                                                    self.dev_num5 = None
                                                                                                    self.dev_num6 = None
                                                                                                    self.dev_num7 = None
                                                                                                    self.manu_test_data = None
                                                                                                    self.asset_id = None
                                                                                                    self.asset_alias = None
                                                                                                    self.base_mac_address1 = None
                                                                                                    self.mac_add_blk_size1 = None
                                                                                                    self.base_mac_address2 = None
                                                                                                    self.mac_add_blk_size2 = None
                                                                                                    self.base_mac_address3 = None
                                                                                                    self.mac_add_blk_size3 = None
                                                                                                    self.base_mac_address4 = None
                                                                                                    self.mac_add_blk_size4 = None
                                                                                                    self.pcb_serial_num = None
                                                                                                    self.power_supply_type = None
                                                                                                    self.power_consumption = None
                                                                                                    self.block_signature = None
                                                                                                    self.block_version = None
                                                                                                    self.block_length = None
                                                                                                    self.block_checksum = None
                                                                                                    self.eeprom_size = None
                                                                                                    self.block_count = None
                                                                                                    self.fru_major_type = None
                                                                                                    self.fru_minor_type = None
                                                                                                    self.oem_string = None
                                                                                                    self.product_id = None
                                                                                                    self.serial_number = None
                                                                                                    self.part_number = None
                                                                                                    self.part_revision = None
                                                                                                    self.mfg_deviation = None
                                                                                                    self.hw_version = None
                                                                                                    self.mfg_bits = None
                                                                                                    self.engineer_use = None
                                                                                                    self.snmpoid = None
                                                                                                    self.rma_code = None
                                                                                                    self.eci_alpha_number = None

                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._segment_path = lambda: "eeprom"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                                class Rma(_Entity_):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    	**config**\: False
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2018-04-19'

                                                                                                    def __init__(self):
                                                                                                        if sys.version_info > (3,):
                                                                                                            super().__init__()
                                                                                                        else:
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                        ])
                                                                                                        self.test_history = None
                                                                                                        self.rma_number = None
                                                                                                        self.rma_history = None
                                                                                                        self._segment_path = lambda: "rma"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                                    @staticmethod
                                                                                                    def _meta_info():
                                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                                @staticmethod
                                                                                                def _meta_info():
                                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes.InvEepromInfo']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8.Attributes']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s.Tsi8']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Tsi8s']['meta_info']


                                                                            class Attributes(_Entity_):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"

                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._segment_path = lambda: "attributes"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes, [], name, value)


                                                                                class InvBasicBag(_Entity_):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if applicable to this entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: allocated_power
                                                                                    
                                                                                    	Allocated power for an entity
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_capacity
                                                                                    
                                                                                    	Power Capacity of a Power Module
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.vendor_type = None
                                                                                        self.name = None
                                                                                        self.hardware_revision = None
                                                                                        self.firmware_revision = None
                                                                                        self.software_revision = None
                                                                                        self.chip_hardware_revision = None
                                                                                        self.serial_number = None
                                                                                        self.manufacturer_name = None
                                                                                        self.model_name = None
                                                                                        self.asset_id_str = None
                                                                                        self.asset_identification = None
                                                                                        self.is_field_replaceable_unit = None
                                                                                        self.manufacturer_asset_tags = None
                                                                                        self.composite_class_code = None
                                                                                        self.memory_size = None
                                                                                        self.environmental_monitor_path = None
                                                                                        self.alias = None
                                                                                        self.group_flag = None
                                                                                        self.new_deviation_number = None
                                                                                        self.physical_layer_interface_module_type = None
                                                                                        self.unrecognized_fru = None
                                                                                        self.redundancystate = None
                                                                                        self.ceport = None
                                                                                        self.xr_scoped = None
                                                                                        self.unique_id = None
                                                                                        self.allocated_power = None
                                                                                        self.power_capacity = None
                                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvBasicBag']['meta_info']


                                                                                class EnvSensorInfo(_Entity_):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: average
                                                                                    
                                                                                    	Average sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minimum
                                                                                    
                                                                                    	Minimum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: maximum
                                                                                    
                                                                                    	Maximum Sensor value over time interval
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: interval
                                                                                    
                                                                                    	Time Interval over which sensor value is monitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                        ])
                                                                                        self.field_validity_bitmap = None
                                                                                        self.device_description = None
                                                                                        self.units = None
                                                                                        self.device_id = None
                                                                                        self.value = None
                                                                                        self.alarm_type = None
                                                                                        self.data_type = None
                                                                                        self.scale = None
                                                                                        self.precision = None
                                                                                        self.status = None
                                                                                        self.age_time_stamp = None
                                                                                        self.update_rate = None
                                                                                        self.average = None
                                                                                        self.minimum = None
                                                                                        self.maximum = None
                                                                                        self.interval = None
                                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfo']['meta_info']


                                                                                class PwgInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                        ])
                                                                                        self.power_group_redundancy_mode = None
                                                                                        self.power_group_power_units = None
                                                                                        self.power_group_available_current = None
                                                                                        self.power_group_drawn_current = None
                                                                                        self._segment_path = lambda: "pwg-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.PwgInfo']['meta_info']


                                                                                class EnvSensorInfoXml(_Entity_):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                        ])
                                                                                        self.description = None
                                                                                        self.units = None
                                                                                        self.value = None
                                                                                        self.data_type = None
                                                                                        self.status = None
                                                                                        self.update_rate = None

                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                                    class Threshold(_Entity_):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.threshold_array = YList(self)
                                                                                            self._segment_path = lambda: "threshold"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                        class ThresholdArray(_Entity_):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_name = None
                                                                                                self._segment_path = lambda: "threshold-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.EnvSensorInfoXml']['meta_info']


                                                                                class InvAssetBag(_Entity_):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                        ])
                                                                                        self.part_number = None
                                                                                        self.manufacturer_assembly_number = None
                                                                                        self.manufacturer_assembly_revision = None
                                                                                        self.manufacturer_firmware_identifier = None
                                                                                        self.manufacturer_software_identifier = None
                                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                                        self.original_equipment_manufacturer_string = None
                                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvAssetBag']['meta_info']


                                                                                class Threshold(_Entity_):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._segment_path = lambda: "threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold, [], name, value)


                                                                                    class MajorLo(_Entity_):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorLo']['meta_info']


                                                                                    class CriticalHi(_Entity_):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalHi']['meta_info']


                                                                                    class MinorHi(_Entity_):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorHi']['meta_info']


                                                                                    class MajorHi(_Entity_):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "major-hi"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MajorHi']['meta_info']


                                                                                    class CriticalLo(_Entity_):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "critical-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.CriticalLo']['meta_info']


                                                                                    class MinorLo(_Entity_):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._segment_path = lambda: "minor-lo"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo, [], name, value)


                                                                                        class ThreshBag(_Entity_):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\: bool
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                                ])
                                                                                                self.threshold_severity = None
                                                                                                self.threshold_relation = None
                                                                                                self.threshold_value = None
                                                                                                self.threshold_evaluation = None
                                                                                                self.threshold_notification_enabled = None
                                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold.MinorLo']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.Threshold']['meta_info']


                                                                                class FruInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                        ])
                                                                                        self.card_administrative_state = None
                                                                                        self.power_administrative_state = None
                                                                                        self.card_operational_state = None
                                                                                        self.card_monitor_state = None
                                                                                        self.card_reset_reason = None
                                                                                        self.power_current_measurement = None
                                                                                        self.power_operational_state = None

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._segment_path = lambda: "fru-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                                    class LastOperationalStateChange(_Entity_):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                                    class CardUpTime(_Entity_):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                            ])
                                                                                            self.time_in_seconds = None
                                                                                            self.time_in_nano_seconds = None
                                                                                            self._segment_path = lambda: "card-up-time"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.FruInfo']['meta_info']


                                                                                class InvEepromInfo(_Entity_):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: form_factor
                                                                                    
                                                                                    	Optics form factor
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: connector_type
                                                                                    
                                                                                    	Connector type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: otn_application_code
                                                                                    
                                                                                    	Otn Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: sonet_application_code
                                                                                    
                                                                                    	Sonet Application Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: ethernet_compliance_code
                                                                                    
                                                                                    	Ethernet Compliance Code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: date_string
                                                                                    
                                                                                    	Date string in IDPROM
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                        ])
                                                                                        self.inv_card_type = None
                                                                                        self.opaque_data = None
                                                                                        self.opaque_data_size = None
                                                                                        self.has_eeprom = None
                                                                                        self.description = None
                                                                                        self.form_factor = None
                                                                                        self.connector_type = None
                                                                                        self.otn_application_code = None
                                                                                        self.sonet_application_code = None
                                                                                        self.ethernet_compliance_code = None
                                                                                        self.date_string = None

                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                                    class Eeprom(_Entity_):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        .. attribute:: eci_alpha_number
                                                                                        
                                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        	**config**\: False
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2018-04-19'

                                                                                        def __init__(self):
                                                                                            if sys.version_info > (3,):
                                                                                                super().__init__()
                                                                                            else:
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                            ])
                                                                                            self.description = None
                                                                                            self.idprom_format_rev = None
                                                                                            self.controller_family = None
                                                                                            self.controller_type = None
                                                                                            self.vid = None
                                                                                            self.hwid = None
                                                                                            self.pid = None
                                                                                            self.udi_description = None
                                                                                            self.udi_name = None
                                                                                            self.clei = None
                                                                                            self.eci = None
                                                                                            self.top_assem_part_num = None
                                                                                            self.top_assem_vid = None
                                                                                            self.pca_num = None
                                                                                            self.pcavid = None
                                                                                            self.chassis_sid = None
                                                                                            self.dev_num1 = None
                                                                                            self.dev_num2 = None
                                                                                            self.dev_num3 = None
                                                                                            self.dev_num4 = None
                                                                                            self.dev_num5 = None
                                                                                            self.dev_num6 = None
                                                                                            self.dev_num7 = None
                                                                                            self.manu_test_data = None
                                                                                            self.asset_id = None
                                                                                            self.asset_alias = None
                                                                                            self.base_mac_address1 = None
                                                                                            self.mac_add_blk_size1 = None
                                                                                            self.base_mac_address2 = None
                                                                                            self.mac_add_blk_size2 = None
                                                                                            self.base_mac_address3 = None
                                                                                            self.mac_add_blk_size3 = None
                                                                                            self.base_mac_address4 = None
                                                                                            self.mac_add_blk_size4 = None
                                                                                            self.pcb_serial_num = None
                                                                                            self.power_supply_type = None
                                                                                            self.power_consumption = None
                                                                                            self.block_signature = None
                                                                                            self.block_version = None
                                                                                            self.block_length = None
                                                                                            self.block_checksum = None
                                                                                            self.eeprom_size = None
                                                                                            self.block_count = None
                                                                                            self.fru_major_type = None
                                                                                            self.fru_minor_type = None
                                                                                            self.oem_string = None
                                                                                            self.product_id = None
                                                                                            self.serial_number = None
                                                                                            self.part_number = None
                                                                                            self.part_revision = None
                                                                                            self.mfg_deviation = None
                                                                                            self.hw_version = None
                                                                                            self.mfg_bits = None
                                                                                            self.engineer_use = None
                                                                                            self.snmpoid = None
                                                                                            self.rma_code = None
                                                                                            self.eci_alpha_number = None

                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._segment_path = lambda: "eeprom"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                        class Rma(_Entity_):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            	**config**\: False
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2018-04-19'

                                                                                            def __init__(self):
                                                                                                if sys.version_info > (3,):
                                                                                                    super().__init__()
                                                                                                else:
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                                ])
                                                                                                self.test_history = None
                                                                                                self.rma_number = None
                                                                                                self.rma_history = None
                                                                                                self._segment_path = lambda: "rma"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                            @staticmethod
                                                                                            def _meta_info():
                                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                        @staticmethod
                                                                                        def _meta_info():
                                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes.InvEepromInfo']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7.Attributes']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s.Tsi7']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Tsi7s']['meta_info']


                                                                    class Attributes(_Entity_):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"

                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._segment_path = lambda: "attributes"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes, [], name, value)


                                                                        class InvBasicBag(_Entity_):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if applicable to this entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: allocated_power
                                                                            
                                                                            	Allocated power for an entity
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_capacity
                                                                            
                                                                            	Power Capacity of a Power Module
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.vendor_type = None
                                                                                self.name = None
                                                                                self.hardware_revision = None
                                                                                self.firmware_revision = None
                                                                                self.software_revision = None
                                                                                self.chip_hardware_revision = None
                                                                                self.serial_number = None
                                                                                self.manufacturer_name = None
                                                                                self.model_name = None
                                                                                self.asset_id_str = None
                                                                                self.asset_identification = None
                                                                                self.is_field_replaceable_unit = None
                                                                                self.manufacturer_asset_tags = None
                                                                                self.composite_class_code = None
                                                                                self.memory_size = None
                                                                                self.environmental_monitor_path = None
                                                                                self.alias = None
                                                                                self.group_flag = None
                                                                                self.new_deviation_number = None
                                                                                self.physical_layer_interface_module_type = None
                                                                                self.unrecognized_fru = None
                                                                                self.redundancystate = None
                                                                                self.ceport = None
                                                                                self.xr_scoped = None
                                                                                self.unique_id = None
                                                                                self.allocated_power = None
                                                                                self.power_capacity = None
                                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvBasicBag']['meta_info']


                                                                        class EnvSensorInfo(_Entity_):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: average
                                                                            
                                                                            	Average sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minimum
                                                                            
                                                                            	Minimum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: maximum
                                                                            
                                                                            	Maximum Sensor value over time interval
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: interval
                                                                            
                                                                            	Time Interval over which sensor value is monitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                                ])
                                                                                self.field_validity_bitmap = None
                                                                                self.device_description = None
                                                                                self.units = None
                                                                                self.device_id = None
                                                                                self.value = None
                                                                                self.alarm_type = None
                                                                                self.data_type = None
                                                                                self.scale = None
                                                                                self.precision = None
                                                                                self.status = None
                                                                                self.age_time_stamp = None
                                                                                self.update_rate = None
                                                                                self.average = None
                                                                                self.minimum = None
                                                                                self.maximum = None
                                                                                self.interval = None
                                                                                self._segment_path = lambda: "env-sensor-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfo']['meta_info']


                                                                        class PwgInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\: str
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                                ])
                                                                                self.power_group_redundancy_mode = None
                                                                                self.power_group_power_units = None
                                                                                self.power_group_available_current = None
                                                                                self.power_group_drawn_current = None
                                                                                self._segment_path = lambda: "pwg-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.PwgInfo']['meta_info']


                                                                        class EnvSensorInfoXml(_Entity_):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                                ])
                                                                                self.description = None
                                                                                self.units = None
                                                                                self.value = None
                                                                                self.data_type = None
                                                                                self.status = None
                                                                                self.update_rate = None

                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                            class Threshold(_Entity_):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.threshold_array = YList(self)
                                                                                    self._segment_path = lambda: "threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                                class ThresholdArray(_Entity_):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_name = None
                                                                                        self._segment_path = lambda: "threshold-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.EnvSensorInfoXml']['meta_info']


                                                                        class InvAssetBag(_Entity_):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                                ])
                                                                                self.part_number = None
                                                                                self.manufacturer_assembly_number = None
                                                                                self.manufacturer_assembly_revision = None
                                                                                self.manufacturer_firmware_identifier = None
                                                                                self.manufacturer_software_identifier = None
                                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                                self.original_equipment_manufacturer_string = None
                                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvAssetBag']['meta_info']


                                                                        class Threshold(_Entity_):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._segment_path = lambda: "threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold, [], name, value)


                                                                            class MajorLo(_Entity_):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorLo']['meta_info']


                                                                            class CriticalHi(_Entity_):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalHi']['meta_info']


                                                                            class MinorHi(_Entity_):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorHi']['meta_info']


                                                                            class MajorHi(_Entity_):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "major-hi"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MajorHi']['meta_info']


                                                                            class CriticalLo(_Entity_):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "critical-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.CriticalLo']['meta_info']


                                                                            class MinorLo(_Entity_):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._segment_path = lambda: "minor-lo"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo, [], name, value)


                                                                                class ThreshBag(_Entity_):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\: bool
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                        ])
                                                                                        self.threshold_severity = None
                                                                                        self.threshold_relation = None
                                                                                        self.threshold_value = None
                                                                                        self.threshold_evaluation = None
                                                                                        self.threshold_notification_enabled = None
                                                                                        self._segment_path = lambda: "thresh-bag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold.MinorLo']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.Threshold']['meta_info']


                                                                        class FruInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                                ])
                                                                                self.card_administrative_state = None
                                                                                self.power_administrative_state = None
                                                                                self.card_operational_state = None
                                                                                self.card_monitor_state = None
                                                                                self.card_reset_reason = None
                                                                                self.power_current_measurement = None
                                                                                self.power_operational_state = None

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._segment_path = lambda: "fru-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                            class LastOperationalStateChange(_Entity_):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                            class CardUpTime(_Entity_):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                                    ])
                                                                                    self.time_in_seconds = None
                                                                                    self.time_in_nano_seconds = None
                                                                                    self._segment_path = lambda: "card-up-time"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.FruInfo']['meta_info']


                                                                        class InvEepromInfo(_Entity_):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: form_factor
                                                                            
                                                                            	Optics form factor
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: connector_type
                                                                            
                                                                            	Connector type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: otn_application_code
                                                                            
                                                                            	Otn Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: sonet_application_code
                                                                            
                                                                            	Sonet Application Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: ethernet_compliance_code
                                                                            
                                                                            	Ethernet Compliance Code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: date_string
                                                                            
                                                                            	Date string in IDPROM
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                                ])
                                                                                self.inv_card_type = None
                                                                                self.opaque_data = None
                                                                                self.opaque_data_size = None
                                                                                self.has_eeprom = None
                                                                                self.description = None
                                                                                self.form_factor = None
                                                                                self.connector_type = None
                                                                                self.otn_application_code = None
                                                                                self.sonet_application_code = None
                                                                                self.ethernet_compliance_code = None
                                                                                self.date_string = None

                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                            class Eeprom(_Entity_):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                .. attribute:: eci_alpha_number
                                                                                
                                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                	**config**\: False
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2018-04-19'

                                                                                def __init__(self):
                                                                                    if sys.version_info > (3,):
                                                                                        super().__init__()
                                                                                    else:
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                                    ])
                                                                                    self.description = None
                                                                                    self.idprom_format_rev = None
                                                                                    self.controller_family = None
                                                                                    self.controller_type = None
                                                                                    self.vid = None
                                                                                    self.hwid = None
                                                                                    self.pid = None
                                                                                    self.udi_description = None
                                                                                    self.udi_name = None
                                                                                    self.clei = None
                                                                                    self.eci = None
                                                                                    self.top_assem_part_num = None
                                                                                    self.top_assem_vid = None
                                                                                    self.pca_num = None
                                                                                    self.pcavid = None
                                                                                    self.chassis_sid = None
                                                                                    self.dev_num1 = None
                                                                                    self.dev_num2 = None
                                                                                    self.dev_num3 = None
                                                                                    self.dev_num4 = None
                                                                                    self.dev_num5 = None
                                                                                    self.dev_num6 = None
                                                                                    self.dev_num7 = None
                                                                                    self.manu_test_data = None
                                                                                    self.asset_id = None
                                                                                    self.asset_alias = None
                                                                                    self.base_mac_address1 = None
                                                                                    self.mac_add_blk_size1 = None
                                                                                    self.base_mac_address2 = None
                                                                                    self.mac_add_blk_size2 = None
                                                                                    self.base_mac_address3 = None
                                                                                    self.mac_add_blk_size3 = None
                                                                                    self.base_mac_address4 = None
                                                                                    self.mac_add_blk_size4 = None
                                                                                    self.pcb_serial_num = None
                                                                                    self.power_supply_type = None
                                                                                    self.power_consumption = None
                                                                                    self.block_signature = None
                                                                                    self.block_version = None
                                                                                    self.block_length = None
                                                                                    self.block_checksum = None
                                                                                    self.eeprom_size = None
                                                                                    self.block_count = None
                                                                                    self.fru_major_type = None
                                                                                    self.fru_minor_type = None
                                                                                    self.oem_string = None
                                                                                    self.product_id = None
                                                                                    self.serial_number = None
                                                                                    self.part_number = None
                                                                                    self.part_revision = None
                                                                                    self.mfg_deviation = None
                                                                                    self.hw_version = None
                                                                                    self.mfg_bits = None
                                                                                    self.engineer_use = None
                                                                                    self.snmpoid = None
                                                                                    self.rma_code = None
                                                                                    self.eci_alpha_number = None

                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._segment_path = lambda: "eeprom"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                                class Rma(_Entity_):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    	**config**\: False
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2018-04-19'

                                                                                    def __init__(self):
                                                                                        if sys.version_info > (3,):
                                                                                            super().__init__()
                                                                                        else:
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                        ])
                                                                                        self.test_history = None
                                                                                        self.rma_number = None
                                                                                        self.rma_history = None
                                                                                        self._segment_path = lambda: "rma"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                                    @staticmethod
                                                                                    def _meta_info():
                                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                                @staticmethod
                                                                                def _meta_info():
                                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes.InvEepromInfo']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6.Attributes']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s.Tsi6']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Tsi6s']['meta_info']


                                                            class Attributes(_Entity_):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"

                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._segment_path = lambda: "attributes"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes, [], name, value)


                                                                class InvBasicBag(_Entity_):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if applicable to this entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: allocated_power
                                                                    
                                                                    	Allocated power for an entity
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_capacity
                                                                    
                                                                    	Power Capacity of a Power Module
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.vendor_type = None
                                                                        self.name = None
                                                                        self.hardware_revision = None
                                                                        self.firmware_revision = None
                                                                        self.software_revision = None
                                                                        self.chip_hardware_revision = None
                                                                        self.serial_number = None
                                                                        self.manufacturer_name = None
                                                                        self.model_name = None
                                                                        self.asset_id_str = None
                                                                        self.asset_identification = None
                                                                        self.is_field_replaceable_unit = None
                                                                        self.manufacturer_asset_tags = None
                                                                        self.composite_class_code = None
                                                                        self.memory_size = None
                                                                        self.environmental_monitor_path = None
                                                                        self.alias = None
                                                                        self.group_flag = None
                                                                        self.new_deviation_number = None
                                                                        self.physical_layer_interface_module_type = None
                                                                        self.unrecognized_fru = None
                                                                        self.redundancystate = None
                                                                        self.ceport = None
                                                                        self.xr_scoped = None
                                                                        self.unique_id = None
                                                                        self.allocated_power = None
                                                                        self.power_capacity = None
                                                                        self._segment_path = lambda: "inv-basic-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvBasicBag']['meta_info']


                                                                class EnvSensorInfo(_Entity_):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: average
                                                                    
                                                                    	Average sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minimum
                                                                    
                                                                    	Minimum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: maximum
                                                                    
                                                                    	Maximum Sensor value over time interval
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: interval
                                                                    
                                                                    	Time Interval over which sensor value is monitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                        ])
                                                                        self.field_validity_bitmap = None
                                                                        self.device_description = None
                                                                        self.units = None
                                                                        self.device_id = None
                                                                        self.value = None
                                                                        self.alarm_type = None
                                                                        self.data_type = None
                                                                        self.scale = None
                                                                        self.precision = None
                                                                        self.status = None
                                                                        self.age_time_stamp = None
                                                                        self.update_rate = None
                                                                        self.average = None
                                                                        self.minimum = None
                                                                        self.maximum = None
                                                                        self.interval = None
                                                                        self._segment_path = lambda: "env-sensor-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfo']['meta_info']


                                                                class PwgInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\: str
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                        ])
                                                                        self.power_group_redundancy_mode = None
                                                                        self.power_group_power_units = None
                                                                        self.power_group_available_current = None
                                                                        self.power_group_drawn_current = None
                                                                        self._segment_path = lambda: "pwg-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.PwgInfo']['meta_info']


                                                                class EnvSensorInfoXml(_Entity_):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                        ])
                                                                        self.description = None
                                                                        self.units = None
                                                                        self.value = None
                                                                        self.data_type = None
                                                                        self.status = None
                                                                        self.update_rate = None

                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                                    class Threshold(_Entity_):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.threshold_array = YList(self)
                                                                            self._segment_path = lambda: "threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                        class ThresholdArray(_Entity_):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_name = None
                                                                                self._segment_path = lambda: "threshold-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.EnvSensorInfoXml']['meta_info']


                                                                class InvAssetBag(_Entity_):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                        ])
                                                                        self.part_number = None
                                                                        self.manufacturer_assembly_number = None
                                                                        self.manufacturer_assembly_revision = None
                                                                        self.manufacturer_firmware_identifier = None
                                                                        self.manufacturer_software_identifier = None
                                                                        self.manufacturer_common_language_equipment_identifier = None
                                                                        self.original_equipment_manufacturer_string = None
                                                                        self._segment_path = lambda: "inv-asset-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvAssetBag']['meta_info']


                                                                class Threshold(_Entity_):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"

                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"

                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._segment_path = lambda: "threshold"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold, [], name, value)


                                                                    class MajorLo(_Entity_):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorLo']['meta_info']


                                                                    class CriticalHi(_Entity_):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalHi']['meta_info']


                                                                    class MinorHi(_Entity_):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorHi']['meta_info']


                                                                    class MajorHi(_Entity_):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "major-hi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MajorHi']['meta_info']


                                                                    class CriticalLo(_Entity_):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "critical-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.CriticalLo']['meta_info']


                                                                    class MinorLo(_Entity_):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                            self._leafs = OrderedDict()

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._segment_path = lambda: "minor-lo"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo, [], name, value)


                                                                        class ThreshBag(_Entity_):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\: bool
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                                ])
                                                                                self.threshold_severity = None
                                                                                self.threshold_relation = None
                                                                                self.threshold_value = None
                                                                                self.threshold_evaluation = None
                                                                                self.threshold_notification_enabled = None
                                                                                self._segment_path = lambda: "thresh-bag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold.MinorLo']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.Threshold']['meta_info']


                                                                class FruInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime))])
                                                                        self._leafs = OrderedDict([
                                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                        ])
                                                                        self.card_administrative_state = None
                                                                        self.power_administrative_state = None
                                                                        self.card_operational_state = None
                                                                        self.card_monitor_state = None
                                                                        self.card_reset_reason = None
                                                                        self.power_current_measurement = None
                                                                        self.power_operational_state = None

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._segment_path = lambda: "fru-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                                    class LastOperationalStateChange(_Entity_):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "last-operational-state-change"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                                    class CardUpTime(_Entity_):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                            ])
                                                                            self.time_in_seconds = None
                                                                            self.time_in_nano_seconds = None
                                                                            self._segment_path = lambda: "card-up-time"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo.CardUpTime']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.FruInfo']['meta_info']


                                                                class InvEepromInfo(_Entity_):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: form_factor
                                                                    
                                                                    	Optics form factor
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: connector_type
                                                                    
                                                                    	Connector type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: otn_application_code
                                                                    
                                                                    	Otn Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: sonet_application_code
                                                                    
                                                                    	Sonet Application Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: ethernet_compliance_code
                                                                    
                                                                    	Ethernet Compliance Code
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: date_string
                                                                    
                                                                    	Date string in IDPROM
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom))])
                                                                        self._leafs = OrderedDict([
                                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                        ])
                                                                        self.inv_card_type = None
                                                                        self.opaque_data = None
                                                                        self.opaque_data_size = None
                                                                        self.has_eeprom = None
                                                                        self.description = None
                                                                        self.form_factor = None
                                                                        self.connector_type = None
                                                                        self.otn_application_code = None
                                                                        self.sonet_application_code = None
                                                                        self.ethernet_compliance_code = None
                                                                        self.date_string = None

                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                                    class Eeprom(_Entity_):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        .. attribute:: eci_alpha_number
                                                                        
                                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        	**config**\: False
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2018-04-19'

                                                                        def __init__(self):
                                                                            if sys.version_info > (3,):
                                                                                super().__init__()
                                                                            else:
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                            self._leafs = OrderedDict([
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                            ])
                                                                            self.description = None
                                                                            self.idprom_format_rev = None
                                                                            self.controller_family = None
                                                                            self.controller_type = None
                                                                            self.vid = None
                                                                            self.hwid = None
                                                                            self.pid = None
                                                                            self.udi_description = None
                                                                            self.udi_name = None
                                                                            self.clei = None
                                                                            self.eci = None
                                                                            self.top_assem_part_num = None
                                                                            self.top_assem_vid = None
                                                                            self.pca_num = None
                                                                            self.pcavid = None
                                                                            self.chassis_sid = None
                                                                            self.dev_num1 = None
                                                                            self.dev_num2 = None
                                                                            self.dev_num3 = None
                                                                            self.dev_num4 = None
                                                                            self.dev_num5 = None
                                                                            self.dev_num6 = None
                                                                            self.dev_num7 = None
                                                                            self.manu_test_data = None
                                                                            self.asset_id = None
                                                                            self.asset_alias = None
                                                                            self.base_mac_address1 = None
                                                                            self.mac_add_blk_size1 = None
                                                                            self.base_mac_address2 = None
                                                                            self.mac_add_blk_size2 = None
                                                                            self.base_mac_address3 = None
                                                                            self.mac_add_blk_size3 = None
                                                                            self.base_mac_address4 = None
                                                                            self.mac_add_blk_size4 = None
                                                                            self.pcb_serial_num = None
                                                                            self.power_supply_type = None
                                                                            self.power_consumption = None
                                                                            self.block_signature = None
                                                                            self.block_version = None
                                                                            self.block_length = None
                                                                            self.block_checksum = None
                                                                            self.eeprom_size = None
                                                                            self.block_count = None
                                                                            self.fru_major_type = None
                                                                            self.fru_minor_type = None
                                                                            self.oem_string = None
                                                                            self.product_id = None
                                                                            self.serial_number = None
                                                                            self.part_number = None
                                                                            self.part_revision = None
                                                                            self.mfg_deviation = None
                                                                            self.hw_version = None
                                                                            self.mfg_bits = None
                                                                            self.engineer_use = None
                                                                            self.snmpoid = None
                                                                            self.rma_code = None
                                                                            self.eci_alpha_number = None

                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._segment_path = lambda: "eeprom"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                        class Rma(_Entity_):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            	**config**\: False
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2018-04-19'

                                                                            def __init__(self):
                                                                                if sys.version_info > (3,):
                                                                                    super().__init__()
                                                                                else:
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                                ])
                                                                                self.test_history = None
                                                                                self.rma_number = None
                                                                                self.rma_history = None
                                                                                self._segment_path = lambda: "rma"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                            @staticmethod
                                                                            def _meta_info():
                                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                        @staticmethod
                                                                        def _meta_info():
                                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes.InvEepromInfo']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5.Attributes']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s.Tsi5']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Tsi5s']['meta_info']


                                                    class Attributes(_Entity_):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo))])
                                                            self._leafs = OrderedDict()

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"

                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._segment_path = lambda: "attributes"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes, [], name, value)


                                                        class InvBasicBag(_Entity_):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if applicable to this entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: allocated_power
                                                            
                                                            	Allocated power for an entity
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_capacity
                                                            
                                                            	Power Capacity of a Power Module
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.vendor_type = None
                                                                self.name = None
                                                                self.hardware_revision = None
                                                                self.firmware_revision = None
                                                                self.software_revision = None
                                                                self.chip_hardware_revision = None
                                                                self.serial_number = None
                                                                self.manufacturer_name = None
                                                                self.model_name = None
                                                                self.asset_id_str = None
                                                                self.asset_identification = None
                                                                self.is_field_replaceable_unit = None
                                                                self.manufacturer_asset_tags = None
                                                                self.composite_class_code = None
                                                                self.memory_size = None
                                                                self.environmental_monitor_path = None
                                                                self.alias = None
                                                                self.group_flag = None
                                                                self.new_deviation_number = None
                                                                self.physical_layer_interface_module_type = None
                                                                self.unrecognized_fru = None
                                                                self.redundancystate = None
                                                                self.ceport = None
                                                                self.xr_scoped = None
                                                                self.unique_id = None
                                                                self.allocated_power = None
                                                                self.power_capacity = None
                                                                self._segment_path = lambda: "inv-basic-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvBasicBag']['meta_info']


                                                        class EnvSensorInfo(_Entity_):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: average
                                                            
                                                            	Average sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minimum
                                                            
                                                            	Minimum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: maximum
                                                            
                                                            	Maximum Sensor value over time interval
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: interval
                                                            
                                                            	Time Interval over which sensor value is monitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                                ])
                                                                self.field_validity_bitmap = None
                                                                self.device_description = None
                                                                self.units = None
                                                                self.device_id = None
                                                                self.value = None
                                                                self.alarm_type = None
                                                                self.data_type = None
                                                                self.scale = None
                                                                self.precision = None
                                                                self.status = None
                                                                self.age_time_stamp = None
                                                                self.update_rate = None
                                                                self.average = None
                                                                self.minimum = None
                                                                self.maximum = None
                                                                self.interval = None
                                                                self._segment_path = lambda: "env-sensor-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfo']['meta_info']


                                                        class PwgInfo(_Entity_):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\: str
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                                ])
                                                                self.power_group_redundancy_mode = None
                                                                self.power_group_power_units = None
                                                                self.power_group_available_current = None
                                                                self.power_group_drawn_current = None
                                                                self._segment_path = lambda: "pwg-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.PwgInfo']['meta_info']


                                                        class EnvSensorInfoXml(_Entity_):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold))])
                                                                self._leafs = OrderedDict([
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                                ])
                                                                self.description = None
                                                                self.units = None
                                                                self.value = None
                                                                self.data_type = None
                                                                self.status = None
                                                                self.update_rate = None

                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                            class Threshold(_Entity_):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.threshold_array = YList(self)
                                                                    self._segment_path = lambda: "threshold"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                                class ThresholdArray(_Entity_):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_name = None
                                                                        self._segment_path = lambda: "threshold-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.EnvSensorInfoXml']['meta_info']


                                                        class InvAssetBag(_Entity_):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                                ])
                                                                self.part_number = None
                                                                self.manufacturer_assembly_number = None
                                                                self.manufacturer_assembly_revision = None
                                                                self.manufacturer_firmware_identifier = None
                                                                self.manufacturer_software_identifier = None
                                                                self.manufacturer_common_language_equipment_identifier = None
                                                                self.original_equipment_manufacturer_string = None
                                                                self._segment_path = lambda: "inv-asset-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvAssetBag']['meta_info']


                                                        class Threshold(_Entity_):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo))])
                                                                self._leafs = OrderedDict()

                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"

                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"

                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._segment_path = lambda: "threshold"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold, [], name, value)


                                                            class MajorLo(_Entity_):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorLo']['meta_info']


                                                            class CriticalHi(_Entity_):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalHi']['meta_info']


                                                            class MinorHi(_Entity_):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorHi']['meta_info']


                                                            class MajorHi(_Entity_):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "major-hi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MajorHi']['meta_info']


                                                            class CriticalLo(_Entity_):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "critical-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.CriticalLo']['meta_info']


                                                            class MinorLo(_Entity_):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag))])
                                                                    self._leafs = OrderedDict()

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._segment_path = lambda: "minor-lo"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo, [], name, value)


                                                                class ThreshBag(_Entity_):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\: bool
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                        ])
                                                                        self.threshold_severity = None
                                                                        self.threshold_relation = None
                                                                        self.threshold_value = None
                                                                        self.threshold_evaluation = None
                                                                        self.threshold_notification_enabled = None
                                                                        self._segment_path = lambda: "thresh-bag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold.MinorLo']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.Threshold']['meta_info']


                                                        class FruInfo(_Entity_):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime))])
                                                                self._leafs = OrderedDict([
                                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                                ])
                                                                self.card_administrative_state = None
                                                                self.power_administrative_state = None
                                                                self.card_operational_state = None
                                                                self.card_monitor_state = None
                                                                self.card_reset_reason = None
                                                                self.power_current_measurement = None
                                                                self.power_operational_state = None

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._segment_path = lambda: "fru-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                            class LastOperationalStateChange(_Entity_):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "last-operational-state-change"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                            class CardUpTime(_Entity_):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\: int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**config**\: False
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                                    ])
                                                                    self.time_in_seconds = None
                                                                    self.time_in_nano_seconds = None
                                                                    self._segment_path = lambda: "card-up-time"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo.CardUpTime']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.FruInfo']['meta_info']


                                                        class InvEepromInfo(_Entity_):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\: str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: form_factor
                                                            
                                                            	Optics form factor
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: connector_type
                                                            
                                                            	Connector type
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: otn_application_code
                                                            
                                                            	Otn Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: sonet_application_code
                                                            
                                                            	Sonet Application Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: ethernet_compliance_code
                                                            
                                                            	Ethernet Compliance Code
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: date_string
                                                            
                                                            	Date string in IDPROM
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom))])
                                                                self._leafs = OrderedDict([
                                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                                ])
                                                                self.inv_card_type = None
                                                                self.opaque_data = None
                                                                self.opaque_data_size = None
                                                                self.has_eeprom = None
                                                                self.description = None
                                                                self.form_factor = None
                                                                self.connector_type = None
                                                                self.otn_application_code = None
                                                                self.sonet_application_code = None
                                                                self.ethernet_compliance_code = None
                                                                self.date_string = None

                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._segment_path = lambda: "inv-eeprom-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                            class Eeprom(_Entity_):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                .. attribute:: eci_alpha_number
                                                                
                                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                	**config**\: False
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2018-04-19'

                                                                def __init__(self):
                                                                    if sys.version_info > (3,):
                                                                        super().__init__()
                                                                    else:
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                                    self._leafs = OrderedDict([
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                                    ])
                                                                    self.description = None
                                                                    self.idprom_format_rev = None
                                                                    self.controller_family = None
                                                                    self.controller_type = None
                                                                    self.vid = None
                                                                    self.hwid = None
                                                                    self.pid = None
                                                                    self.udi_description = None
                                                                    self.udi_name = None
                                                                    self.clei = None
                                                                    self.eci = None
                                                                    self.top_assem_part_num = None
                                                                    self.top_assem_vid = None
                                                                    self.pca_num = None
                                                                    self.pcavid = None
                                                                    self.chassis_sid = None
                                                                    self.dev_num1 = None
                                                                    self.dev_num2 = None
                                                                    self.dev_num3 = None
                                                                    self.dev_num4 = None
                                                                    self.dev_num5 = None
                                                                    self.dev_num6 = None
                                                                    self.dev_num7 = None
                                                                    self.manu_test_data = None
                                                                    self.asset_id = None
                                                                    self.asset_alias = None
                                                                    self.base_mac_address1 = None
                                                                    self.mac_add_blk_size1 = None
                                                                    self.base_mac_address2 = None
                                                                    self.mac_add_blk_size2 = None
                                                                    self.base_mac_address3 = None
                                                                    self.mac_add_blk_size3 = None
                                                                    self.base_mac_address4 = None
                                                                    self.mac_add_blk_size4 = None
                                                                    self.pcb_serial_num = None
                                                                    self.power_supply_type = None
                                                                    self.power_consumption = None
                                                                    self.block_signature = None
                                                                    self.block_version = None
                                                                    self.block_length = None
                                                                    self.block_checksum = None
                                                                    self.eeprom_size = None
                                                                    self.block_count = None
                                                                    self.fru_major_type = None
                                                                    self.fru_minor_type = None
                                                                    self.oem_string = None
                                                                    self.product_id = None
                                                                    self.serial_number = None
                                                                    self.part_number = None
                                                                    self.part_revision = None
                                                                    self.mfg_deviation = None
                                                                    self.hw_version = None
                                                                    self.mfg_bits = None
                                                                    self.engineer_use = None
                                                                    self.snmpoid = None
                                                                    self.rma_code = None
                                                                    self.eci_alpha_number = None

                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._segment_path = lambda: "eeprom"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                                class Rma(_Entity_):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    	**config**\: False
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2018-04-19'

                                                                    def __init__(self):
                                                                        if sys.version_info > (3,):
                                                                            super().__init__()
                                                                        else:
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                        ])
                                                                        self.test_history = None
                                                                        self.rma_number = None
                                                                        self.rma_history = None
                                                                        self._segment_path = lambda: "rma"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                                    @staticmethod
                                                                    def _meta_info():
                                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                                @staticmethod
                                                                def _meta_info():
                                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes.InvEepromInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4.Attributes']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s.Tsi4']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Tsi4s']['meta_info']


                                            class Attributes(_Entity_):
                                                """
                                                Attributes
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo))])
                                                    self._leafs = OrderedDict()

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"

                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._segment_path = lambda: "attributes"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes, [], name, value)


                                                class InvBasicBag(_Entity_):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if applicable to this entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: allocated_power
                                                    
                                                    	Allocated power for an entity
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_capacity
                                                    
                                                    	Power Capacity of a Power Module
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.vendor_type = None
                                                        self.name = None
                                                        self.hardware_revision = None
                                                        self.firmware_revision = None
                                                        self.software_revision = None
                                                        self.chip_hardware_revision = None
                                                        self.serial_number = None
                                                        self.manufacturer_name = None
                                                        self.model_name = None
                                                        self.asset_id_str = None
                                                        self.asset_identification = None
                                                        self.is_field_replaceable_unit = None
                                                        self.manufacturer_asset_tags = None
                                                        self.composite_class_code = None
                                                        self.memory_size = None
                                                        self.environmental_monitor_path = None
                                                        self.alias = None
                                                        self.group_flag = None
                                                        self.new_deviation_number = None
                                                        self.physical_layer_interface_module_type = None
                                                        self.unrecognized_fru = None
                                                        self.redundancystate = None
                                                        self.ceport = None
                                                        self.xr_scoped = None
                                                        self.unique_id = None
                                                        self.allocated_power = None
                                                        self.power_capacity = None
                                                        self._segment_path = lambda: "inv-basic-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvBasicBag']['meta_info']


                                                class EnvSensorInfo(_Entity_):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: average
                                                    
                                                    	Average sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minimum
                                                    
                                                    	Minimum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: maximum
                                                    
                                                    	Maximum Sensor value over time interval
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interval
                                                    
                                                    	Time Interval over which sensor value is monitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                        ])
                                                        self.field_validity_bitmap = None
                                                        self.device_description = None
                                                        self.units = None
                                                        self.device_id = None
                                                        self.value = None
                                                        self.alarm_type = None
                                                        self.data_type = None
                                                        self.scale = None
                                                        self.precision = None
                                                        self.status = None
                                                        self.age_time_stamp = None
                                                        self.update_rate = None
                                                        self.average = None
                                                        self.minimum = None
                                                        self.maximum = None
                                                        self.interval = None
                                                        self._segment_path = lambda: "env-sensor-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfo']['meta_info']


                                                class PwgInfo(_Entity_):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                        ])
                                                        self.power_group_redundancy_mode = None
                                                        self.power_group_power_units = None
                                                        self.power_group_available_current = None
                                                        self.power_group_drawn_current = None
                                                        self._segment_path = lambda: "pwg-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.PwgInfo']['meta_info']


                                                class EnvSensorInfoXml(_Entity_):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold))])
                                                        self._leafs = OrderedDict([
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                        ])
                                                        self.description = None
                                                        self.units = None
                                                        self.value = None
                                                        self.data_type = None
                                                        self.status = None
                                                        self.update_rate = None

                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._segment_path = lambda: "env-sensor-info-xml"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                                    class Threshold(_Entity_):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                            self._leafs = OrderedDict()

                                                            self.threshold_array = YList(self)
                                                            self._segment_path = lambda: "threshold"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                        class ThresholdArray(_Entity_):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_name = None
                                                                self._segment_path = lambda: "threshold-array"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.EnvSensorInfoXml']['meta_info']


                                                class InvAssetBag(_Entity_):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                        ])
                                                        self.part_number = None
                                                        self.manufacturer_assembly_number = None
                                                        self.manufacturer_assembly_revision = None
                                                        self.manufacturer_firmware_identifier = None
                                                        self.manufacturer_software_identifier = None
                                                        self.manufacturer_common_language_equipment_identifier = None
                                                        self.original_equipment_manufacturer_string = None
                                                        self._segment_path = lambda: "inv-asset-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvAssetBag']['meta_info']


                                                class Threshold(_Entity_):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo))])
                                                        self._leafs = OrderedDict()

                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"

                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"

                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"

                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"

                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"

                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._segment_path = lambda: "threshold"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold, [], name, value)


                                                    class MajorLo(_Entity_):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorLo']['meta_info']


                                                    class CriticalHi(_Entity_):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalHi']['meta_info']


                                                    class MinorHi(_Entity_):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorHi']['meta_info']


                                                    class MajorHi(_Entity_):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "major-hi"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MajorHi']['meta_info']


                                                    class CriticalLo(_Entity_):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "critical-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.CriticalLo']['meta_info']


                                                    class MinorLo(_Entity_):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag))])
                                                            self._leafs = OrderedDict()

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._segment_path = lambda: "minor-lo"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo, [], name, value)


                                                        class ThreshBag(_Entity_):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\: bool
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                                ])
                                                                self.threshold_severity = None
                                                                self.threshold_relation = None
                                                                self.threshold_value = None
                                                                self.threshold_evaluation = None
                                                                self.threshold_notification_enabled = None
                                                                self._segment_path = lambda: "thresh-bag"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold.MinorLo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.Threshold']['meta_info']


                                                class FruInfo(_Entity_):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime))])
                                                        self._leafs = OrderedDict([
                                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                        ])
                                                        self.card_administrative_state = None
                                                        self.power_administrative_state = None
                                                        self.card_operational_state = None
                                                        self.card_monitor_state = None
                                                        self.card_reset_reason = None
                                                        self.power_current_measurement = None
                                                        self.power_operational_state = None

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._segment_path = lambda: "fru-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                                    class LastOperationalStateChange(_Entity_):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "last-operational-state-change"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                                    class CardUpTime(_Entity_):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: second
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\: int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**config**\: False
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                            ])
                                                            self.time_in_seconds = None
                                                            self.time_in_nano_seconds = None
                                                            self._segment_path = lambda: "card-up-time"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo.CardUpTime']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.FruInfo']['meta_info']


                                                class InvEepromInfo(_Entity_):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: form_factor
                                                    
                                                    	Optics form factor
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: connector_type
                                                    
                                                    	Connector type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: otn_application_code
                                                    
                                                    	Otn Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: sonet_application_code
                                                    
                                                    	Sonet Application Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ethernet_compliance_code
                                                    
                                                    	Ethernet Compliance Code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: date_string
                                                    
                                                    	Date string in IDPROM
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom))])
                                                        self._leafs = OrderedDict([
                                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                        ])
                                                        self.inv_card_type = None
                                                        self.opaque_data = None
                                                        self.opaque_data_size = None
                                                        self.has_eeprom = None
                                                        self.description = None
                                                        self.form_factor = None
                                                        self.connector_type = None
                                                        self.otn_application_code = None
                                                        self.sonet_application_code = None
                                                        self.ethernet_compliance_code = None
                                                        self.date_string = None

                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._segment_path = lambda: "inv-eeprom-info"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                                    class Eeprom(_Entity_):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: eci_alpha_number
                                                        
                                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2018-04-19'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                            self._leafs = OrderedDict([
                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                            ])
                                                            self.description = None
                                                            self.idprom_format_rev = None
                                                            self.controller_family = None
                                                            self.controller_type = None
                                                            self.vid = None
                                                            self.hwid = None
                                                            self.pid = None
                                                            self.udi_description = None
                                                            self.udi_name = None
                                                            self.clei = None
                                                            self.eci = None
                                                            self.top_assem_part_num = None
                                                            self.top_assem_vid = None
                                                            self.pca_num = None
                                                            self.pcavid = None
                                                            self.chassis_sid = None
                                                            self.dev_num1 = None
                                                            self.dev_num2 = None
                                                            self.dev_num3 = None
                                                            self.dev_num4 = None
                                                            self.dev_num5 = None
                                                            self.dev_num6 = None
                                                            self.dev_num7 = None
                                                            self.manu_test_data = None
                                                            self.asset_id = None
                                                            self.asset_alias = None
                                                            self.base_mac_address1 = None
                                                            self.mac_add_blk_size1 = None
                                                            self.base_mac_address2 = None
                                                            self.mac_add_blk_size2 = None
                                                            self.base_mac_address3 = None
                                                            self.mac_add_blk_size3 = None
                                                            self.base_mac_address4 = None
                                                            self.mac_add_blk_size4 = None
                                                            self.pcb_serial_num = None
                                                            self.power_supply_type = None
                                                            self.power_consumption = None
                                                            self.block_signature = None
                                                            self.block_version = None
                                                            self.block_length = None
                                                            self.block_checksum = None
                                                            self.eeprom_size = None
                                                            self.block_count = None
                                                            self.fru_major_type = None
                                                            self.fru_minor_type = None
                                                            self.oem_string = None
                                                            self.product_id = None
                                                            self.serial_number = None
                                                            self.part_number = None
                                                            self.part_revision = None
                                                            self.mfg_deviation = None
                                                            self.hw_version = None
                                                            self.mfg_bits = None
                                                            self.engineer_use = None
                                                            self.snmpoid = None
                                                            self.rma_code = None
                                                            self.eci_alpha_number = None

                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._segment_path = lambda: "eeprom"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                        class Rma(_Entity_):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2018-04-19'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                                ])
                                                                self.test_history = None
                                                                self.rma_number = None
                                                                self.rma_history = None
                                                                self._segment_path = lambda: "rma"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes.InvEepromInfo']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3.Attributes']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s.Tsi3']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Tsi3s']['meta_info']


                                    class Attributes(_Entity_):
                                        """
                                        Attributes
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo))])
                                            self._leafs = OrderedDict()

                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"

                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._segment_path = lambda: "attributes"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes, [], name, value)


                                        class InvBasicBag(_Entity_):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if applicable to this entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: allocated_power
                                            
                                            	Allocated power for an entity
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_capacity
                                            
                                            	Power Capacity of a Power Module
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                                ])
                                                self.description = None
                                                self.vendor_type = None
                                                self.name = None
                                                self.hardware_revision = None
                                                self.firmware_revision = None
                                                self.software_revision = None
                                                self.chip_hardware_revision = None
                                                self.serial_number = None
                                                self.manufacturer_name = None
                                                self.model_name = None
                                                self.asset_id_str = None
                                                self.asset_identification = None
                                                self.is_field_replaceable_unit = None
                                                self.manufacturer_asset_tags = None
                                                self.composite_class_code = None
                                                self.memory_size = None
                                                self.environmental_monitor_path = None
                                                self.alias = None
                                                self.group_flag = None
                                                self.new_deviation_number = None
                                                self.physical_layer_interface_module_type = None
                                                self.unrecognized_fru = None
                                                self.redundancystate = None
                                                self.ceport = None
                                                self.xr_scoped = None
                                                self.unique_id = None
                                                self.allocated_power = None
                                                self.power_capacity = None
                                                self._segment_path = lambda: "inv-basic-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvBasicBag']['meta_info']


                                        class EnvSensorInfo(_Entity_):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: average
                                            
                                            	Average sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minimum
                                            
                                            	Minimum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: maximum
                                            
                                            	Maximum Sensor value over time interval
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: interval
                                            
                                            	Time Interval over which sensor value is monitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                                ])
                                                self.field_validity_bitmap = None
                                                self.device_description = None
                                                self.units = None
                                                self.device_id = None
                                                self.value = None
                                                self.alarm_type = None
                                                self.data_type = None
                                                self.scale = None
                                                self.precision = None
                                                self.status = None
                                                self.age_time_stamp = None
                                                self.update_rate = None
                                                self.average = None
                                                self.minimum = None
                                                self.maximum = None
                                                self.interval = None
                                                self._segment_path = lambda: "env-sensor-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfo']['meta_info']


                                        class PwgInfo(_Entity_):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                                ])
                                                self.power_group_redundancy_mode = None
                                                self.power_group_power_units = None
                                                self.power_group_available_current = None
                                                self.power_group_drawn_current = None
                                                self._segment_path = lambda: "pwg-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.PwgInfo']['meta_info']


                                        class EnvSensorInfoXml(_Entity_):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold))])
                                                self._leafs = OrderedDict([
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                                ])
                                                self.description = None
                                                self.units = None
                                                self.value = None
                                                self.data_type = None
                                                self.status = None
                                                self.update_rate = None

                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._segment_path = lambda: "env-sensor-info-xml"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                            class Threshold(_Entity_):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                                    self._leafs = OrderedDict()

                                                    self.threshold_array = YList(self)
                                                    self._segment_path = lambda: "threshold"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                                class ThresholdArray(_Entity_):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_name = None
                                                        self._segment_path = lambda: "threshold-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.EnvSensorInfoXml']['meta_info']


                                        class InvAssetBag(_Entity_):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                                ])
                                                self.part_number = None
                                                self.manufacturer_assembly_number = None
                                                self.manufacturer_assembly_revision = None
                                                self.manufacturer_firmware_identifier = None
                                                self.manufacturer_software_identifier = None
                                                self.manufacturer_common_language_equipment_identifier = None
                                                self.original_equipment_manufacturer_string = None
                                                self._segment_path = lambda: "inv-asset-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvAssetBag']['meta_info']


                                        class Threshold(_Entity_):
                                            """
                                            Threshold
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo))])
                                                self._leafs = OrderedDict()

                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"

                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"

                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"

                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"

                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"

                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._segment_path = lambda: "threshold"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold, [], name, value)


                                            class MajorLo(_Entity_):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorLo']['meta_info']


                                            class CriticalHi(_Entity_):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalHi']['meta_info']


                                            class MinorHi(_Entity_):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorHi']['meta_info']


                                            class MajorHi(_Entity_):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "major-hi"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MajorHi']['meta_info']


                                            class CriticalLo(_Entity_):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "critical-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.CriticalLo']['meta_info']


                                            class MinorLo(_Entity_):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag))])
                                                    self._leafs = OrderedDict()

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._segment_path = lambda: "minor-lo"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo, [], name, value)


                                                class ThreshBag(_Entity_):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                        ])
                                                        self.threshold_severity = None
                                                        self.threshold_relation = None
                                                        self.threshold_value = None
                                                        self.threshold_evaluation = None
                                                        self.threshold_notification_enabled = None
                                                        self._segment_path = lambda: "thresh-bag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold.MinorLo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.Threshold']['meta_info']


                                        class FruInfo(_Entity_):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime))])
                                                self._leafs = OrderedDict([
                                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                                ])
                                                self.card_administrative_state = None
                                                self.power_administrative_state = None
                                                self.card_operational_state = None
                                                self.card_monitor_state = None
                                                self.card_reset_reason = None
                                                self.power_current_measurement = None
                                                self.power_operational_state = None

                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._segment_path = lambda: "fru-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                            class LastOperationalStateChange(_Entity_):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "last-operational-state-change"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                            class CardUpTime(_Entity_):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\: int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**config**\: False
                                                
                                                	**units**\: nanosecond
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                                    ])
                                                    self.time_in_seconds = None
                                                    self.time_in_nano_seconds = None
                                                    self._segment_path = lambda: "card-up-time"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo.CardUpTime']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.FruInfo']['meta_info']


                                        class InvEepromInfo(_Entity_):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\: str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: form_factor
                                            
                                            	Optics form factor
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: connector_type
                                            
                                            	Connector type
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: otn_application_code
                                            
                                            	Otn Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: sonet_application_code
                                            
                                            	Sonet Application Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ethernet_compliance_code
                                            
                                            	Ethernet Compliance Code
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: date_string
                                            
                                            	Date string in IDPROM
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom))])
                                                self._leafs = OrderedDict([
                                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                                ])
                                                self.inv_card_type = None
                                                self.opaque_data = None
                                                self.opaque_data_size = None
                                                self.has_eeprom = None
                                                self.description = None
                                                self.form_factor = None
                                                self.connector_type = None
                                                self.otn_application_code = None
                                                self.sonet_application_code = None
                                                self.ethernet_compliance_code = None
                                                self.date_string = None

                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._segment_path = lambda: "inv-eeprom-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                            class Eeprom(_Entity_):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: eci_alpha_number
                                                
                                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                                	**type**\: str
                                                
                                                	**length:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2018-04-19'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma))])
                                                    self._leafs = OrderedDict([
                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                                    ])
                                                    self.description = None
                                                    self.idprom_format_rev = None
                                                    self.controller_family = None
                                                    self.controller_type = None
                                                    self.vid = None
                                                    self.hwid = None
                                                    self.pid = None
                                                    self.udi_description = None
                                                    self.udi_name = None
                                                    self.clei = None
                                                    self.eci = None
                                                    self.top_assem_part_num = None
                                                    self.top_assem_vid = None
                                                    self.pca_num = None
                                                    self.pcavid = None
                                                    self.chassis_sid = None
                                                    self.dev_num1 = None
                                                    self.dev_num2 = None
                                                    self.dev_num3 = None
                                                    self.dev_num4 = None
                                                    self.dev_num5 = None
                                                    self.dev_num6 = None
                                                    self.dev_num7 = None
                                                    self.manu_test_data = None
                                                    self.asset_id = None
                                                    self.asset_alias = None
                                                    self.base_mac_address1 = None
                                                    self.mac_add_blk_size1 = None
                                                    self.base_mac_address2 = None
                                                    self.mac_add_blk_size2 = None
                                                    self.base_mac_address3 = None
                                                    self.mac_add_blk_size3 = None
                                                    self.base_mac_address4 = None
                                                    self.mac_add_blk_size4 = None
                                                    self.pcb_serial_num = None
                                                    self.power_supply_type = None
                                                    self.power_consumption = None
                                                    self.block_signature = None
                                                    self.block_version = None
                                                    self.block_length = None
                                                    self.block_checksum = None
                                                    self.eeprom_size = None
                                                    self.block_count = None
                                                    self.fru_major_type = None
                                                    self.fru_minor_type = None
                                                    self.oem_string = None
                                                    self.product_id = None
                                                    self.serial_number = None
                                                    self.part_number = None
                                                    self.part_revision = None
                                                    self.mfg_deviation = None
                                                    self.hw_version = None
                                                    self.mfg_bits = None
                                                    self.engineer_use = None
                                                    self.snmpoid = None
                                                    self.rma_code = None
                                                    self.eci_alpha_number = None

                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._segment_path = lambda: "eeprom"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                                class Rma(_Entity_):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2018-04-19'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                        ])
                                                        self.test_history = None
                                                        self.rma_number = None
                                                        self.rma_history = None
                                                        self._segment_path = lambda: "rma"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes.InvEepromInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2.Attributes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s.Tsi2']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Tsi2s']['meta_info']


                            class Attributes(_Entity_):
                                """
                                Attributes
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold>`
                                
                                	**config**\: False
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo))])
                                    self._leafs = OrderedDict()

                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"

                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._segment_path = lambda: "attributes"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes, [], name, value)


                                class InvBasicBag(_Entity_):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if applicable to this entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: allocated_power
                                    
                                    	Allocated power for an entity
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_capacity
                                    
                                    	Power Capacity of a Power Module
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                        ])
                                        self.description = None
                                        self.vendor_type = None
                                        self.name = None
                                        self.hardware_revision = None
                                        self.firmware_revision = None
                                        self.software_revision = None
                                        self.chip_hardware_revision = None
                                        self.serial_number = None
                                        self.manufacturer_name = None
                                        self.model_name = None
                                        self.asset_id_str = None
                                        self.asset_identification = None
                                        self.is_field_replaceable_unit = None
                                        self.manufacturer_asset_tags = None
                                        self.composite_class_code = None
                                        self.memory_size = None
                                        self.environmental_monitor_path = None
                                        self.alias = None
                                        self.group_flag = None
                                        self.new_deviation_number = None
                                        self.physical_layer_interface_module_type = None
                                        self.unrecognized_fru = None
                                        self.redundancystate = None
                                        self.ceport = None
                                        self.xr_scoped = None
                                        self.unique_id = None
                                        self.allocated_power = None
                                        self.power_capacity = None
                                        self._segment_path = lambda: "inv-basic-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvBasicBag']['meta_info']


                                class EnvSensorInfo(_Entity_):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: average
                                    
                                    	Average sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minimum
                                    
                                    	Minimum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: maximum
                                    
                                    	Maximum Sensor value over time interval
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interval
                                    
                                    	Time Interval over which sensor value is monitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                        ])
                                        self.field_validity_bitmap = None
                                        self.device_description = None
                                        self.units = None
                                        self.device_id = None
                                        self.value = None
                                        self.alarm_type = None
                                        self.data_type = None
                                        self.scale = None
                                        self.precision = None
                                        self.status = None
                                        self.age_time_stamp = None
                                        self.update_rate = None
                                        self.average = None
                                        self.minimum = None
                                        self.maximum = None
                                        self.interval = None
                                        self._segment_path = lambda: "env-sensor-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfo']['meta_info']


                                class PwgInfo(_Entity_):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                        ])
                                        self.power_group_redundancy_mode = None
                                        self.power_group_power_units = None
                                        self.power_group_available_current = None
                                        self.power_group_drawn_current = None
                                        self._segment_path = lambda: "pwg-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.PwgInfo']['meta_info']


                                class EnvSensorInfoXml(_Entity_):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold))])
                                        self._leafs = OrderedDict([
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                        ])
                                        self.description = None
                                        self.units = None
                                        self.value = None
                                        self.data_type = None
                                        self.status = None
                                        self.update_rate = None

                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._segment_path = lambda: "env-sensor-info-xml"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                                    class Threshold(_Entity_):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                            self._leafs = OrderedDict()

                                            self.threshold_array = YList(self)
                                            self._segment_path = lambda: "threshold"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                        class ThresholdArray(_Entity_):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\: str
                                            
                                            	**length:** 0..50
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_name = None
                                                self._segment_path = lambda: "threshold-array"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.EnvSensorInfoXml']['meta_info']


                                class InvAssetBag(_Entity_):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                        ])
                                        self.part_number = None
                                        self.manufacturer_assembly_number = None
                                        self.manufacturer_assembly_revision = None
                                        self.manufacturer_firmware_identifier = None
                                        self.manufacturer_software_identifier = None
                                        self.manufacturer_common_language_equipment_identifier = None
                                        self.original_equipment_manufacturer_string = None
                                        self._segment_path = lambda: "inv-asset-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvAssetBag']['meta_info']


                                class Threshold(_Entity_):
                                    """
                                    Threshold
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo))])
                                        self._leafs = OrderedDict()

                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"

                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"

                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"

                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"

                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"

                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._segment_path = lambda: "threshold"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold, [], name, value)


                                    class MajorLo(_Entity_):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorLo']['meta_info']


                                    class CriticalHi(_Entity_):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalHi']['meta_info']


                                    class MinorHi(_Entity_):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorHi']['meta_info']


                                    class MajorHi(_Entity_):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "major-hi"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MajorHi']['meta_info']


                                    class CriticalLo(_Entity_):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "critical-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.CriticalLo']['meta_info']


                                    class MinorLo(_Entity_):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag))])
                                            self._leafs = OrderedDict()

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._segment_path = lambda: "minor-lo"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo, [], name, value)


                                        class ThreshBag(_Entity_):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                                ])
                                                self.threshold_severity = None
                                                self.threshold_relation = None
                                                self.threshold_value = None
                                                self.threshold_evaluation = None
                                                self.threshold_notification_enabled = None
                                                self._segment_path = lambda: "thresh-bag"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold.MinorLo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.Threshold']['meta_info']


                                class FruInfo(_Entity_):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime))])
                                        self._leafs = OrderedDict([
                                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                        ])
                                        self.card_administrative_state = None
                                        self.power_administrative_state = None
                                        self.card_operational_state = None
                                        self.card_monitor_state = None
                                        self.card_reset_reason = None
                                        self.power_current_measurement = None
                                        self.power_operational_state = None

                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._segment_path = lambda: "fru-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                                    class LastOperationalStateChange(_Entity_):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "last-operational-state-change"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                                    class CardUpTime(_Entity_):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**config**\: False
                                        
                                        	**units**\: nanosecond
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                            ])
                                            self.time_in_seconds = None
                                            self.time_in_nano_seconds = None
                                            self._segment_path = lambda: "card-up-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo.CardUpTime']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.FruInfo']['meta_info']


                                class InvEepromInfo(_Entity_):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\: str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: form_factor
                                    
                                    	Optics form factor
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connector_type
                                    
                                    	Connector type
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn_application_code
                                    
                                    	Otn Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: sonet_application_code
                                    
                                    	Sonet Application Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ethernet_compliance_code
                                    
                                    	Ethernet Compliance Code
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: date_string
                                    
                                    	Date string in IDPROM
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom))])
                                        self._leafs = OrderedDict([
                                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                        ])
                                        self.inv_card_type = None
                                        self.opaque_data = None
                                        self.opaque_data_size = None
                                        self.has_eeprom = None
                                        self.description = None
                                        self.form_factor = None
                                        self.connector_type = None
                                        self.otn_application_code = None
                                        self.sonet_application_code = None
                                        self.ethernet_compliance_code = None
                                        self.date_string = None

                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._segment_path = lambda: "inv-eeprom-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                                    class Eeprom(_Entity_):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: eci_alpha_number
                                        
                                        	AlphaNumeric Equipment Catalog Item (ECI) number
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2018-04-19'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma))])
                                            self._leafs = OrderedDict([
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                            ])
                                            self.description = None
                                            self.idprom_format_rev = None
                                            self.controller_family = None
                                            self.controller_type = None
                                            self.vid = None
                                            self.hwid = None
                                            self.pid = None
                                            self.udi_description = None
                                            self.udi_name = None
                                            self.clei = None
                                            self.eci = None
                                            self.top_assem_part_num = None
                                            self.top_assem_vid = None
                                            self.pca_num = None
                                            self.pcavid = None
                                            self.chassis_sid = None
                                            self.dev_num1 = None
                                            self.dev_num2 = None
                                            self.dev_num3 = None
                                            self.dev_num4 = None
                                            self.dev_num5 = None
                                            self.dev_num6 = None
                                            self.dev_num7 = None
                                            self.manu_test_data = None
                                            self.asset_id = None
                                            self.asset_alias = None
                                            self.base_mac_address1 = None
                                            self.mac_add_blk_size1 = None
                                            self.base_mac_address2 = None
                                            self.mac_add_blk_size2 = None
                                            self.base_mac_address3 = None
                                            self.mac_add_blk_size3 = None
                                            self.base_mac_address4 = None
                                            self.mac_add_blk_size4 = None
                                            self.pcb_serial_num = None
                                            self.power_supply_type = None
                                            self.power_consumption = None
                                            self.block_signature = None
                                            self.block_version = None
                                            self.block_length = None
                                            self.block_checksum = None
                                            self.eeprom_size = None
                                            self.block_count = None
                                            self.fru_major_type = None
                                            self.fru_minor_type = None
                                            self.oem_string = None
                                            self.product_id = None
                                            self.serial_number = None
                                            self.part_number = None
                                            self.part_revision = None
                                            self.mfg_deviation = None
                                            self.hw_version = None
                                            self.mfg_bits = None
                                            self.engineer_use = None
                                            self.snmpoid = None
                                            self.rma_code = None
                                            self.eci_alpha_number = None

                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._segment_path = lambda: "eeprom"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                        class Rma(_Entity_):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2018-04-19'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                                ])
                                                self.test_history = None
                                                self.rma_number = None
                                                self.rma_history = None
                                                self._segment_path = lambda: "rma"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo.Eeprom']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes.InvEepromInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1.Attributes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s.Tsi1']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Tsi1s']['meta_info']


                    class Attributes(_Entity_):
                        """
                        Attributes
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag>`
                        
                        	**config**\: False
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold>`
                        
                        	**config**\: False
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo))])
                            self._leafs = OrderedDict()

                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"

                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"

                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"

                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._segment_path = lambda: "attributes"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes, [], name, value)


                        class InvBasicBag(_Entity_):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if applicable to this entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: allocated_power
                            
                            	Allocated power for an entity
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_capacity
                            
                            	Power Capacity of a Power Module
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                    ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                                    ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                                    ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                                    ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                                    ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                    ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                                    ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                                    ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                                    ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                                    ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                                    ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                                    ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                                    ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                                    ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                                    ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                                    ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                                    ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                                    ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                                    ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                                    ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                                    ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                                    ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                                    ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                                    ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                                    ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                                ])
                                self.description = None
                                self.vendor_type = None
                                self.name = None
                                self.hardware_revision = None
                                self.firmware_revision = None
                                self.software_revision = None
                                self.chip_hardware_revision = None
                                self.serial_number = None
                                self.manufacturer_name = None
                                self.model_name = None
                                self.asset_id_str = None
                                self.asset_identification = None
                                self.is_field_replaceable_unit = None
                                self.manufacturer_asset_tags = None
                                self.composite_class_code = None
                                self.memory_size = None
                                self.environmental_monitor_path = None
                                self.alias = None
                                self.group_flag = None
                                self.new_deviation_number = None
                                self.physical_layer_interface_module_type = None
                                self.unrecognized_fru = None
                                self.redundancystate = None
                                self.ceport = None
                                self.xr_scoped = None
                                self.unique_id = None
                                self.allocated_power = None
                                self.power_capacity = None
                                self._segment_path = lambda: "inv-basic-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag']['meta_info']


                        class EnvSensorInfo(_Entity_):
                            """
                            Environment sensor info
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: average
                            
                            	Average sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: minimum
                            
                            	Minimum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: maximum
                            
                            	Maximum Sensor value over time interval
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: interval
                            
                            	Time Interval over which sensor value is monitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                                    ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                                    ('units', (YLeaf(YType.str, 'units'), ['str'])),
                                    ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                    ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                                    ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                                    ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                                    ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                                    ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                                    ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                    ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                                    ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                                    ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                                    ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                                ])
                                self.field_validity_bitmap = None
                                self.device_description = None
                                self.units = None
                                self.device_id = None
                                self.value = None
                                self.alarm_type = None
                                self.data_type = None
                                self.scale = None
                                self.precision = None
                                self.status = None
                                self.age_time_stamp = None
                                self.update_rate = None
                                self.average = None
                                self.minimum = None
                                self.maximum = None
                                self.interval = None
                                self._segment_path = lambda: "env-sensor-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo']['meta_info']


                        class PwgInfo(_Entity_):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                                    ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                                    ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                                    ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                                ])
                                self.power_group_redundancy_mode = None
                                self.power_group_power_units = None
                                self.power_group_available_current = None
                                self.power_group_drawn_current = None
                                self._segment_path = lambda: "pwg-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo']['meta_info']


                        class EnvSensorInfoXml(_Entity_):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            	**config**\: False
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            	**config**\: False
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold))])
                                self._leafs = OrderedDict([
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                                    ('value', (YLeaf(YType.str, 'value'), ['str'])),
                                    ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                                    ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                                ])
                                self.description = None
                                self.units = None
                                self.value = None
                                self.data_type = None
                                self.status = None
                                self.update_rate = None

                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._segment_path = lambda: "env-sensor-info-xml"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                            class Threshold(_Entity_):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                                    self._leafs = OrderedDict()

                                    self.threshold_array = YList(self)
                                    self._segment_path = lambda: "threshold"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                                class ThresholdArray(_Entity_):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\: str
                                    
                                    	**length:** 0..50
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                            ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                            ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                            ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_name = None
                                        self._segment_path = lambda: "threshold-array"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml']['meta_info']


                        class InvAssetBag(_Entity_):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                    ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                                    ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                                    ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                                    ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                                    ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                                    ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                                ])
                                self.part_number = None
                                self.manufacturer_assembly_number = None
                                self.manufacturer_assembly_revision = None
                                self.manufacturer_firmware_identifier = None
                                self.manufacturer_software_identifier = None
                                self.manufacturer_common_language_equipment_identifier = None
                                self.original_equipment_manufacturer_string = None
                                self._segment_path = lambda: "inv-asset-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag']['meta_info']


                        class Threshold(_Entity_):
                            """
                            Threshold
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi>`
                            
                            	**config**\: False
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo>`
                            
                            	**config**\: False
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo))])
                                self._leafs = OrderedDict()

                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"

                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"

                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"

                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"

                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"

                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._segment_path = lambda: "threshold"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold, [], name, value)


                            class MajorLo(_Entity_):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo']['meta_info']


                            class CriticalHi(_Entity_):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi']['meta_info']


                            class MinorHi(_Entity_):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi']['meta_info']


                            class MajorHi(_Entity_):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "major-hi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi']['meta_info']


                            class CriticalLo(_Entity_):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "critical-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo']['meta_info']


                            class MinorLo(_Entity_):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag))])
                                    self._leafs = OrderedDict()

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._segment_path = lambda: "minor-lo"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo, [], name, value)


                                class ThreshBag(_Entity_):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                            ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                            ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                            ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                            ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                        ])
                                        self.threshold_severity = None
                                        self.threshold_relation = None
                                        self.threshold_value = None
                                        self.threshold_evaluation = None
                                        self.threshold_notification_enabled = None
                                        self._segment_path = lambda: "thresh-bag"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold']['meta_info']


                        class FruInfo(_Entity_):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            	**config**\: False
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime))])
                                self._leafs = OrderedDict([
                                    ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                                    ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                                    ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                                    ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                                    ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                                    ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                                    ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                                ])
                                self.card_administrative_state = None
                                self.power_administrative_state = None
                                self.card_operational_state = None
                                self.card_monitor_state = None
                                self.card_reset_reason = None
                                self.power_current_measurement = None
                                self.power_operational_state = None

                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._segment_path = lambda: "fru-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                            class LastOperationalStateChange(_Entity_):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "last-operational-state-change"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                            class CardUpTime(_Entity_):
                                """
                                card up time
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\: int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**config**\: False
                                
                                	**units**\: nanosecond
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                        ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                                    ])
                                    self.time_in_seconds = None
                                    self.time_in_nano_seconds = None
                                    self._segment_path = lambda: "card-up-time"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo']['meta_info']


                        class InvEepromInfo(_Entity_):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            	**config**\: False
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\: str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            	**config**\: False
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: form_factor
                            
                            	Optics form factor
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connector_type
                            
                            	Connector type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: otn_application_code
                            
                            	Otn Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sonet_application_code
                            
                            	Sonet Application Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ethernet_compliance_code
                            
                            	Ethernet Compliance Code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: date_string
                            
                            	Date string in IDPROM
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom))])
                                self._leafs = OrderedDict([
                                    ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                                    ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                                    ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                                    ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                                    ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                                    ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                                    ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                                    ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                                    ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                                ])
                                self.inv_card_type = None
                                self.opaque_data = None
                                self.opaque_data_size = None
                                self.has_eeprom = None
                                self.description = None
                                self.form_factor = None
                                self.connector_type = None
                                self.otn_application_code = None
                                self.sonet_application_code = None
                                self.ethernet_compliance_code = None
                                self.date_string = None

                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._segment_path = lambda: "inv-eeprom-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                            class Eeprom(_Entity_):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                	**config**\: False
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: eci_alpha_number
                                
                                	AlphaNumeric Equipment Catalog Item (ECI) number
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2018-04-19'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma))])
                                    self._leafs = OrderedDict([
                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                        ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                        ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                        ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                        ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                        ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                        ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                        ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                        ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                        ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                        ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                        ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                        ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                        ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                        ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                        ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                        ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                        ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                        ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                        ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                        ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                        ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                        ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                        ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                        ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                        ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                        ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                        ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                        ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                        ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                        ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                        ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                        ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                        ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                        ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                        ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                        ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                        ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                        ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                        ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                        ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                        ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                        ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                        ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                        ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                        ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                        ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                        ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                        ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                        ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                        ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                        ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                        ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                        ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                        ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                        ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                                    ])
                                    self.description = None
                                    self.idprom_format_rev = None
                                    self.controller_family = None
                                    self.controller_type = None
                                    self.vid = None
                                    self.hwid = None
                                    self.pid = None
                                    self.udi_description = None
                                    self.udi_name = None
                                    self.clei = None
                                    self.eci = None
                                    self.top_assem_part_num = None
                                    self.top_assem_vid = None
                                    self.pca_num = None
                                    self.pcavid = None
                                    self.chassis_sid = None
                                    self.dev_num1 = None
                                    self.dev_num2 = None
                                    self.dev_num3 = None
                                    self.dev_num4 = None
                                    self.dev_num5 = None
                                    self.dev_num6 = None
                                    self.dev_num7 = None
                                    self.manu_test_data = None
                                    self.asset_id = None
                                    self.asset_alias = None
                                    self.base_mac_address1 = None
                                    self.mac_add_blk_size1 = None
                                    self.base_mac_address2 = None
                                    self.mac_add_blk_size2 = None
                                    self.base_mac_address3 = None
                                    self.mac_add_blk_size3 = None
                                    self.base_mac_address4 = None
                                    self.mac_add_blk_size4 = None
                                    self.pcb_serial_num = None
                                    self.power_supply_type = None
                                    self.power_consumption = None
                                    self.block_signature = None
                                    self.block_version = None
                                    self.block_length = None
                                    self.block_checksum = None
                                    self.eeprom_size = None
                                    self.block_count = None
                                    self.fru_major_type = None
                                    self.fru_minor_type = None
                                    self.oem_string = None
                                    self.product_id = None
                                    self.serial_number = None
                                    self.part_number = None
                                    self.part_revision = None
                                    self.mfg_deviation = None
                                    self.hw_version = None
                                    self.mfg_bits = None
                                    self.engineer_use = None
                                    self.snmpoid = None
                                    self.rma_code = None
                                    self.eci_alpha_number = None

                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._segment_path = lambda: "eeprom"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                                class Rma(_Entity_):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\: str
                                    
                                    	**length:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2018-04-19'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                            ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                            ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                        ])
                                        self.test_history = None
                                        self.rma_number = None
                                        self.rma_history = None
                                        self._segment_path = lambda: "rma"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                    return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot.Attributes']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Fantray.Slot']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Racks.Rack.Fantray']['meta_info']


            class Attributes(_Entity_):
                """
                Attributes
                
                .. attribute:: inv_basic_bag
                
                	Inventory Basic Bag
                	**type**\:  :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvBasicBag>`
                
                	**config**\: False
                
                .. attribute:: env_sensor_info
                
                	Environment sensor info
                	**type**\:  :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfo>`
                
                	**config**\: False
                
                .. attribute:: pwg_info
                
                	Inventory EDM PWG info
                	**type**\:  :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.PwgInfo>`
                
                	**config**\: False
                
                .. attribute:: env_sensor_info_xml
                
                	Environment sensor info XML
                	**type**\:  :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml>`
                
                	**config**\: False
                
                .. attribute:: inv_asset_bag
                
                	Inventory Asset Bag
                	**type**\:  :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvAssetBag>`
                
                	**config**\: False
                
                .. attribute:: threshold
                
                	Threshold
                	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold>`
                
                	**config**\: False
                
                .. attribute:: fru_info
                
                	Inventory EDM FRU info
                	**type**\:  :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo>`
                
                	**config**\: False
                
                .. attribute:: inv_eeprom_info
                
                	Inventory EDM EEPROM Information Bag
                	**type**\:  :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo>`
                
                	**config**\: False
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2018-04-19'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Inventory.Racks.Rack.Attributes, self).__init__()

                    self.yang_name = "attributes"
                    self.yang_parent_name = "rack"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("inv-basic-bag", ("inv_basic_bag", Inventory.Racks.Rack.Attributes.InvBasicBag)), ("env-sensor-info", ("env_sensor_info", Inventory.Racks.Rack.Attributes.EnvSensorInfo)), ("pwg-info", ("pwg_info", Inventory.Racks.Rack.Attributes.PwgInfo)), ("env-sensor-info-xml", ("env_sensor_info_xml", Inventory.Racks.Rack.Attributes.EnvSensorInfoXml)), ("inv-asset-bag", ("inv_asset_bag", Inventory.Racks.Rack.Attributes.InvAssetBag)), ("threshold", ("threshold", Inventory.Racks.Rack.Attributes.Threshold)), ("fru-info", ("fru_info", Inventory.Racks.Rack.Attributes.FruInfo)), ("inv-eeprom-info", ("inv_eeprom_info", Inventory.Racks.Rack.Attributes.InvEepromInfo))])
                    self._leafs = OrderedDict()

                    self.inv_basic_bag = Inventory.Racks.Rack.Attributes.InvBasicBag()
                    self.inv_basic_bag.parent = self
                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"

                    self.env_sensor_info = Inventory.Racks.Rack.Attributes.EnvSensorInfo()
                    self.env_sensor_info.parent = self
                    self._children_name_map["env_sensor_info"] = "env-sensor-info"

                    self.pwg_info = Inventory.Racks.Rack.Attributes.PwgInfo()
                    self.pwg_info.parent = self
                    self._children_name_map["pwg_info"] = "pwg-info"

                    self.env_sensor_info_xml = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml()
                    self.env_sensor_info_xml.parent = self
                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"

                    self.inv_asset_bag = Inventory.Racks.Rack.Attributes.InvAssetBag()
                    self.inv_asset_bag.parent = self
                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"

                    self.threshold = Inventory.Racks.Rack.Attributes.Threshold()
                    self.threshold.parent = self
                    self._children_name_map["threshold"] = "threshold"

                    self.fru_info = Inventory.Racks.Rack.Attributes.FruInfo()
                    self.fru_info.parent = self
                    self._children_name_map["fru_info"] = "fru-info"

                    self.inv_eeprom_info = Inventory.Racks.Rack.Attributes.InvEepromInfo()
                    self.inv_eeprom_info.parent = self
                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                    self._segment_path = lambda: "attributes"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Inventory.Racks.Rack.Attributes, [], name, value)


                class InvBasicBag(_Entity_):
                    """
                    Inventory Basic Bag
                    
                    .. attribute:: description
                    
                    	describes in user\-readable terms       what the entity in question does
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: vendor_type
                    
                    	maps to the vendor OID string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: name
                    
                    	name string for the entity
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hardware_revision
                    
                    	hw revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: firmware_revision
                    
                    	firmware revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: software_revision
                    
                    	software revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: chip_hardware_revision
                    
                    	chip module hw revision string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: serial_number
                    
                    	serial number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_name
                    
                    	manufacturer's name
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: model_name
                    
                    	model name
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: asset_id_str
                    
                    	asset Identification string
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: asset_identification
                    
                    	asset Identification
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: is_field_replaceable_unit
                    
                    	1 if Field Replaceable Unit 0, if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_asset_tags
                    
                    	Manufacture Asset Tags
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: composite_class_code
                    
                    	Major&minor class of the entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: memory_size
                    
                    	Size of memory associated with       the entity where applicable
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: environmental_monitor_path
                    
                    	sysdb name of sensor in the envmon EDM
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: alias
                    
                    	useful for storing an entity alias 
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: group_flag
                    
                    	indicates if this entity is group       or not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: new_deviation_number
                    
                    	integer value for New Deviation Number 0x88
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: physical_layer_interface_module_type
                    
                    	integer value for plim type if     applicable to this entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: unrecognized_fru
                    
                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: redundancystate
                    
                    	integer value for Redundancy State if applicable to this entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: ceport
                    
                    	1 if ce port found, 0 if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: xr_scoped
                    
                    	1 if xr scoped, 0 if not
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unique_id
                    
                    	Unique id for an entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: allocated_power
                    
                    	Allocated power for an entity
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_capacity
                    
                    	Power Capacity of a Power Module
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.InvBasicBag, self).__init__()

                        self.yang_name = "inv-basic-bag"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('vendor_type', (YLeaf(YType.str, 'vendor-type'), ['str'])),
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('hardware_revision', (YLeaf(YType.str, 'hardware-revision'), ['str'])),
                            ('firmware_revision', (YLeaf(YType.str, 'firmware-revision'), ['str'])),
                            ('software_revision', (YLeaf(YType.str, 'software-revision'), ['str'])),
                            ('chip_hardware_revision', (YLeaf(YType.str, 'chip-hardware-revision'), ['str'])),
                            ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                            ('manufacturer_name', (YLeaf(YType.str, 'manufacturer-name'), ['str'])),
                            ('model_name', (YLeaf(YType.str, 'model-name'), ['str'])),
                            ('asset_id_str', (YLeaf(YType.str, 'asset-id-str'), ['str'])),
                            ('asset_identification', (YLeaf(YType.int32, 'asset-identification'), ['int'])),
                            ('is_field_replaceable_unit', (YLeaf(YType.boolean, 'is-field-replaceable-unit'), ['bool'])),
                            ('manufacturer_asset_tags', (YLeaf(YType.int32, 'manufacturer-asset-tags'), ['int'])),
                            ('composite_class_code', (YLeaf(YType.int32, 'composite-class-code'), ['int'])),
                            ('memory_size', (YLeaf(YType.int32, 'memory-size'), ['int'])),
                            ('environmental_monitor_path', (YLeaf(YType.str, 'environmental-monitor-path'), ['str'])),
                            ('alias', (YLeaf(YType.str, 'alias'), ['str'])),
                            ('group_flag', (YLeaf(YType.boolean, 'group-flag'), ['bool'])),
                            ('new_deviation_number', (YLeaf(YType.int32, 'new-deviation-number'), ['int'])),
                            ('physical_layer_interface_module_type', (YLeaf(YType.int32, 'physical-layer-interface-module-type'), ['int'])),
                            ('unrecognized_fru', (YLeaf(YType.boolean, 'unrecognized-fru'), ['bool'])),
                            ('redundancystate', (YLeaf(YType.int32, 'redundancystate'), ['int'])),
                            ('ceport', (YLeaf(YType.boolean, 'ceport'), ['bool'])),
                            ('xr_scoped', (YLeaf(YType.boolean, 'xr-scoped'), ['bool'])),
                            ('unique_id', (YLeaf(YType.int32, 'unique-id'), ['int'])),
                            ('allocated_power', (YLeaf(YType.int32, 'allocated-power'), ['int'])),
                            ('power_capacity', (YLeaf(YType.int32, 'power-capacity'), ['int'])),
                        ])
                        self.description = None
                        self.vendor_type = None
                        self.name = None
                        self.hardware_revision = None
                        self.firmware_revision = None
                        self.software_revision = None
                        self.chip_hardware_revision = None
                        self.serial_number = None
                        self.manufacturer_name = None
                        self.model_name = None
                        self.asset_id_str = None
                        self.asset_identification = None
                        self.is_field_replaceable_unit = None
                        self.manufacturer_asset_tags = None
                        self.composite_class_code = None
                        self.memory_size = None
                        self.environmental_monitor_path = None
                        self.alias = None
                        self.group_flag = None
                        self.new_deviation_number = None
                        self.physical_layer_interface_module_type = None
                        self.unrecognized_fru = None
                        self.redundancystate = None
                        self.ceport = None
                        self.xr_scoped = None
                        self.unique_id = None
                        self.allocated_power = None
                        self.power_capacity = None
                        self._segment_path = lambda: "inv-basic-bag"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.InvBasicBag, ['description', 'vendor_type', 'name', 'hardware_revision', 'firmware_revision', 'software_revision', 'chip_hardware_revision', 'serial_number', 'manufacturer_name', 'model_name', 'asset_id_str', 'asset_identification', 'is_field_replaceable_unit', 'manufacturer_asset_tags', 'composite_class_code', 'memory_size', 'environmental_monitor_path', 'alias', 'group_flag', 'new_deviation_number', 'physical_layer_interface_module_type', 'unrecognized_fru', 'redundancystate', 'ceport', 'xr_scoped', 'unique_id', 'allocated_power', 'power_capacity'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.InvBasicBag']['meta_info']


                class EnvSensorInfo(_Entity_):
                    """
                    Environment sensor info
                    
                    .. attribute:: field_validity_bitmap
                    
                    	Sensor valid bitmap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: device_description
                    
                    	Device Name
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: device_id
                    
                    	Identifier for this device
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: value
                    
                    	Current reading of sensor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: alarm_type
                    
                    	Indicates threshold violation
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: data_type
                    
                    	Sensor data type enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: scale
                    
                    	Sensor scale enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: precision
                    
                    	Sensor precision range
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	Sensor operation state enums
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: age_time_stamp
                    
                    	Age of the sensor value; set to the current time if directly access the value from sensor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: average
                    
                    	Average sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: minimum
                    
                    	Minimum Sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: maximum
                    
                    	Maximum Sensor value over time interval
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: interval
                    
                    	Time Interval over which sensor value is monitored
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.EnvSensorInfo, self).__init__()

                        self.yang_name = "env-sensor-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('field_validity_bitmap', (YLeaf(YType.uint32, 'field-validity-bitmap'), ['int'])),
                            ('device_description', (YLeaf(YType.str, 'device-description'), ['str'])),
                            ('units', (YLeaf(YType.str, 'units'), ['str'])),
                            ('device_id', (YLeaf(YType.uint32, 'device-id'), ['int'])),
                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                            ('alarm_type', (YLeaf(YType.uint32, 'alarm-type'), ['int'])),
                            ('data_type', (YLeaf(YType.uint32, 'data-type'), ['int'])),
                            ('scale', (YLeaf(YType.uint32, 'scale'), ['int'])),
                            ('precision', (YLeaf(YType.uint32, 'precision'), ['int'])),
                            ('status', (YLeaf(YType.uint32, 'status'), ['int'])),
                            ('age_time_stamp', (YLeaf(YType.uint32, 'age-time-stamp'), ['int'])),
                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                            ('average', (YLeaf(YType.int32, 'average'), ['int'])),
                            ('minimum', (YLeaf(YType.int32, 'minimum'), ['int'])),
                            ('maximum', (YLeaf(YType.int32, 'maximum'), ['int'])),
                            ('interval', (YLeaf(YType.int32, 'interval'), ['int'])),
                        ])
                        self.field_validity_bitmap = None
                        self.device_description = None
                        self.units = None
                        self.device_id = None
                        self.value = None
                        self.alarm_type = None
                        self.data_type = None
                        self.scale = None
                        self.precision = None
                        self.status = None
                        self.age_time_stamp = None
                        self.update_rate = None
                        self.average = None
                        self.minimum = None
                        self.maximum = None
                        self.interval = None
                        self._segment_path = lambda: "env-sensor-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.EnvSensorInfo, ['field_validity_bitmap', 'device_description', 'units', 'device_id', 'value', 'alarm_type', 'data_type', 'scale', 'precision', 'status', 'age_time_stamp', 'update_rate', 'average', 'minimum', 'maximum', 'interval'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.EnvSensorInfo']['meta_info']


                class PwgInfo(_Entity_):
                    """
                    Inventory EDM PWG info
                    
                    .. attribute:: power_group_redundancy_mode
                    
                    	redundancy mode
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_group_power_units
                    
                    	power units
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: power_group_available_current
                    
                    	available current
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_group_drawn_current
                    
                    	drawn current
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.PwgInfo, self).__init__()

                        self.yang_name = "pwg-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('power_group_redundancy_mode', (YLeaf(YType.int32, 'power-group-redundancy-mode'), ['int'])),
                            ('power_group_power_units', (YLeaf(YType.str, 'power-group-power-units'), ['str'])),
                            ('power_group_available_current', (YLeaf(YType.int32, 'power-group-available-current'), ['int'])),
                            ('power_group_drawn_current', (YLeaf(YType.int32, 'power-group-drawn-current'), ['int'])),
                        ])
                        self.power_group_redundancy_mode = None
                        self.power_group_power_units = None
                        self.power_group_available_current = None
                        self.power_group_drawn_current = None
                        self._segment_path = lambda: "pwg-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.PwgInfo, ['power_group_redundancy_mode', 'power_group_power_units', 'power_group_available_current', 'power_group_drawn_current'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.PwgInfo']['meta_info']


                class EnvSensorInfoXml(_Entity_):
                    """
                    Environment sensor info XML
                    
                    .. attribute:: threshold
                    
                    	Threshold information
                    	**type**\:  :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold>`
                    
                    	**config**\: False
                    
                    .. attribute:: description
                    
                    	Device Name
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\:  :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                    
                    	**config**\: False
                    
                    .. attribute:: value
                    
                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                    	**type**\: str
                    
                    	**length:** 0..50
                    
                    	**config**\: False
                    
                    .. attribute:: data_type
                    
                    	Sensor data type
                    	**type**\:  :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	Sensor operation state
                    	**type**\:  :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml, self).__init__()

                        self.yang_name = "env-sensor-info-xml"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("threshold", ("threshold", Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold))])
                        self._leafs = OrderedDict([
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('units', (YLeaf(YType.enumeration, 'units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'Unit', '')])),
                            ('value', (YLeaf(YType.str, 'value'), ['str'])),
                            ('data_type', (YLeaf(YType.enumeration, 'data-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorData', '')])),
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'SensorStatus', '')])),
                            ('update_rate', (YLeaf(YType.uint32, 'update-rate'), ['int'])),
                        ])
                        self.description = None
                        self.units = None
                        self.value = None
                        self.data_type = None
                        self.status = None
                        self.update_rate = None

                        self.threshold = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold()
                        self.threshold.parent = self
                        self._children_name_map["threshold"] = "threshold"
                        self._segment_path = lambda: "env-sensor-info-xml"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml, ['description', 'units', 'value', 'data_type', 'status', 'update_rate'], name, value)


                    class Threshold(_Entity_):
                        """
                        Threshold information
                        
                        .. attribute:: threshold_array
                        
                        	Array of threshold
                        	**type**\: list of  		 :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                            self.yang_name = "threshold"
                            self.yang_parent_name = "env-sensor-info-xml"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("threshold-array", ("threshold_array", Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray))])
                            self._leafs = OrderedDict()

                            self.threshold_array = YList(self)
                            self._segment_path = lambda: "threshold"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold, [], name, value)


                        class ThresholdArray(_Entity_):
                            """
                            Array of threshold
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** \-2147483648..2147483647
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_name
                            
                            	Threshold name
                            	**type**\: str
                            
                            	**length:** 0..50
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                self.yang_name = "threshold-array"
                                self.yang_parent_name = "threshold"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.enumeration, 'threshold-severity'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdSeverity', '')])),
                                    ('threshold_relation', (YLeaf(YType.enumeration, 'threshold-relation'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'ThresholdRelation', '')])),
                                    ('threshold_value', (YLeaf(YType.int32, 'threshold-value'), ['int'])),
                                    ('threshold_name', (YLeaf(YType.str, 'threshold-name'), ['str'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_name = None
                                self._segment_path = lambda: "threshold-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.EnvSensorInfoXml']['meta_info']


                class InvAssetBag(_Entity_):
                    """
                    Inventory Asset Bag
                    
                    .. attribute:: part_number
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_assembly_number
                    
                    	Manufacture Assembly number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_assembly_revision
                    
                    	Manufacture assembly revision
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_firmware_identifier
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_software_identifier
                    
                    	
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: manufacturer_common_language_equipment_identifier
                    
                    	Common Language Equipment           Identifier number
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: original_equipment_manufacturer_string
                    
                    	String containing OEM information           if applicable
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.InvAssetBag, self).__init__()

                        self.yang_name = "inv-asset-bag"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                            ('manufacturer_assembly_number', (YLeaf(YType.str, 'manufacturer-assembly-number'), ['str'])),
                            ('manufacturer_assembly_revision', (YLeaf(YType.str, 'manufacturer-assembly-revision'), ['str'])),
                            ('manufacturer_firmware_identifier', (YLeaf(YType.str, 'manufacturer-firmware-identifier'), ['str'])),
                            ('manufacturer_software_identifier', (YLeaf(YType.str, 'manufacturer-software-identifier'), ['str'])),
                            ('manufacturer_common_language_equipment_identifier', (YLeaf(YType.str, 'manufacturer-common-language-equipment-identifier'), ['str'])),
                            ('original_equipment_manufacturer_string', (YLeaf(YType.str, 'original-equipment-manufacturer-string'), ['str'])),
                        ])
                        self.part_number = None
                        self.manufacturer_assembly_number = None
                        self.manufacturer_assembly_revision = None
                        self.manufacturer_firmware_identifier = None
                        self.manufacturer_software_identifier = None
                        self.manufacturer_common_language_equipment_identifier = None
                        self.original_equipment_manufacturer_string = None
                        self._segment_path = lambda: "inv-asset-bag"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.InvAssetBag, ['part_number', 'manufacturer_assembly_number', 'manufacturer_assembly_revision', 'manufacturer_firmware_identifier', 'manufacturer_software_identifier', 'manufacturer_common_language_equipment_identifier', 'original_equipment_manufacturer_string'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.InvAssetBag']['meta_info']


                class Threshold(_Entity_):
                    """
                    Threshold
                    
                    .. attribute:: major_lo
                    
                    	Major Low
                    	**type**\:  :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorLo>`
                    
                    	**config**\: False
                    
                    .. attribute:: critical_hi
                    
                    	Critical High
                    	**type**\:  :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: minor_hi
                    
                    	Minor High
                    	**type**\:  :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: major_hi
                    
                    	Major High
                    	**type**\:  :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorHi>`
                    
                    	**config**\: False
                    
                    .. attribute:: critical_lo
                    
                    	Critical Low
                    	**type**\:  :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalLo>`
                    
                    	**config**\: False
                    
                    .. attribute:: minor_lo
                    
                    	Minor Low
                    	**type**\:  :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorLo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.Threshold, self).__init__()

                        self.yang_name = "threshold"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("major-lo", ("major_lo", Inventory.Racks.Rack.Attributes.Threshold.MajorLo)), ("critical-hi", ("critical_hi", Inventory.Racks.Rack.Attributes.Threshold.CriticalHi)), ("minor-hi", ("minor_hi", Inventory.Racks.Rack.Attributes.Threshold.MinorHi)), ("major-hi", ("major_hi", Inventory.Racks.Rack.Attributes.Threshold.MajorHi)), ("critical-lo", ("critical_lo", Inventory.Racks.Rack.Attributes.Threshold.CriticalLo)), ("minor-lo", ("minor_lo", Inventory.Racks.Rack.Attributes.Threshold.MinorLo))])
                        self._leafs = OrderedDict()

                        self.major_lo = Inventory.Racks.Rack.Attributes.Threshold.MajorLo()
                        self.major_lo.parent = self
                        self._children_name_map["major_lo"] = "major-lo"

                        self.critical_hi = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi()
                        self.critical_hi.parent = self
                        self._children_name_map["critical_hi"] = "critical-hi"

                        self.minor_hi = Inventory.Racks.Rack.Attributes.Threshold.MinorHi()
                        self.minor_hi.parent = self
                        self._children_name_map["minor_hi"] = "minor-hi"

                        self.major_hi = Inventory.Racks.Rack.Attributes.Threshold.MajorHi()
                        self.major_hi.parent = self
                        self._children_name_map["major_hi"] = "major-hi"

                        self.critical_lo = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo()
                        self.critical_lo.parent = self
                        self._children_name_map["critical_lo"] = "critical-lo"

                        self.minor_lo = Inventory.Racks.Rack.Attributes.Threshold.MinorLo()
                        self.minor_lo.parent = self
                        self._children_name_map["minor_lo"] = "minor-lo"
                        self._segment_path = lambda: "threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold, [], name, value)


                    class MajorLo(_Entity_):
                        """
                        Major Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo, self).__init__()

                            self.yang_name = "major-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "major-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MajorLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MajorLo']['meta_info']


                    class CriticalHi(_Entity_):
                        """
                        Critical High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi, self).__init__()

                            self.yang_name = "critical-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "critical-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.CriticalHi']['meta_info']


                    class MinorHi(_Entity_):
                        """
                        Minor High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi, self).__init__()

                            self.yang_name = "minor-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "minor-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MinorHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MinorHi']['meta_info']


                    class MajorHi(_Entity_):
                        """
                        Major High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi, self).__init__()

                            self.yang_name = "major-hi"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "major-hi"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MajorHi, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-hi"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MajorHi']['meta_info']


                    class CriticalLo(_Entity_):
                        """
                        Critical Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo, self).__init__()

                            self.yang_name = "critical-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "critical-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.CriticalLo']['meta_info']


                    class MinorLo(_Entity_):
                        """
                        Minor Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:  :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo, self).__init__()

                            self.yang_name = "minor-lo"
                            self.yang_parent_name = "threshold"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("thresh-bag", ("thresh_bag", Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag))])
                            self._leafs = OrderedDict()

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._segment_path = lambda: "minor-lo"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MinorLo, [], name, value)


                        class ThreshBag(_Entity_):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-lo"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('threshold_severity', (YLeaf(YType.uint32, 'threshold-severity'), ['int'])),
                                    ('threshold_relation', (YLeaf(YType.uint32, 'threshold-relation'), ['int'])),
                                    ('threshold_value', (YLeaf(YType.uint32, 'threshold-value'), ['int'])),
                                    ('threshold_evaluation', (YLeaf(YType.boolean, 'threshold-evaluation'), ['bool'])),
                                    ('threshold_notification_enabled', (YLeaf(YType.boolean, 'threshold-notification-enabled'), ['bool'])),
                                ])
                                self.threshold_severity = None
                                self.threshold_relation = None
                                self.threshold_value = None
                                self.threshold_evaluation = None
                                self.threshold_notification_enabled = None
                                self._segment_path = lambda: "thresh-bag"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag, ['threshold_severity', 'threshold_relation', 'threshold_value', 'threshold_evaluation', 'threshold_notification_enabled'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold.MinorLo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.Threshold']['meta_info']


                class FruInfo(_Entity_):
                    """
                    Inventory EDM FRU info
                    
                    .. attribute:: last_operational_state_change
                    
                    	last card oper change state
                    	**type**\:  :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange>`
                    
                    	**config**\: False
                    
                    .. attribute:: card_up_time
                    
                    	card up time
                    	**type**\:  :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime>`
                    
                    	**config**\: False
                    
                    .. attribute:: card_administrative_state
                    
                    	card admin state\: shutdown or not
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_administrative_state
                    
                    	power admin state\: up or down
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_operational_state
                    
                    	card operation state
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_monitor_state
                    
                    	card is monitored by a manager or left unmonitored
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: card_reset_reason
                    
                    	card reset reason enum
                    	**type**\:  :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: power_current_measurement
                    
                    	power current\: not implemented
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: power_operational_state
                    
                    	Power operation state
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.FruInfo, self).__init__()

                        self.yang_name = "fru-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("last-operational-state-change", ("last_operational_state_change", Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange)), ("card-up-time", ("card_up_time", Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime))])
                        self._leafs = OrderedDict([
                            ('card_administrative_state', (YLeaf(YType.int32, 'card-administrative-state'), ['int'])),
                            ('power_administrative_state', (YLeaf(YType.int32, 'power-administrative-state'), ['int'])),
                            ('card_operational_state', (YLeaf(YType.int32, 'card-operational-state'), ['int'])),
                            ('card_monitor_state', (YLeaf(YType.int32, 'card-monitor-state'), ['int'])),
                            ('card_reset_reason', (YLeaf(YType.enumeration, 'card-reset-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper', 'CardResetReason', '')])),
                            ('power_current_measurement', (YLeaf(YType.int32, 'power-current-measurement'), ['int'])),
                            ('power_operational_state', (YLeaf(YType.int32, 'power-operational-state'), ['int'])),
                        ])
                        self.card_administrative_state = None
                        self.power_administrative_state = None
                        self.card_operational_state = None
                        self.card_monitor_state = None
                        self.card_reset_reason = None
                        self.power_current_measurement = None
                        self.power_operational_state = None

                        self.last_operational_state_change = Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange()
                        self.last_operational_state_change.parent = self
                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"

                        self.card_up_time = Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime()
                        self.card_up_time.parent = self
                        self._children_name_map["card_up_time"] = "card-up-time"
                        self._segment_path = lambda: "fru-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.FruInfo, ['card_administrative_state', 'power_administrative_state', 'card_operational_state', 'card_monitor_state', 'card_reset_reason', 'power_current_measurement', 'power_operational_state'], name, value)


                    class LastOperationalStateChange(_Entity_):
                        """
                        last card oper change state
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                            self.yang_name = "last-operational-state-change"
                            self.yang_parent_name = "fru-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                            ])
                            self.time_in_seconds = None
                            self.time_in_nano_seconds = None
                            self._segment_path = lambda: "last-operational-state-change"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange']['meta_info']


                    class CardUpTime(_Entity_):
                        """
                        card up time
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\: int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime, self).__init__()

                            self.yang_name = "card-up-time"
                            self.yang_parent_name = "fru-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('time_in_seconds', (YLeaf(YType.int32, 'time-in-seconds'), ['int'])),
                                ('time_in_nano_seconds', (YLeaf(YType.int32, 'time-in-nano-seconds'), ['int'])),
                            ])
                            self.time_in_seconds = None
                            self.time_in_nano_seconds = None
                            self._segment_path = lambda: "card-up-time"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime, ['time_in_seconds', 'time_in_nano_seconds'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.FruInfo']['meta_info']


                class InvEepromInfo(_Entity_):
                    """
                    Inventory EDM EEPROM Information Bag
                    
                    .. attribute:: eeprom
                    
                    	EEPROM data not from hex data
                    	**type**\:  :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom>`
                    
                    	**config**\: False
                    
                    .. attribute:: inv_card_type
                    
                    	Inventory card type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: opaque_data
                    
                    	EEPROM hex data
                    	**type**\: str
                    
                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                    
                    	**config**\: False
                    
                    .. attribute:: opaque_data_size
                    
                    	size of the EEPROM hex data
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_eeprom
                    
                    	use eeprom instead of opaque data
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: description
                    
                    	A textual description of physical entity
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: form_factor
                    
                    	Optics form factor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: connector_type
                    
                    	Connector type
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: otn_application_code
                    
                    	Otn Application Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sonet_application_code
                    
                    	Sonet Application Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ethernet_compliance_code
                    
                    	Ethernet Compliance Code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: date_string
                    
                    	Date string in IDPROM
                    	**type**\: str
                    
                    	**length:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2018-04-19'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Inventory.Racks.Rack.Attributes.InvEepromInfo, self).__init__()

                        self.yang_name = "inv-eeprom-info"
                        self.yang_parent_name = "attributes"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("eeprom", ("eeprom", Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom))])
                        self._leafs = OrderedDict([
                            ('inv_card_type', (YLeaf(YType.uint8, 'inv-card-type'), ['int'])),
                            ('opaque_data', (YLeaf(YType.str, 'opaque-data'), ['str'])),
                            ('opaque_data_size', (YLeaf(YType.uint32, 'opaque-data-size'), ['int'])),
                            ('has_eeprom', (YLeaf(YType.uint32, 'has-eeprom'), ['int'])),
                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                            ('form_factor', (YLeaf(YType.uint32, 'form-factor'), ['int'])),
                            ('connector_type', (YLeaf(YType.uint32, 'connector-type'), ['int'])),
                            ('otn_application_code', (YLeaf(YType.uint32, 'otn-application-code'), ['int'])),
                            ('sonet_application_code', (YLeaf(YType.uint32, 'sonet-application-code'), ['int'])),
                            ('ethernet_compliance_code', (YLeaf(YType.uint32, 'ethernet-compliance-code'), ['int'])),
                            ('date_string', (YLeaf(YType.str, 'date-string'), ['str'])),
                        ])
                        self.inv_card_type = None
                        self.opaque_data = None
                        self.opaque_data_size = None
                        self.has_eeprom = None
                        self.description = None
                        self.form_factor = None
                        self.connector_type = None
                        self.otn_application_code = None
                        self.sonet_application_code = None
                        self.ethernet_compliance_code = None
                        self.date_string = None

                        self.eeprom = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom()
                        self.eeprom.parent = self
                        self._children_name_map["eeprom"] = "eeprom"
                        self._segment_path = lambda: "inv-eeprom-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Inventory.Racks.Rack.Attributes.InvEepromInfo, ['inv_card_type', 'opaque_data', 'opaque_data_size', 'has_eeprom', 'description', 'form_factor', 'connector_type', 'otn_application_code', 'sonet_application_code', 'ethernet_compliance_code', 'date_string'], name, value)


                    class Eeprom(_Entity_):
                        """
                        EEPROM data not from hex data
                        
                        .. attribute:: rma
                        
                        	RMA Data
                        	**type**\:  :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma>`
                        
                        	**config**\: False
                        
                        .. attribute:: description
                        
                        	A textual description of physical entity
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: idprom_format_rev
                        
                        	IDPROM Format Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: controller_family
                        
                        	Controller family
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: controller_type
                        
                        	Controller type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: vid
                        
                        	Version ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: hwid
                        
                        	Hardware Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pid
                        
                        	Product ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: udi_description
                        
                        	UDI description
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: udi_name
                        
                        	UDI name
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: clei
                        
                        	Common Language Equipment Identifier (CLEI) code
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eci
                        
                        	Equipment Catalog Item (ECI) number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: top_assem_part_num
                        
                        	Top assembly part number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: top_assem_vid
                        
                        	Top assembly revision number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pca_num
                        
                        	PCA number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pcavid
                        
                        	PCA revision ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: chassis_sid
                        
                        	Chassis serial number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num1
                        
                        	Deviation Number # 1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num2
                        
                        	Deviation Number # 2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num3
                        
                        	Deviation Number # 3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num4
                        
                        	Deviation Number # 4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num5
                        
                        	Deviation Number # 5
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num6
                        
                        	Deviation Number # 6
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: dev_num7
                        
                        	Deviation Number # 7
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: manu_test_data
                        
                        	Manufacturing Test Data
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: asset_id
                        
                        	Asset ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: asset_alias
                        
                        	Asset Alias
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address1
                        
                        	Base Mac Address #1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size1
                        
                        	Mac Address Block Size #1
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address2
                        
                        	Base Mac Address #2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size2
                        
                        	Mac Address Block Size #2
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address3
                        
                        	Base Mac Address #3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size3
                        
                        	Mac Address Block Size #3
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: base_mac_address4
                        
                        	Base Mac Address #4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mac_add_blk_size4
                        
                        	Mac Address Block Size #4
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: pcb_serial_num
                        
                        	PCB Serial Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: power_supply_type
                        
                        	Power Supply Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: power_consumption
                        
                        	Power Consumption
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_signature
                        
                        	Block Signature
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_version
                        
                        	Block Version
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_length
                        
                        	Block Length
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_checksum
                        
                        	Block Checksum
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eeprom_size
                        
                        	EEPROM Size
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: block_count
                        
                        	Block Count
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: fru_major_type
                        
                        	FRU Major Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: fru_minor_type
                        
                        	FRU Minor Type
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: oem_string
                        
                        	OEM String
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: product_id
                        
                        	Product ID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: serial_number
                        
                        	Serial Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: part_number
                        
                        	Part Number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: part_revision
                        
                        	Part Revision
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mfg_deviation
                        
                        	MFG Deviation
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: hw_version
                        
                        	Hardware Version
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: mfg_bits
                        
                        	MFG Bits
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: engineer_use
                        
                        	Engineer Use
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: snmpoid
                        
                        	SNMP OID
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: rma_code
                        
                        	RMA Code
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: eci_alpha_number
                        
                        	AlphaNumeric Equipment Catalog Item (ECI) number
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2018-04-19'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom, self).__init__()

                            self.yang_name = "eeprom"
                            self.yang_parent_name = "inv-eeprom-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rma", ("rma", Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma))])
                            self._leafs = OrderedDict([
                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                ('idprom_format_rev', (YLeaf(YType.str, 'idprom-format-rev'), ['str'])),
                                ('controller_family', (YLeaf(YType.str, 'controller-family'), ['str'])),
                                ('controller_type', (YLeaf(YType.str, 'controller-type'), ['str'])),
                                ('vid', (YLeaf(YType.str, 'vid'), ['str'])),
                                ('hwid', (YLeaf(YType.str, 'hwid'), ['str'])),
                                ('pid', (YLeaf(YType.str, 'pid'), ['str'])),
                                ('udi_description', (YLeaf(YType.str, 'udi-description'), ['str'])),
                                ('udi_name', (YLeaf(YType.str, 'udi-name'), ['str'])),
                                ('clei', (YLeaf(YType.str, 'clei'), ['str'])),
                                ('eci', (YLeaf(YType.str, 'eci'), ['str'])),
                                ('top_assem_part_num', (YLeaf(YType.str, 'top-assem-part-num'), ['str'])),
                                ('top_assem_vid', (YLeaf(YType.str, 'top-assem-vid'), ['str'])),
                                ('pca_num', (YLeaf(YType.str, 'pca-num'), ['str'])),
                                ('pcavid', (YLeaf(YType.str, 'pcavid'), ['str'])),
                                ('chassis_sid', (YLeaf(YType.str, 'chassis-sid'), ['str'])),
                                ('dev_num1', (YLeaf(YType.str, 'dev-num1'), ['str'])),
                                ('dev_num2', (YLeaf(YType.str, 'dev-num2'), ['str'])),
                                ('dev_num3', (YLeaf(YType.str, 'dev-num3'), ['str'])),
                                ('dev_num4', (YLeaf(YType.str, 'dev-num4'), ['str'])),
                                ('dev_num5', (YLeaf(YType.str, 'dev-num5'), ['str'])),
                                ('dev_num6', (YLeaf(YType.str, 'dev-num6'), ['str'])),
                                ('dev_num7', (YLeaf(YType.str, 'dev-num7'), ['str'])),
                                ('manu_test_data', (YLeaf(YType.str, 'manu-test-data'), ['str'])),
                                ('asset_id', (YLeaf(YType.str, 'asset-id'), ['str'])),
                                ('asset_alias', (YLeaf(YType.str, 'asset-alias'), ['str'])),
                                ('base_mac_address1', (YLeaf(YType.str, 'base-mac-address1'), ['str'])),
                                ('mac_add_blk_size1', (YLeaf(YType.str, 'mac-add-blk-size1'), ['str'])),
                                ('base_mac_address2', (YLeaf(YType.str, 'base-mac-address2'), ['str'])),
                                ('mac_add_blk_size2', (YLeaf(YType.str, 'mac-add-blk-size2'), ['str'])),
                                ('base_mac_address3', (YLeaf(YType.str, 'base-mac-address3'), ['str'])),
                                ('mac_add_blk_size3', (YLeaf(YType.str, 'mac-add-blk-size3'), ['str'])),
                                ('base_mac_address4', (YLeaf(YType.str, 'base-mac-address4'), ['str'])),
                                ('mac_add_blk_size4', (YLeaf(YType.str, 'mac-add-blk-size4'), ['str'])),
                                ('pcb_serial_num', (YLeaf(YType.str, 'pcb-serial-num'), ['str'])),
                                ('power_supply_type', (YLeaf(YType.str, 'power-supply-type'), ['str'])),
                                ('power_consumption', (YLeaf(YType.str, 'power-consumption'), ['str'])),
                                ('block_signature', (YLeaf(YType.str, 'block-signature'), ['str'])),
                                ('block_version', (YLeaf(YType.str, 'block-version'), ['str'])),
                                ('block_length', (YLeaf(YType.str, 'block-length'), ['str'])),
                                ('block_checksum', (YLeaf(YType.str, 'block-checksum'), ['str'])),
                                ('eeprom_size', (YLeaf(YType.str, 'eeprom-size'), ['str'])),
                                ('block_count', (YLeaf(YType.str, 'block-count'), ['str'])),
                                ('fru_major_type', (YLeaf(YType.str, 'fru-major-type'), ['str'])),
                                ('fru_minor_type', (YLeaf(YType.str, 'fru-minor-type'), ['str'])),
                                ('oem_string', (YLeaf(YType.str, 'oem-string'), ['str'])),
                                ('product_id', (YLeaf(YType.str, 'product-id'), ['str'])),
                                ('serial_number', (YLeaf(YType.str, 'serial-number'), ['str'])),
                                ('part_number', (YLeaf(YType.str, 'part-number'), ['str'])),
                                ('part_revision', (YLeaf(YType.str, 'part-revision'), ['str'])),
                                ('mfg_deviation', (YLeaf(YType.str, 'mfg-deviation'), ['str'])),
                                ('hw_version', (YLeaf(YType.str, 'hw-version'), ['str'])),
                                ('mfg_bits', (YLeaf(YType.str, 'mfg-bits'), ['str'])),
                                ('engineer_use', (YLeaf(YType.str, 'engineer-use'), ['str'])),
                                ('snmpoid', (YLeaf(YType.str, 'snmpoid'), ['str'])),
                                ('rma_code', (YLeaf(YType.str, 'rma-code'), ['str'])),
                                ('eci_alpha_number', (YLeaf(YType.str, 'eci-alpha-number'), ['str'])),
                            ])
                            self.description = None
                            self.idprom_format_rev = None
                            self.controller_family = None
                            self.controller_type = None
                            self.vid = None
                            self.hwid = None
                            self.pid = None
                            self.udi_description = None
                            self.udi_name = None
                            self.clei = None
                            self.eci = None
                            self.top_assem_part_num = None
                            self.top_assem_vid = None
                            self.pca_num = None
                            self.pcavid = None
                            self.chassis_sid = None
                            self.dev_num1 = None
                            self.dev_num2 = None
                            self.dev_num3 = None
                            self.dev_num4 = None
                            self.dev_num5 = None
                            self.dev_num6 = None
                            self.dev_num7 = None
                            self.manu_test_data = None
                            self.asset_id = None
                            self.asset_alias = None
                            self.base_mac_address1 = None
                            self.mac_add_blk_size1 = None
                            self.base_mac_address2 = None
                            self.mac_add_blk_size2 = None
                            self.base_mac_address3 = None
                            self.mac_add_blk_size3 = None
                            self.base_mac_address4 = None
                            self.mac_add_blk_size4 = None
                            self.pcb_serial_num = None
                            self.power_supply_type = None
                            self.power_consumption = None
                            self.block_signature = None
                            self.block_version = None
                            self.block_length = None
                            self.block_checksum = None
                            self.eeprom_size = None
                            self.block_count = None
                            self.fru_major_type = None
                            self.fru_minor_type = None
                            self.oem_string = None
                            self.product_id = None
                            self.serial_number = None
                            self.part_number = None
                            self.part_revision = None
                            self.mfg_deviation = None
                            self.hw_version = None
                            self.mfg_bits = None
                            self.engineer_use = None
                            self.snmpoid = None
                            self.rma_code = None
                            self.eci_alpha_number = None

                            self.rma = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma()
                            self.rma.parent = self
                            self._children_name_map["rma"] = "rma"
                            self._segment_path = lambda: "eeprom"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom, ['description', 'idprom_format_rev', 'controller_family', 'controller_type', 'vid', 'hwid', 'pid', 'udi_description', 'udi_name', 'clei', 'eci', 'top_assem_part_num', 'top_assem_vid', 'pca_num', 'pcavid', 'chassis_sid', 'dev_num1', 'dev_num2', 'dev_num3', 'dev_num4', 'dev_num5', 'dev_num6', 'dev_num7', 'manu_test_data', 'asset_id', 'asset_alias', 'base_mac_address1', 'mac_add_blk_size1', 'base_mac_address2', 'mac_add_blk_size2', 'base_mac_address3', 'mac_add_blk_size3', 'base_mac_address4', 'mac_add_blk_size4', 'pcb_serial_num', 'power_supply_type', 'power_consumption', 'block_signature', 'block_version', 'block_length', 'block_checksum', 'eeprom_size', 'block_count', 'fru_major_type', 'fru_minor_type', 'oem_string', 'product_id', 'serial_number', 'part_number', 'part_revision', 'mfg_deviation', 'hw_version', 'mfg_bits', 'engineer_use', 'snmpoid', 'rma_code', 'eci_alpha_number'], name, value)


                        class Rma(_Entity_):
                            """
                            RMA Data
                            
                            .. attribute:: test_history
                            
                            	Test history
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: rma_number
                            
                            	RMA tracking number format is N\-N\-N
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: rma_history
                            
                            	RMA history
                            	**type**\: str
                            
                            	**length:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2018-04-19'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                self.yang_name = "rma"
                                self.yang_parent_name = "eeprom"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('test_history', (YLeaf(YType.str, 'test-history'), ['str'])),
                                    ('rma_number', (YLeaf(YType.str, 'rma-number'), ['str'])),
                                    ('rma_history', (YLeaf(YType.str, 'rma-history'), ['str'])),
                                ])
                                self.test_history = None
                                self.rma_number = None
                                self.rma_history = None
                                self._segment_path = lambda: "rma"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma, ['test_history', 'rma_number', 'rma_history'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                                return meta._meta_table['Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                            return meta._meta_table['Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                        return meta._meta_table['Inventory.Racks.Rack.Attributes.InvEepromInfo']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                    return meta._meta_table['Inventory.Racks.Rack.Attributes']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
                return meta._meta_table['Inventory.Racks.Rack']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
            return meta._meta_table['Inventory.Racks']['meta_info']

    def clone_ptr(self):
        self._top_entity = Inventory()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_invmgr_oper as meta
        return meta._meta_table['Inventory']['meta_info']


